// DialogMenu.cpp : implementation file
//

#include "stdafx.h"
#include "formcreator.h"
#include "DialogMenu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMenuDialog dialog


CMenuDialog::CMenuDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CMenuDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMenuDialog)
	m_strName = _T("");
	//}}AFX_DATA_INIT
}


void CMenuDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMenuDialog)
	DDX_Control(pDX, IDC_TREE_MENU, m_treeMenu);
	DDX_Text(pDX, IDC_EDIT_MENUNAME, m_strName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMenuDialog, CDialog)
	//{{AFX_MSG_MAP(CMenuDialog)
	ON_BN_CLICKED(IDC_BUTTON_ADDMENU, OnButtonAddmenu)
	ON_NOTIFY(TVN_KEYDOWN, IDC_TREE_MENU, OnKeydownTreeMenu)
	ON_BN_CLICKED(IDC_BUTTON_ADDSUBMENU, OnButtonAddsubmenu)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_MENU, OnSelchangedTreeMenu)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMenuDialog message handlers

void CMenuDialog::OnButtonAddmenu() 
{
	UpdateData(TRUE);

	HTREEITEM curItem;
	HTREEITEM parItem;

	if (m_strName != "")
	{
	
		curItem = m_treeMenu.GetSelectedItem();
		if (curItem)
		{
			parItem = m_treeMenu.GetParentItem(curItem);
			m_treeMenu.InsertItem(m_strName, 0, 0, parItem, curItem);
			m_treeMenu.Expand(parItem, TVE_EXPAND);
		}
		else
			m_treeMenu.InsertItem(m_strName, 0, 0, TVI_ROOT, TVI_LAST);

	}
}

void CMenuDialog::OnButtonAddsubmenu() 
{
	UpdateData(TRUE);

	HTREEITEM curItem;

	if (m_strName != "")
	{
	
		curItem = m_treeMenu.GetSelectedItem();
		if (curItem)
		{	
			m_treeMenu.InsertItem(m_strName, 0, 0, curItem, TVI_LAST);
			m_treeMenu.Expand(curItem, TVE_EXPAND);
		}
		else
			m_treeMenu.InsertItem(m_strName, 0, 0, TVI_ROOT, TVI_LAST);

	}
	
}

BOOL CMenuDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMenuDialog::OnKeydownTreeMenu(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_KEYDOWN* pTVKeyDown = (TV_KEYDOWN*)pNMHDR;

	//HTREEITEM item = m_treeMenu.GetSelectedItem();
	//m_treeMenu.EditLabel(item);
	*pResult = 0;
}

void CMenuDialog::OnOK() 
{
	if (GetAsyncKeyState(VK_RETURN))
		return;
	
	CDialog::OnOK();
}


void CMenuDialog::OnSelchangedTreeMenu(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	m_strName = m_treeMenu.GetItemText(pNMTreeView->itemNew.hItem);
	UpdateData(FALSE);
	*pResult = 0;
}
