// DialogTab.cpp : implementation file
//

#include "stdafx.h"
#include "formcreator.h"
#include "DialogTab.h"
#include "Globals.h"
#include "FormCreatorView.h"
#include <iostream>
using namespace std;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabDialog dialog


CTabDialog::CTabDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTabDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTabDialog)
	m_strSheetName = _T("");
	//}}AFX_DATA_INIT
}


void CTabDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabDialog)
	DDX_Control(pDX, IDC_LIST_SHEETS, m_lbSheets);
	DDX_Text(pDX, IDC_EDIT_SHEETNAME, m_strSheetName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabDialog, CDialog)
	//{{AFX_MSG_MAP(CTabDialog)
	ON_EN_CHANGE(IDC_EDIT_SHEETNAME, OnChangeEditSheetname)
	ON_BN_CLICKED(IDC_BUTTON_ADDSHEET, OnButtonAddsheet)
	ON_BN_CLICKED(IDC_BUTTON_DELSHEET, OnButtonDelsheet)
	ON_BN_CLICKED(IDC_BUTTON_ADDNEWSHEET, OnButtonAddnewsheet)
	ON_LBN_SELCHANGE(IDC_LIST_SHEETS, OnSelchangeListSheets)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabDialog message handlers

BOOL CTabDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	int nPages = m_pTabCtrl->GetItemCount();

	char strItemName[256];
	TCITEM item;
	item.mask = TCIF_TEXT;
	item.cchTextMax = 256;
	item.pszText = strItemName;
	
	if (nPages > 0)
	{
		for (int i = 0; i < nPages; i++)
		{
			memset(strItemName, 0, 256);
			m_pTabCtrl->GetItem(i, &item);
			m_lbSheets.AddString(strItemName);
		}
		
		
		m_lbSheets.SetCurSel(m_pTabCtrl->GetCurSel());
		OnSelchangeListSheets();
	}
	return TRUE;  

}

void CTabDialog::OnChangeEditSheetname() 
{
	int nCurSel = m_lbSheets.GetCurSel();

	TCITEM item;

	if (nCurSel >= 0)
	{
		m_lbSheets.DeleteString(nCurSel);
		UpdateData(TRUE);
		m_lbSheets.InsertString(nCurSel, m_strSheetName);
		m_lbSheets.SetCurSel(nCurSel);

		memset(&item, 0, sizeof(TCITEM));	
		item.mask = TCIF_TEXT;
		item.cchTextMax = m_strSheetName.GetLength();
		item.pszText = (char *) m_strSheetName.GetBuffer(256);

		m_pTabCtrl->SetItem(nCurSel, &item);	
		m_pTabCtrl->Invalidate(FALSE);

	}
	
}

void CTabDialog::OnButtonAddsheet() 
{
	int nPages = m_pTabCtrl->GetItemCount() + 1;
	UpdateData(TRUE);
	if (m_strSheetName != "")
	{
		int nCurSel = m_lbSheets.AddString(m_strSheetName);
		m_pTabCtrl->InsertItem(nPages, m_strSheetName, 0);
		m_lbSheets.SetCurSel(nCurSel);
		m_pTabCtrl->Invalidate(FALSE);
	}
	
}

void CTabDialog::OnButtonDelsheet() 
{
	int nSheets = m_pTabCtrl->GetItemCount();
	
	if (nSheets == 0)
		return;
	
	int nCurSel = m_lbSheets.GetCurSel();
	
	m_pTabCtrl->DeleteItem(nCurSel);
	pView->RemoveObjectsFromSheet(&pView->m_pTObject->m_objects, nCurSel);
	pView->ChangeSheetNumbers(&pView->m_pTObject->m_objects, nCurSel);

	if (nSheets > 1)
	{
		m_lbSheets.DeleteString(nCurSel);
		m_strSheetName = "";
	}
	else
	{
		m_strSheetName = "Zakadka 1";
		m_pTabCtrl->InsertItem(0, m_strSheetName);
		m_lbSheets.DeleteString(0);
		m_lbSheets.InsertString(0, m_strSheetName);
	}

	UpdateData(FALSE);

	if (nCurSel < 1)
		nCurSel = 1;

	m_lbSheets.SetCurSel(nCurSel - 1);
//	m_pTabCtrl->SetCurSel(nCurSel - 1);
//	pView->m_pTObject->m_nCurPage = nCurSel - 1;

	OnSelchangeListSheets();

	
}

void CTabDialog::OnButtonAddnewsheet() 
{
	int nPages = m_pTabCtrl->GetItemCount() + 1;

	CString strName;
	strName.Format("Zakadka %d", nPages);
	int nCurSel = m_lbSheets.AddString(strName);
	m_pTabCtrl->InsertItem(nPages, strName, 0);
	m_lbSheets.SetCurSel(nCurSel);
	OnSelchangeListSheets();
	m_pTabCtrl->Invalidate(FALSE);
}

void CTabDialog::OnSelchangeListSheets() 
{
	int nCurSel = m_lbSheets.GetCurSel();
	if (nCurSel != LB_ERR)
	{
		m_lbSheets.GetText(nCurSel, m_strSheetName);
		UpdateData(FALSE);	

		m_pTabCtrl->SetCurSel(nCurSel);
		pView->m_pTObject->m_nCurPage = nCurSel;

		pView->ShowObjects(nCurSel, &pView->m_pTObject->m_objects);
		pView->Invalidate(FALSE);
	}
}

