#include "stdafx.h"
#include "FormCreator.h"
#include "Globals.h"

#include "GridCtrl/GridCtrl.h"
#include "Console.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include "MultiRectTracker.h"
#include "ToolbarControls.h"

#include "DialogGrid.h"
#include "DialogTemplate.h"
#include "ColumnsDialog.h"

#include "TObject.h"
#include "PanelControl.h"

#include "TransparentWindow.h"
#include "math.h"
#include <afxrich.h>

#include <iostream>
using namespace std;

void CFormCreatorView::HTML_Save(CFile & file)
{
	CString strTmp;

	strTmp = "<html>\r\n<head>\r\n  <title></title>\r\n  <meta http-equiv=\"content-type\"\r\n content=\"text/html; charset=ISO-8859-2\">\r\n</head>\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "<body>\r\n<table cellpadding=\"2\" cellspacing=\"2\" border=\"1\" width=\"100%\">\r\n  <tbody>\r\n    <tr>\r\n      <td valign=\"top\" align=\"center\"><b>Numer</b><br>\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "      </td>\r\n      <td valign=\"top\" align=\"center\"><b>Nazwa obiektu</b><br>\r\n      </td>\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "      <td valign=\"top\" align=\"center\">\r\n      <blockquote>\r\n        <blockquote>\r\n          <blockquote><b>Opis</b><br>\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "          </blockquote>\r\n        </blockquote>\r\n      </blockquote>\r\n      </td>\r\n    </tr>\r\n";
	file.Write(strTmp, strTmp.GetLength());

	for (int i = 1; i < m_pGrdInfObjList->GetRowCount(); i++)
	{
		strTmp = "    <tr>\r\n";
		file.Write(strTmp, strTmp.GetLength());
    
		for (int j = 0; j < m_pGrdInfObjList->GetColumnCount(); j++)
		{	
			strTmp = "      <td valign=\"top\">";
			file.Write(strTmp, strTmp.GetLength());
			
			CString strItem;

			strItem = m_pGrdInfObjList->GetItemText(i, j);
			file.Write(strItem, strItem.GetLength());
			strTmp = "<br>\r\n      </td>\r\n";
			file.Write(strTmp, strTmp.GetLength());
		}

		strTmp = "    </tr>\r\n";
		file.Write(strTmp, strTmp.GetLength());
      
	}

	strTmp ="  </tbody>\r\n</table>\r\n<br>\r\n</body>\r\n</html>\r\n";

	file.Write(strTmp, strTmp.GetLength());
}

void CFormCreatorView::OnFileSavehtml() 
{
	CString strDocName;
	this->GetParentFrame()->GetWindowText(strDocName);
	CFileDialog dlgFile(false, "html", strDocName, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "HTML (*.html)|*.html|");
	
	int iRes = dlgFile.DoModal();

	if (iRes == IDCANCEL)
		return;

	CFile file;

	ONDEBUG("Exporting table to HTML " << (LPCSTR) dlgFile.GetFileName());
	
	BOOL bOpened = file.Open(dlgFile.GetFileName(), CFile::modeWrite | CFile::modeCreate | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd tworzenia pliku");
		return;
	}

	HTML_Save(file);

	file.Close();


}
