// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "FormCreator.h"

#include "ChildFrm.h"
#include "globals.h"

#include "console.h"
#include <iostream>
#include "CTList.h"
extern CConsole con;
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame
#define IDC_OBJLISTGRID 5555

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_WM_MDIACTIVATE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
}

CChildFrame::~CChildFrame()
{
}

#define SPACELEFT 4
#define SPACETOP  2
#define POSEDTWIDTH 50

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{

	cs.style = WS_CHILD | WS_VISIBLE | WS_OVERLAPPED |
	           WS_CAPTION | WS_SYSMENU | FWS_ADDTOTITLE |
	           WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX |
	           WS_MAXIMIZE;

	
	if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;

	if (!m_wndToolBarLay.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_LEFT
		 | CBRS_TOOLTIPS | CBRS_SIZE_DYNAMIC | CBRS_FLYBY /*| CBRS_GRIPPER*/) ||
		!m_wndToolBarLay.LoadToolBar(IDR_TOOLBAR_LAYOUT))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBarPrp.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_RIGHT
		 | CBRS_TOOLTIPS | CBRS_SIZE_DYNAMIC | CBRS_FLYBY /*| CBRS_GRIPPER*/) ||
		!m_wndToolBarPrp.LoadToolBar(IDR_TOOLBAR_PROPERTIES))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBarCon.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_BOTTOM
		 | CBRS_TOOLTIPS | CBRS_SIZE_DYNAMIC | CBRS_FLYBY /*| CBRS_GRIPPER*/) ||
		!m_wndToolBarCon.LoadToolBar(IDR_TOOLBAR_CONTROLS))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}


/*	int index = m_wndToolBarCon.GetCount() - 1;
	m_wndToolBarCon.SetButtonInfo(index, 0, TBBS_SEPARATOR, 0);*/

	CRect rect;
	
	rect.left   = SPACELEFT;
	rect.top    = SPACETOP;
	rect.right  = 136;
	rect.bottom = 18;

	m_wndToolBarPrp.m_stcCaption.Create("Nazwa kontrolki", WS_CHILD | WS_VISIBLE | SS_SIMPLE, rect, &m_wndToolBarPrp, 0);

	rect.top    = rect.bottom;
	rect.bottom = rect.top + 18;

    m_wndToolBarPrp.m_edtCaption.Create(WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER,rect, &m_wndToolBarPrp, 0);

	rect.top    = rect.bottom + 2;
	rect.bottom = rect.top + 18;

	m_wndToolBarPrp.m_stcName.Create("Nazwa obiektu", WS_CHILD | WS_VISIBLE | SS_SIMPLE, rect, &m_wndToolBarPrp, 0);

	rect.top    = rect.bottom - 2;
	rect.bottom = rect.top + 18;

    m_wndToolBarPrp.m_edtName.Create(WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER,rect, &m_wndToolBarPrp, 0);

	rect.top    = rect.bottom + 2;
	rect.bottom = rect.top + 18;
 
	m_wndToolBarPrp.m_stcType.Create("Typ obiektu", WS_CHILD | WS_VISIBLE | SS_SIMPLE, rect, &m_wndToolBarPrp, 0);

	rect.top     = rect.bottom;
	rect.bottom  = rect.top + 150;

    m_wndToolBarPrp.m_cmbType.Create(WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_VSCROLL ,rect, &m_wndToolBarPrp, 0);

	rect.top    = rect.top + 25;
	rect.bottom = rect.top + 18;

	m_wndToolBarPrp.m_stcObjList.Create("Lista obiektw", WS_CHILD | WS_VISIBLE | SS_SIMPLE, rect, &m_wndToolBarPrp, 0);

	rect.top    = rect.bottom;
	rect.bottom = rect.top + 200;

	m_wndToolBarPrp.m_grdObjList.Create(rect, &m_wndToolBarPrp, IDC_OBJLISTGRID, WS_CHILD | WS_VISIBLE);
	m_wndToolBarPrp.m_grdObjList.SetDefCellHeight(16);
	m_wndToolBarPrp.m_grdObjList.SetListMode(TRUE);
	m_wndToolBarPrp.m_grdObjList.SetSingleRowSelection(TRUE);
	m_wndToolBarPrp.m_grdObjList.SetTrackFocusCell(FALSE);
	m_wndToolBarPrp.m_grdObjList.SetFrameFocusCell(FALSE);
	m_wndToolBarPrp.m_grdObjList.SetEditable(FALSE);
	m_wndToolBarPrp.m_grdObjList.SetHeaderSort(true);
	m_wndToolBarPrp.m_grdObjList.InsertColumn("Obiekt");
	m_wndToolBarPrp.m_grdObjList.ExpandColumnsToFit(TRUE);
	m_wndToolBarPrp.m_grdObjList.SetFixedRowCount(1);
	m_wndToolBarPrp.m_grdObjList.EnableSelection(TRUE);
	CGridCellBase * pCell =  m_wndToolBarPrp.m_grdObjList.GetCell(0,0);
	pCell->SetBackClr(RGB(245,214,33));



	rect.top = rect.bottom + 2;
	rect.bottom = rect.top + 18;

	m_wndToolBarPrp.m_btnShowNumbers.Create("Pokazuj numerki", WS_CHILD | WS_VISIBLE | BS_CHECKBOX | BS_AUTOCHECKBOX | BS_FLAT, rect, &m_wndToolBarPrp, 0);
	m_wndToolBarPrp.m_btnShowNumbers.SetCheck(true);


	rect.left   = SPACELEFT;
	rect.right  = rect.left + 50;
	rect.top    = rect.bottom + 15;
	rect.bottom = rect.top + 18;

	m_wndToolBarPrp.m_stcPosX.Create("Poz.X", WS_CHILD | WS_VISIBLE | SS_SIMPLE, rect, &m_wndToolBarPrp, 0);

	rect.top    -= 3;
	rect.bottom -= 3;
	rect.left   = 70;
	rect.right  = 136;

	m_wndToolBarPrp.m_edtPosX.Create(WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER, rect, &m_wndToolBarPrp, 0);

	rect.left   = SPACELEFT;
	rect.right  = rect.left + 50;
	rect.top    = rect.bottom + 5;
	rect.bottom = rect.top + 18;

	m_wndToolBarPrp.m_stcPosY.Create("Poz.Y", WS_CHILD | WS_VISIBLE | SS_SIMPLE, rect, &m_wndToolBarPrp, 0);

	rect.top    -= 3;
	rect.bottom -= 3;
	rect.left   = 70;
	rect.right  = 136;

	m_wndToolBarPrp.m_edtPosY.Create(WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER, rect, &m_wndToolBarPrp, 0);

	rect.left   = SPACELEFT;
	rect.right  = rect.left + 50;
	rect.top    = rect.bottom + 5;
	rect.bottom = rect.top + 18;

	m_wndToolBarPrp.m_stcWidth.Create("Szeroko", WS_CHILD | WS_VISIBLE | SS_SIMPLE, rect, &m_wndToolBarPrp, 0);

	rect.top    -= 3;
	rect.bottom -= 3;
	rect.left   = 70;
	rect.right  = 136;

	m_wndToolBarPrp.m_edtWidth.Create(WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER, rect, &m_wndToolBarPrp, 0);

	rect.left   = SPACELEFT;
	rect.right  = rect.left + 50;
	rect.top    = rect.bottom + 5;
	rect.bottom = rect.top + 18;

	m_wndToolBarPrp.m_stcHeight.Create("Wysoko", WS_CHILD | WS_VISIBLE | SS_SIMPLE, rect, &m_wndToolBarPrp, 0);

	rect.top    -= 3;
	rect.bottom -= 3;
	rect.left   = 70;
	rect.right  = 136;

	m_wndToolBarPrp.m_edtHeight.Create(WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER, rect, &m_wndToolBarPrp, 0);
	
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = 10;
	strcpy(lf.lfFaceName, "MS Sans Serif");
	HFONT hfont = ::CreateFontIndirect(&lf);

	m_wndToolBarPrp.m_edtName.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_edtCaption.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
//	m_wndToolBarPrp.m_edtInfo.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_cmbType.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_stcName.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_stcCaption.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_stcObjList.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_stcType.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_stcPosX.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_stcPosY.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_stcHeight.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_stcWidth.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_edtPosX.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_edtPosY.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_edtHeight.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_edtWidth.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
	m_wndToolBarPrp.m_btnShowNumbers.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
//	m_wndToolBarPrp.m_btnUpdateInfo.SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));


	//m_wndToolBarLay.SetSizes(CSize(30,30), CSize(16,16));
	/*m_wndToolBarLayout.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBarLayout);
	
	m_wndToolBarCon.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBarCon);*/


	//m_wndToolBarCon.CreateControl()

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers




void CChildFrame::OnMDIActivate(BOOL bActivate, CWnd* pActivateWnd, CWnd* pDeactivateWnd) 
{
	CMDIChildWnd::OnMDIActivate(bActivate, pActivateWnd, pDeactivateWnd);

	g_pToolBarCon = &m_wndToolBarCon;
	g_pToolBarLay = &m_wndToolBarLay;
	g_pToolBarPrp = &m_wndToolBarPrp;

	g_pToolBarCtrlCon = &m_wndToolBarCon.GetToolBarCtrl();
	g_pToolBarCtrlLay = &m_wndToolBarLay.GetToolBarCtrl();
	g_pToolBarCtrlPrp = &m_wndToolBarPrp.GetToolBarCtrl();
	g_pActiveView     = (CFormCreatorView *) GetActiveView();

	g_pActiveWnd      = (CWnd *) this;


}

void CChildFrame::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
}


BOOL CChildFrame::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;
}


LRESULT CChildFrame::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	if (message == WM_APP + 10001)
		GetActiveView()->SendMessage(message, 0, 0);

	return CMDIChildWnd::WindowProc(message, wParam, lParam);
}

void CChildFrame::OnClose() 
{

	CFormCreatorView * pView = (CFormCreatorView *) GetActiveView();


	if (pView->m_bChange)
	{
	
		int nRes = AfxMessageBox("Zapisa zmiany", MB_YESNO | MB_ICONQUESTION);

		if (nRes == IDYES)
			pView->OnFileSave();
	}
	CMDIChildWnd::OnClose();
}
