// ColumnsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "formcreator.h"
#include "ColumnsDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColumnsDialog dialog


CColumnsDialog::CColumnsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CColumnsDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColumnsDialog)
	m_strColName = _T("");
	//}}AFX_DATA_INIT
}


void CColumnsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColumnsDialog)
	DDX_Control(pDX, IDC_LIST_COLUMNS, m_lbColumns);
	DDX_Text(pDX, IDC_EDIT_COLNAME, m_strColName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CColumnsDialog, CDialog)
	//{{AFX_MSG_MAP(CColumnsDialog)
	ON_BN_CLICKED(IDC_BUTTON_ADDCOLUMN, OnButtonAddcolumn)
	ON_BN_CLICKED(IDC_BUTTON_REMCOLUMN, OnButtonRemcolumn)
	ON_EN_CHANGE(IDC_EDIT_COLNAME, OnChangeEditColname)
	ON_LBN_SELCHANGE(IDC_LIST_COLUMNS, OnSelchangeListColumns)
	ON_BN_CLICKED(IDC_BUTTON_ADDNEWCOLUMN, OnButtonAddnewcolumn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColumnsDialog message handlers

BOOL CColumnsDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_nColCount = m_pGrid->GetColumnCount();

	for (int nCol = 1; nCol < m_nColCount; nCol++)
	{
		CString strColName = m_pGrid->GetItemText(0, nCol);
		if (strColName != "")
			m_lbColumns.AddString(strColName);
		
	}
	m_nColCount--;

	
	m_lbColumns.SetCurSel(0);
	m_strColName = m_pGrid->GetItemText(0, 1);
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CColumnsDialog::OnButtonAddcolumn() 
{
	UpdateData(TRUE);
	if (m_strColName == "")
		return;

	int nCurSel = m_lbColumns.AddString(m_strColName);	

	if (m_nColCount == 1 && m_pGrid->GetItemText(0, 1) == "")
	{
		m_pGrid->SetItemText(0, 1, m_strColName);
		
		CDC * pDC = m_pParent->GetDC();
		m_pGrid->SetColumnWidth(1, pDC->GetTextExtent(m_strColName).cx + 5);
		m_pParent->ReleaseDC(pDC);
	}
	else
	{
		m_pGrid->InsertColumn(m_strColName);
		m_nColCount++;
	}

	m_lbColumns.SetCurSel(nCurSel);
	
	m_pParent->InvalidateRect(m_wndRect, false);

}

void CColumnsDialog::OnButtonRemcolumn() 
{
	int nCurSel = m_lbColumns.GetCurSel();
	
	m_lbColumns.DeleteString(nCurSel);
	m_strColName = "";
	UpdateData(FALSE);

	
	if (m_nColCount == 1)
	{
		m_pGrid->SetItemText(0, 1, "");
		m_pGrid->SetColumnWidth(1, 50);
	}
	else if (m_nColCount > 1)
	{
		m_pGrid->DeleteColumn(nCurSel + 1);
		m_nColCount--;
	}
	
	if (nCurSel < 1)
		nCurSel = 1;

	m_lbColumns.SetCurSel(nCurSel - 1);

	m_pParent->InvalidateRect(m_wndRect, false);

}

void CColumnsDialog::OnChangeEditColname() 
{
	int nCurSel = m_lbColumns.GetCurSel();

	if (nCurSel >= 0)
	{
		m_lbColumns.DeleteString(nCurSel);
		UpdateData(TRUE);
		m_lbColumns.InsertString(nCurSel, m_strColName);
		m_lbColumns.SetCurSel(nCurSel);

		m_pGrid->SetItemText(0, nCurSel + 1, m_strColName);
		
		CDC * pDC = m_pParent->GetDC();
		m_pGrid->SetColumnWidth(nCurSel + 1, pDC->GetTextExtent(m_strColName).cx + 5);
		m_pParent->ReleaseDC(pDC);
		m_pParent->InvalidateRect(m_wndRect, false);
	
	}
	
}

void CColumnsDialog::OnSelchangeListColumns() 
{
	int nCurSel = m_lbColumns.GetCurSel();

	m_lbColumns.GetText(nCurSel, m_strColName);
	CDC * pDC = m_pParent->GetDC();
	m_pGrid->SetColumnWidth(nCurSel + 1, pDC->GetTextExtent(m_strColName).cx + 5);
	m_pParent->ReleaseDC(pDC);
	m_pParent->InvalidateRect(m_wndRect, false);
	UpdateData(FALSE);
}

void CColumnsDialog::OnButtonAddnewcolumn() 
{
	m_strColName = "nowa kolumna";
	UpdateData(FALSE);
	OnButtonAddcolumn();
	
}
