// TDialog.cpp : implementation file
//

#include "stdafx.h"
#include "FormCreator.h"
#include "DialogTemplate.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include <iostream>
#include "console.h"
#include "globals.h"

using namespace std;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTemplateDialog dialog


CTemplateDialog::CTemplateDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTemplateDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTemplateDialog)
	//}}AFX_DATA_INIT
	m_nDibX = 0;
	m_nDibY = 0;
	m_pDibBuff = NULL;

}

void CTemplateDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemplateDialog)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTemplateDialog, CDialog)
	//{{AFX_MSG_MAP(CTemplateDialog)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_DRAWITEM()
	ON_WM_MOUSEMOVE()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTemplateDialog message handlers




BOOL CTemplateDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_pMemDC = new CDC;
	m_pBmpBuff = new CBitmap;
	m_pDibBuff = NULL;
	m_nGridX = 0;
	m_nGridY = 0;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTemplateDialog::FillRect(CRect & rect, DWORD col)
{
	for (int i = rect.top; i <= rect.bottom; i++)
	{
		int adr = i * m_nDibX;
		for (int j = rect.left; j <= rect.right; j++)
			m_pDibBuff[adr + j] = col;
	
	}
}
#define MRGB(r,g,b) (r << 16 | g << 8 | b)

void CTemplateDialog::DrawGrid(CRect & rect)
{
	bool bDraw = false;
	CFormCreatorView * pView = (CFormCreatorView *) GetParent();
	
	if (!pView->m_bShowGrid)
		return;


	int nWidth = rect.Width() + 0;
	int nHeight = rect.Height() + 0;

	int nSize = nWidth * nHeight;
	
	if (m_nDibX * m_nDibY < nSize)
	{
		cout << "Size changed..." << nWidth << "," << nHeight << endl;

		if (m_pDibBuff)
		{
			delete [] m_pDibBuff;
			m_pDibBuff = NULL;
		}

		m_nDibX = nWidth;
		m_nDibY = nHeight;

		m_pDibBuff = new int[nSize];

		bDraw = true;
	}


	if (m_nGridX != pView->m_nGridX || 
		m_nGridY != pView->m_nGridY)
	{
		m_nGridX = pView->m_nGridX;
		m_nGridY = pView->m_nGridY;
	
		bDraw = true;
	}


	memset(&m_bmpInfoH, 0, sizeof(BITMAPINFOHEADER));
	m_bmpInfoH.biSize        = sizeof(BITMAPINFOHEADER);
	m_bmpInfoH.biBitCount    = 32;
	m_bmpInfoH.biPlanes      = 1;
	m_bmpInfoH.biCompression = BI_RGB;
	m_bmpInfoH.biWidth       = m_nDibX;
	m_bmpInfoH.biHeight      = -m_nDibY;
	m_bmpInfoH.biSizeImage   = nSize;

	memcpy(&m_bmpInfo.bmiHeader, &m_bmpInfoH, sizeof(BITMAPINFOHEADER));
	//m_bmpInfo.bmiHeader      = m_bmpInfoH;

	if (bDraw)
	{	
		DWORD bkgCol = ::GetSysColor(COLOR_3DFACE);
//		FillRect(rect, bkgCol);
		cout << "Drawing grid..." << endl;

		float dx = rect.right  / (float) pView->m_nGridX;
		float dy = rect.bottom / (float) pView->m_nGridY;

		float sx = pView->m_pTracker->Nearest(rect.left, pView->m_nGridX);
		float sy = pView->m_pTracker->Nearest(rect.top,  pView->m_nGridY);

		int start_sy = sy;

		while (sx < (float) rect.right) 
		{
			sy = start_sy;


			while (sy < (float) rect.bottom)
			{
				int gx = (int) sx;
				int gy = (int) sy;

				if (gx > nWidth || gy > nHeight)
					cout << "OffScreen " << gx <<"," << gy << endl;
				else
				
				m_pDibBuff[gx + gy * (m_nDibX)] = MRGB(100,100,100);
		
				sy += (float) pView->m_nGridY;
			}

			sx += (float) pView->m_nGridX;
		}
	}


}

void DrawDiffRect(CRect & sRect, CRect & dRect, CRect & rect0, CRect & rect1)
{
	int dx = dRect.left - sRect.left;
	int dy = dRect.top  - sRect.top;

	CRect r0, r1;

	if (dx < 0) //left
	{
		rect0.left   = sRect.left   + dx;
		rect0.top    = sRect.top    + dy;
		rect0.right  = sRect.left;
		rect0.bottom = sRect.bottom + dy;

	}
	else
	{
		rect0.left   = sRect.right;
		rect0.top    = sRect.top    + dy;
		rect0.right  = sRect.right  + dx;
		rect0.bottom = sRect.bottom + dy;
	}

	if (dy < 0)
	{
		rect1.left   = sRect.left;
		rect1.top    = sRect.top   + dy;
		rect1.right  = sRect.right + dx;
		rect1.bottom = sRect.top;
	}
	else
	{
		rect1.left   = sRect.left;
		rect1.top    = sRect.top   + dy;
		rect1.right  = sRect.right + dx;
		rect1.bottom = sRect.top;

	}

}
void CTemplateDialog::OnPaint() 
{
	CFormCreatorView * pView = (CFormCreatorView *) GetParent();

	CPaintDC dc(this); // device context for painting

/*
	CDC memDC;
	memDC.CreateCompatibleDC( &dc );
	CRect rcClip, rcClient;
	GetClientRect(&rcClient);
	CBitmap bitmap;
	bitmap.CreateCompatibleBitmap( &dc, rcClient.Width(), rcClient.Height() );
	memDC.SelectObject( &bitmap );

	CWnd::DefWindowProc( WM_PAINT, (WPARAM)memDC.m_hDC, 0 );

	dc.BitBlt(rcClient.left, rcClient.top, rcClient.Width(), rcClient.Height(), &memDC, 0,0 ,SRCCOPY);

	return;*/

	if (!pView->m_bShowGrid)
		return;

/*	CRect clnRect;
	//GetClientRect(&clnRect);
	dc.GetClipBox(clnRect);
	DrawGrid(clnRect);
	::StretchDIBits(dc.m_hDC, 
		          clnRect.left, clnRect.top, clnRect.Width(), clnRect.Height(),
				  clnRect.left, clnRect.top, clnRect.Width(), clnRect.Height(),
				  m_pDibBuff,
				  &m_bmpInfo,
				  DIB_RGB_COLORS,
				  SRCCOPY);

	

	
	return;*/

	CRect rect;
	dc.GetClipBox(rect);


	DWORD bkgCol = ::GetSysColor(COLOR_3DFACE);

		
	CTList<CTObject *>::iterator it;

	float dx = rect.right  / (float) pView->m_nGridX;
	float dy = rect.bottom / (float) pView->m_nGridY;

	float sx = pView->m_pTracker->Nearest(rect.left, pView->m_nGridX);
	float sy = pView->m_pTracker->Nearest(rect.top,  pView->m_nGridY);

	int start_sy = sy;

	while (sx <= (float) rect.right) 
	{
		sy = start_sy;


		while (sy <= (float) rect.bottom)
		{

			/* eby unikn migotania sprawdzam czy dany punkt nie ley 
			   na jakim z obiektw */

			
			bool bInRect = false;

			int gx = (int) sx;
			int gy = (int) sy;

			it = pView->m_objects.begin();

			while (it != NULL)
			{	
				CRect * curRect = &it->m_curRect;

				if	(gy > curRect->top  && gy < curRect->bottom &&
					 gx > curRect->left && gx < curRect->right)
				{
					bInRect = true;
					break;
				}
				++it;
			}

			if (!bInRect)
				dc.SetPixelV(gx, gy, RGB(100,100,100));
			//dc.SetPixelV((int) sx, (int) sy, RGB(100, 100, 100));

			sy += (float) pView->m_nGridY;
		}

		sx += (float) pView->m_nGridX;
	}
	
}

void CTemplateDialog::OnDestroy() 
{
	CDialog::OnDestroy();

	delete m_pMemDC;
	delete m_pBmpBuff;

	if (m_pDibBuff)
		delete [] m_pDibBuff;
}

void CTemplateDialog::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}

void CTemplateDialog::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnMouseMove(nFlags, point);
}

HBRUSH CTemplateDialog::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

/*
	CRect clnRect;
	GetClientRect(&clnRect);
	//m_pMemDC->CreateCompatibleDC(pDC);
	m_pBmpBuff->CreateCompatibleBitmap(pDC, clnRect.Width(), clnRect.Height());
	pDC->SelectObject(m_pBmpBuff);*/

	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}
