// MEdit.cpp : implementation file
//

#include "stdafx.h"
#include "FormCreator.h"
#include "EditObjectName.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include "globals.h"

#include <iostream>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CObjectNameEdit

CObjectNameEdit::CObjectNameEdit()
{
	m_bFocus = false;
}

CObjectNameEdit::~CObjectNameEdit()
{
}


BEGIN_MESSAGE_MAP(CObjectNameEdit, CEdit)
	//{{AFX_MSG_MAP(CObjectNameEdit)
	ON_WM_CREATE()
	ON_CONTROL_REFLECT(EN_CHANGE, OnChange)
	ON_WM_SETFOCUS()
	ON_WM_KEYDOWN()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CObjectNameEdit message handlers


int CObjectNameEdit::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CEdit::OnCreate(lpCreateStruct) == -1)
		return -1;

	SetLimitText(256);
	return 0;
}


void CObjectNameEdit::OnChange() 
{
	CWnd * pWnd = GetFocus();
	if (!pWnd || pWnd != this)
		return;

	CFormCreatorView * pView = (CFormCreatorView *) GetParentFrame()->GetActiveView();

	if (pView->m_bShiftPressed)
		return;

	char str[256];

	int strLen = GetWindowText(str, 256);
	str[strLen + 1] = 0;
	
	if (pView->m_nObjSelected == 0)
	{
		pView->m_strDlgName = str;
	}
	else
	if (pView->m_nObjSelected == 1)
	{
		int nRow = pView->FindRowInObjInfList(pView->m_pTObject->m_strName);
		pView->m_pGrdInfObjList->SetItemText(nRow, 1, str);
		pView->m_pGrdInfObjList->RedrawRow(nRow);
		nRow = pView->FindRowInObjList(pView->m_pTObject->m_strName);
		g_pToolBarPrp->m_grdObjList.SetItemText(nRow, 0, str);
		g_pToolBarPrp->m_grdObjList.RedrawRow(nRow);

		pView->m_pTObject->m_strName = str;


		CRect drgRect = pView->GetObjectRealRect(pView->m_pTObject, pView->m_pTObject->m_curRect);

		if (pView->m_bShowNumbers)
			pView->m_pDlg->InvalidateRect(pView->m_pTObject->m_numRect);

		pView->m_pDlg->UpdateWindow();
		CDC * pDC = pView->m_pDlg->GetDC();
		pView->m_pTracker->DrawTrackerRect(pDC, pView->m_pTracker->CalcDragRect(drgRect), false);
		pView->m_pDlg->ReleaseDC(pDC);
	
	}
	
	
}

void CObjectNameEdit::OnSetFocus(CWnd* pOldWnd) 
{
	CEdit::OnSetFocus(pOldWnd);
	m_bFocus = true;
}

void CObjectNameEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CObjectNameEdit::OnKillFocus(CWnd* pNewWnd) 
{
	m_bFocus = false;
	CEdit::OnKillFocus(pNewWnd);
	
	
}
