// GuzikView.cpp : implementation of the CFormCreatorView class
//

#include "stdafx.h"
#include "FormCreator.h"
#include "Globals.h"

#include "GridCtrl/GridCtrl.h"
#include "GridCtrl/GridCellBase.h"
#include "Console.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include "MultiRectTracker.h"
#include "ToolbarControls.h"

#include "DialogMenu.h"
#include "DialogGrid.h"
#include "DialogTemplate.h"
#include "DialogPanelControl.h"
#include "ColumnsDialog.h"
#include "DialogListItems.h"
#include "DialogTab.h"

#include "TObject.h"

#include "PanelControl.h"
#include "ButtonEdit.h"

#include "TransparentWindow.h"
#include "math.h"
#include "Guid.h"
#include <afxrich.h>

#include <iostream>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define IDC_OBJINFLISTGRID 3333
#define IDC_OBJLISTGRID 5555
/////////////////////////////////////////////////////////////////////////////
// CFormCreatorView

#ifdef _DEBUG
CConsole con;
#endif


IMPLEMENT_DYNCREATE(CFormCreatorView, CScrollView)

BEGIN_MESSAGE_MAP(CFormCreatorView, CScrollView)
	//{{AFX_MSG_MAP(CFormCreatorView)
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_SETCURSOR()
	ON_COMMAND(ID_TB_BUTTON, OnTbButton)
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_TB_TEXTBOX, OnTbTextbox)
	ON_COMMAND(ID_TB_CHECKBUTTON, OnTbCheckbutton)
	ON_COMMAND(ID_TB_RADIOBUTTON, OnTbRadiobutton)
	ON_COMMAND(ID_TB_STATICTEXT, OnTbStatictext)
	ON_COMMAND(ID_TB_GROUPBOX, OnTbGroupbox)
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_COMMAND(ID_TB_VSCROLLBAR, OnTbVscrollbar)
	ON_COMMAND(ID_TB_HSCROLLBAR, OnTbHscrollbar)
	ON_COMMAND(ID_TB_LISTBOX, OnTbListbox)
	ON_COMMAND(ID_TB_PICTURE, OnTbPicture)
	ON_COMMAND(ID_TB_PROGRESSBAR, OnTbProgressbar)
	ON_COMMAND(ID_TB_SLIDER, OnTbSlider)
	ON_COMMAND(ID_TB_TABCONTROL, OnTbTabcontrol)
	ON_COMMAND(ID_TB_TREECONTROL, OnTbTreecontrol)
	ON_COMMAND(ID_TB_COMBOBOX, OnTbCombobox)
	ON_COMMAND(ID_TB_TESTMODE, OnTbTestmode)
	ON_COMMAND(ID_TB_LISTCONTROL, OnTbListcontrol)
	ON_COMMAND(ID_TB_SPIN, OnTbSpin)
	ON_COMMAND(ID_TB_IPADDRESS, OnTbIpaddress)
	ON_COMMAND(ID_TB_HOTKEY, OnTbHotkey)
	ON_COMMAND(ID_TB_DATETIMEPICKER, OnTbDatetimepicker)
	ON_COMMAND(ID_TB_ALGNOBJLEFT, OnTbAlgnobjleft)
	ON_COMMAND(ID_TB_ALGNOBJRIGHT, OnTbAlgnobjright)
	ON_COMMAND(ID_TB_ALGNOBJTOP, OnTbAlgnobjtop)
	ON_COMMAND(ID_TB_ALGNOBJBOTTOM, OnTbAlgnobjbottom)
	ON_COMMAND(ID_TB_CENTERV, OnTbCenterv)
	ON_COMMAND(ID_TB_CENTERH, OnTbCenterh)
	ON_COMMAND(ID_TB_GRID, OnTbGrid)
	ON_COMMAND(ID_TB_SAMESIZEV, OnTbSamesizev)
	ON_COMMAND(ID_TB_SAMESIZEH, OnTbSamesizeh)
	ON_COMMAND(ID_TB_SAMESIZEVH, OnTbSamesizevh)
	ON_COMMAND(ID_TB_SPACEV, OnTbSpacev)
	ON_COMMAND(ID_TB_SPACEH, OnTbSpaceh)
	ON_COMMAND(ID_TB_CALENDAR, OnTbCalendar)
	ON_COMMAND(ID_TB_RICHEDIT, OnTbRichedit)
	ON_COMMAND(ID_TB_SGRID, OnTbSgrid)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_GRID_USER, OnGridUser)
	ON_COMMAND(ID_GRID_0, OnGrid0)
	ON_COMMAND(ID_GRID_1, OnGrid1)
	ON_COMMAND(ID_GRID_2, OnGrid2)
	ON_COMMAND(ID_GRID_3, OnGrid3)
	ON_COMMAND(ID_GRID_4, OnGrid4)
	ON_UPDATE_COMMAND_UI(ID_GRID_0, OnUpdateGrid0)
	ON_UPDATE_COMMAND_UI(ID_GRID_1, OnUpdateGrid1)
	ON_UPDATE_COMMAND_UI(ID_GRID_2, OnUpdateGrid2)
	ON_UPDATE_COMMAND_UI(ID_GRID_3, OnUpdateGrid3)
	ON_UPDATE_COMMAND_UI(ID_GRID_4, OnUpdateGrid4)
	ON_UPDATE_COMMAND_UI(ID_GRID_USER, OnUpdateGridUser)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_COMMAND(ID_FILE_IMPORT_DFM, OnFileImportDfm)
	ON_COMMAND(ID_FILE_EXPORT_DFM, OnFileExportDfm)
	ON_COMMAND(ID_TB_PANEL, OnTbPanel)
	ON_COMMAND(ID_FILE_SAVEHTML, OnFileSavehtml)
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_TB_SWITCHWINDOW, OnTbSwitchwindow)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_MENU1_ACTIV, OnMenu1Activ)
	ON_COMMAND(ID_MENU1_ALIGNTOLEFT, OnMenu1Aligntoleft)
	ON_COMMAND(ID_MENU1_ALIGNTORIGHT, OnMenu1Aligntoright)
	ON_COMMAND(ID_MENU1_ALIGNTOTOP, OnMenu1Aligntotop)
	ON_COMMAND(ID_MENU1_ALIGNTOBOTTOM, OnMenu1Aligntobottom)
	ON_COMMAND(ID_MENU1_CENTERH, OnMenu1Centerh)
	ON_COMMAND(ID_MENU1_CENTERV, OnMenu1Centerv)
	ON_COMMAND(ID_MENU1_SAMESIZEH, OnMenu1Samesizeh)
	ON_COMMAND(ID_MENU1_SAMESIZEV, OnMenu1Samesizev)
	ON_COMMAND(ID_MENU1_SAMESIZEVH, OnMenu1Samesizevh)
	ON_COMMAND(ID_MENU1_SPACEH, OnMenu1Spaceh)
	ON_COMMAND(ID_MENU1_SPACEV, OnMenu1Spacev)
	ON_COMMAND(ID_MENU1_SWITCHAPP, OnMenu1Switchapp)
	ON_COMMAND(ID_HELP_CONTENT, OnHelpContent)
	ON_COMMAND(ID_TB_BUTTONEDIT, OnTbButtonedit)
	ON_COMMAND(ID_MENU1_PROPERTIES, OnMenu1Properties)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_TB_MENU, OnTbMenu)
	ON_COMMAND(ID_TB_POPUPMENU, OnTbPopupmenu)
	ON_COMMAND(ID_TB_SNAP, OnTbSnap)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_MESSAGE(WM_APP + 10001, OnUserMessage)

    ON_NOTIFY(GVN_SELCHANGED, IDC_OBJINFLISTGRID, OnObjInfListClick)
    ON_NOTIFY(GVN_SELCHANGED, IDC_OBJLISTGRID, OnObjListClick)

END_MESSAGE_MAP()

void CFormCreatorView::OnUserMessage(WPARAM wParam, LPARAM lParam)
{
	UpdateDialog();
}

int CFormCreatorView::FindRowInObjInfList(CString & strName)
{
	int nRows = m_pGrdInfObjList->GetRowCount();

	for (int i = 1; i < nRows; i++)
	{
		if (strName == m_pGrdInfObjList->GetItemText(i, 1))
			return i;
	}
	return -1;
}
int CFormCreatorView::FindRowInObjList(CString & strName)
{
	int nRows = g_pToolBarPrp->m_grdObjList.GetRowCount();

	for (int i = 0; i < nRows; i++)
	{
		if (strName == g_pToolBarPrp->m_grdObjList.GetItemText(i, 0))
			return i;
	}
	return -1;
}

void CFormCreatorView::OnObjInfListClick(NMHDR *pNotifyStruct, LRESULT* /*pResult*/)
{
    NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;

	CString strName = m_pGrdInfObjList->GetItemText(pItem->iRow, 1);
	CTObject * pTObject = FindObjectByName(&m_objects, strName);

	if (pTObject)
	{
		SelectObject(pTObject);
	}
	
}

void CFormCreatorView::SelectObject(CTObject * pTObject)
{
	if (!pTObject)
	{
		m_nObjSelected = 0;
		m_bDlgSelected = true;
		m_pTracker->m_bDlgSelected = true;
		DrawTrackerRect();
		return;
	}

	m_pTObject = pTObject;
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, true);
	m_pTracker->RemoveAllObjects();
	m_pTracker->AddObject(pTObject);
	m_bDlgSelected = false;
	m_pTracker->m_bDlgSelected = false;
	m_nObjSelected = 1;

	CTObject * pTTmpObject = pTObject;
	CTObject * pTTmpParent = pTObject->m_pTParent;

	bool bIsOnTabSheet = false;
	
	while (pTTmpParent != m_pTDlg)
	{
		if (pTTmpParent->m_nType == CTRL_TABCONTROL)
		{
			/* eby niepotrzebnie nie odwiea zakadki, gdy kontrolka
			   ley na aktualnie widocznej zkadce */
			if (pTTmpParent->m_nCurPage != pTTmpObject->m_nPage) 
				bIsOnTabSheet = true;
			((CTabCtrl *) pTTmpParent->m_pObject)->SetCurSel(pTTmpObject->m_nPage);
			pTTmpParent->m_nCurPage = pTTmpObject->m_nPage;
			pTTmpObject = pTTmpParent;

		}
		pTTmpParent = pTTmpParent->m_pTParent;
	}

	if (bIsOnTabSheet)
		ShowObjects(pTTmpObject->m_nCurPage, &pTTmpObject->m_objects);

	m_pDlg->UpdateWindow();

	EraseDlgDragRect();
	DrawTrackerRect();
	UpdateObjectCaptionInfo();
	UpdateObjectClassInfo();
	UpdateObjectNameInfo();
	UpdateObjectPosInfo(pTObject->m_curRect);

	SelectRowOnObjInfList(pTObject);
	SelectRowOnObjList(pTObject);

}

void CFormCreatorView::OnObjListClick(NMHDR *pNotifyStruct, LRESULT* /*pResult*/)
{
    NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;

	CString strName = g_pToolBarPrp->m_grdObjList.GetItemText(pItem->iRow, 0);
	CTObject * pTObject = FindObjectByName(&m_objects, strName);

	if (pTObject)
	{
		SelectObject(pTObject);
	}

}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::CFormCreatorView
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Konstrukor. Incjializacja wikszoci zmiennych. 
	Wyjscie    : 	
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
CFormCreatorView::CFormCreatorView()
{
	m_bInsert = false;

	#ifdef _DEBUG
	con.RedirectToConsole(true);
	con.SetNumberOfLines(1000);
	#endif

	m_pTracker    = NULL;
	m_pDlg        = NULL;
	m_pTObject    = NULL;
	m_pLstTObject = NULL;

	m_bDlgSelected        = true;
	m_bShiftPressed       = false;
	m_bControlPressed     = false;
	m_bTestMode           = false;
	m_bShowGrid           = false;
	m_bSnapToGrid		  = false;
	m_bShowNumbers        = true;
	m_bSaved              = false;
	m_bGetFileName        = false;
	m_bChange             = false;
	m_bPopUpMenu		  = false;
	m_nGridX              = 10;
	m_nGridY              = 10;
	m_nObjSelected        = 0;
	m_nCtrlID             = 1;
	m_nZeros              = 3;

	m_imgList.Create(16,16,0,0,3);
	m_imgList.Add(AfxGetApp()->LoadIcon(IDI_ICON1));
	m_imgList.Add(AfxGetApp()->LoadIcon(IDI_ICON2));
	m_imgList.Add(AfxGetApp()->LoadIcon(IDI_ICON3));

	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = 10;
	strcpy(lf.lfFaceName, "MS Sans Serif");

	fontNormal.CreateFont(10, 0, 0, 0, FW_NORMAL, 0, 0, 0,
						  ANSI_CHARSET, OUT_DEFAULT_PRECIS,
						  CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
						  DEFAULT_PITCH | FF_SWISS, "MS Sans Serif");
	fontBold.CreateFont(8, 0, 0, 0, FW_BOLD, 0, 0, 0,
						  ANSI_CHARSET, OUT_DEFAULT_PRECIS,
						  CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
						  DEFAULT_PITCH | FF_SWISS, "MS Sans Serif");

	AfxInitRichEdit();

	m_pObjectsID = new int[1000];

	CString strHelpPath =  AfxGetApp()->m_pszHelpFilePath;
	CString strHelpFile =  "FormCreator.hlp";
	
	m_strAppPath = strHelpPath.Mid(0, strHelpPath.GetLength() - strHelpFile.GetLength());

	m_strDlgName = "TForm1";

	m_bmpPopupMenu.LoadBitmap(IDB_BITMAP_POPUPMENU);
	m_bmpMenu.LoadBitmap(IDB_BITMAP_MENU);
	m_bmpPicture.LoadBitmap(IDB_BITMAP_PICTURE);

//	m_pMemDC  = new CDC;
//	m_pBitmap = new CBitmap;

}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::~CFormCreatorView
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Destruktor. Usunicie wszystkich obiektw  
	Wyjscie    :	
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
CFormCreatorView::~CFormCreatorView()
{

	RemoveAllObjects();
	m_pDlg->DestroyWindow();
	m_pGrdInfObjList->DestroyWindow();

	delete m_pTDlg;
	delete m_pDlg;
	delete m_pGrdInfObjList;
	delete m_pTracker;


//	delete m_pMemDC;
//	delete m_pBitmap;
}

BOOL CFormCreatorView::PreCreateWindow(CREATESTRUCT& cs)
{

	cs.style |= WS_VSCROLL | WS_HSCROLL;

	return CScrollView::PreCreateWindow(cs);

}


/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnDraw
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  
	Wyjscie    :  void
	Parametry  :
			      CDC* pDC	-   kontekst urzdzenia
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnDraw(CDC* pDC)
{
	CRect dlgRect = GetDlgScreenRect();

	int nDlgHeight = dlgRect.Height();
	int nDlgWidth  = dlgRect.Width();

	if (pDC->IsPrinting())
	{
		//m_pGrdInfObjList->Print(NULL);
		m_pDlg->Print(pDC, PRF_NONCLIENT | PRF_CLIENT | PRF_CHILDREN);
		DrawInfo(pDC);
		
	}
	else
	{
		
		//m_pDlg->Print(pDC, PRF_NONCLIENT | PRF_CLIENT | PRF_CHILDREN);
		m_pDlg->UpdateWindow();
		DrawTrackerRect();

/*		m_pBitmap->DeleteObject();
		m_pMemDC->DeleteDC();
		m_pBitmap->CreateCompatibleBitmap(pDC, nDlgWidth, nDlgHeight);
		m_pMemDC->CreateCompatibleDC(pDC);
		m_pMemDC->SelectObject(m_pBitmap);
		m_pMemDC->BitBlt(0, 0, nDlgWidth, nDlgHeight, m_pDlg->GetDC(), 0,0, SRCCOPY);// dlgRect.left, dlgRect.top, SRCCOPY);*/


	}

}

CTObject * CFormCreatorView::FindObjectByGuid(CTList<CTObject *> * objects, CString & strGuid)
{
	objIterator it = objects->begin();
	while (it != NULL)
	{
		if (it->m_strGuid == strGuid)
			return *it;
		else
		{
			CTObject * pTObject =  FindObjectByGuid(&it->m_objects, strGuid);
			if (pTObject)
				return pTObject;
		}
		++it;
	}

	return NULL;
}

CTObject * CFormCreatorView::FindObjectByName(CTList<CTObject *> * objects, CString & strName)
{
	objIterator it = objects->begin();
	while (it != NULL)
	{
		if (it->m_strName == strName)
			return *it;
		else
		{
			CTObject * pTObject = FindObjectByName(&it->m_objects, strName);
			if (pTObject)
				return pTObject;
		}
		++it;
	}

	return NULL;
}

void CFormCreatorView::UpdateDialog()
{
	CFile file;
	BOOL bOpened = file.Open(m_strAppPath + "Temp\\FCFile.tmp", CFile::modeRead | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd odczytu pliku");
		return;
	}


	ONDEBUG("Updating dialog...");
	RemoveAllObjects();
	m_nCtrlID = 1;

	TMP_LoadObjects(file);

	file.Close();

	ResetScrollBars();
	Invalidate();
}


#ifdef _DEBUG
void CFormCreatorView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CFormCreatorView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CFormCreatorDoc* CFormCreatorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFormCreatorDoc)));
	return (CFormCreatorDoc*)m_pDocument;
}
#endif //_DEBUG


BOOL CFormCreatorView::OnEraseBkgnd(CDC* pDC) 
{
	CRect dlgRect;
	CRect clnRect;
	CRect grdRect;
	CBrush brush;

	brush.CreateSolidBrush(RGB(162,173,187));
//	brush.CreateSolidBrush(RGB(199,241,205));
	GetClientRect(&clnRect);

	if (!m_pDlg)
	{
		pDC->FillRect(clnRect, &brush);
		return TRUE;
	}

	dlgRect = GetDlgScreenRect();

	m_pGrdInfObjList->GetWindowRect(&grdRect);
	ScreenToClient(&grdRect);

	pDC->FillRect(CRect(0,0, clnRect.right, dlgRect.top), &brush);
	pDC->FillRect(CRect(0, dlgRect.top, dlgRect.left, dlgRect.bottom), &brush);
	pDC->FillRect(CRect(dlgRect.right, dlgRect.top, clnRect.right, dlgRect.bottom), &brush);
	pDC->FillRect(CRect(0, dlgRect.bottom, clnRect.right, grdRect.top), &brush);
	pDC->FillRect(CRect(0, grdRect.top, grdRect.left, grdRect.bottom), &brush);
	pDC->FillRect(CRect(grdRect.right, grdRect.top, clnRect.right, grdRect.bottom), &brush);
	pDC->FillRect(CRect(0, grdRect.bottom, clnRect.right, clnRect.bottom), &brush);


	return TRUE;
}


/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::PointIn
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Sprawdza czy punkt p znajduje si w rodku prostokta r.
	Wyjscie    :  bool	-  true - jeeli punkt znajduje si w prostokcie	
	Parametry  :
			      CPoint &p	-	punkt
			      CRect &r	-	prostokt
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::PointIn(CPoint &p, CRect &r)
{
	if (p.x >= r.left && p.x <= r.right &&
		p.y >= r.top  && p.y <= r.bottom)

		return true;
	else
		return false;

}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::PointInDlgObject
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  
	Wyjscie    :  bool	-	true - jeli punkt ley wewntrz obiektu
	                        formatki.
	Parametry  :
			      CPoint &point     	-	sprawdzany punkt
			      CTObject * pTObject	-	wskanik na sprawdzany obiekt
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::PointInDlgObject(CPoint & point, CRect & wndRect)
{
	
	if (point.x >= wndRect.left && point.x <= wndRect.right &&
		point.y >= wndRect.top  && point.y <= wndRect.bottom)
		return true;
	else
		return false;

}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::PointInDlgObjectFrame
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Spawdza czy punkt ley na obwdce obiektu
	Wyjscie    :  bool	-	true - jeli punkt ley na obwdce obiektu
	Parametry  :
			      CPoint &point	        -	sprawdzany punkt
			      CTObject * pTObject	-	wskanik na sprawdzany obiekt
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::PointInDlgObjectFrame(CPoint &point, CRect & rect)
{
	CRect wndRect = rect;
	
	const int nFrameWidth = 5;
	const int nFrameTopHeight = 15;

	wndRect.left   += nFrameWidth;
	wndRect.right  -= nFrameWidth;
	wndRect.top    += nFrameTopHeight;
	wndRect.bottom -= nFrameWidth;

	if (point.x >= wndRect.left && point.x <= wndRect.right &&
		point.y >= wndRect.top  && point.y <= wndRect.bottom)
		return false;
	else
		return true;

}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::GetDlgBorderSize
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Oblicza grubo ramki okna dialogowego
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::GetDlgBorderSize()
{
	CRect dlgRect;
	CRect cliRect;

	m_pDlg->GetWindowRect(&dlgRect);
	m_pDlg->GetClientRect(&cliRect);

	ScreenToClient(&dlgRect);

	m_nBorderX = (dlgRect.Width() - cliRect.Width()) >> 1;
	m_nBorderY = (dlgRect.Height() - cliRect.Height()) - m_nBorderX;


}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::GetDlgScreenRect
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Oblicza pooenie okna dialogowego w obszarze rysowania
	Wyjscie    :  CRect	-	prostokt okrelajcy to pooenie
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
CRect CFormCreatorView::GetDlgScreenRect()
{
	CRect dlgRect;

	m_pDlg->GetWindowRect(&dlgRect);
	ScreenToClient(&dlgRect);

	return dlgRect;
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::ScaleObjects
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Skaluje proporcjonalnie wszystkie obiekty formatki.
	              Wtedy gdy uytkownik zmienia rozmiar formatki
				  trzymajc control.
	Wyjscie    :  void	
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::_ScaleObjects(CTList<CTObject *> * objects, float fdx, float fdy)
{
	objIterator it = objects->begin();

	while (it != NULL)
	{
		it->m_oldRect = it->m_curRect;

		it->m_curRect.left   = (float) it->m_curRect.left   * fdx;
		it->m_curRect.top    = (float) it->m_curRect.top    * fdy;
		it->m_curRect.right  = (float) it->m_curRect.right  * fdx;
		it->m_curRect.bottom = (float) it->m_curRect.bottom * fdy;

		it->m_pObject->MoveWindow(it->m_curRect, false);

		_ScaleObjects(&it->m_objects, fdx, fdy);

		++it;
	}

}
void CFormCreatorView::ScaleObjects(CTList<CTObject *> * objects)
{

	float fdx = (float) m_pTracker->m_curRect.Width()  / (float) m_pTracker->m_oldRect.Width();
	float fdy = (float) m_pTracker->m_curRect.Height() / (float) m_pTracker->m_oldRect.Height();
	
	_ScaleObjects(objects, fdx, fdy);

}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::UpdateObjectPos
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Gdy formatka zmieni pooenie, konieczne jest
	              ponowne odczytanie pooe wszystkich obiektw.
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::UpdateObjectPos()
{
	objIterator it = m_objects.begin();

	while (it != NULL)
	{
		CRect rect;
		it->m_pObject->GetWindowRect(&rect);
		m_pDlg->ScreenToClient(&rect);
		it->m_oldRect = rect;
		it->m_curRect = rect;
		++it;
	}

}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::PointToDlg
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Mapuje punkt widoku do punktu na formatce
	Wyjscie    :  CPoint	-	mapowany punkt
	Parametry  :
			      CPoint & point	-	punkt na formatce
	Note       :
\*----------------------------------------------------------------------*/
CPoint CFormCreatorView::PointToDlg(CPoint & point)
{
	CPoint pnt;
	CRect dlgRect;

	m_pDlg->GetWindowRect(&dlgRect);

	ScreenToClient(&dlgRect);
	
	pnt.x = point.x - (dlgRect.left + m_nBorderX);
	pnt.y = point.y - (dlgRect.top +  m_nBorderY);

	return pnt;

}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::RectInRect
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Sprawdza czy prostokt rect0 zawiera si w prostokcie
				  rect1.
	Wyjscie    :  bool	-	true - jeli si zawiera
	Parametry  :
			      CRect & rect0	-	prostokt zawierajcy si
			      CRect & rect1	-	prostokt zawierajcy
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::RectInRect(CRect & rect0, CRect & rect1)
{
	if (rect0.left   >= rect1.left  &&
		rect0.right  <= rect1.right &&
		rect0.top    >= rect1.top   &&
		rect0.bottom <= rect1.bottom)

		return true;
	else
		return false;

}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::IntersectRect
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Sprawdza czy prostokt rect0 przecina (zachodzi na)
	              prostokt rect1.
	Wyjscie    :  bool	-	true - jeli przecina
	Parametry  :
			      CRect & rect0	-	
			      CRect & rect1	-	
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::IntersectRect(CRect & rect0, CRect & rect1)
{
	CRect rect = rect0;

	if (rect0.left   < rect.left)   rect.left    = rect0.left;
	if (rect0.right  > rect.left)   rect.right   = rect0.right;
	if (rect0.top    < rect.left)   rect.top     = rect0.top;
	if (rect0.bottom > rect.bottom) rect.bottom  = rect0.bottom;

	int nField0 = (rect0.right - rect0.left) * (rect0.bottom - rect0.top);
	int nField1 = (rect1.right - rect1.left) * (rect1.bottom - rect1.top);
	int nField  = (rect.right  - rect.left)  * (rect.bottom  - rect.top);
	
	return !(nField0 + nField1 == nField);
		
}


/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::InsertObject
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wstawia obiekt na formatk. Uytkownik myszk 
	              ustala rozmiar kontrolki.
	Wyjscie    :  void
	Parametry  :
			      CPoint & point	-	aktualnie wskazywany punkt widoku
	Note       :
\*----------------------------------------------------------------------*/

CRect CFormCreatorView::GetObjectRealRect(CTObject * pTObject, CRect & rect)
{
	CRect curRect = rect;

	CTObject * pTCurObject = pTObject->m_pTParent;

	while (pTCurObject != m_pTDlg)
	{
		int nLeft = pTCurObject->m_curRect.left + pTCurObject->m_nBorderLeft;
		int nTop  = pTCurObject->m_curRect.top  + pTCurObject->m_nBorderTop;

		curRect.left   += nLeft;
		curRect.right  += nLeft;
		curRect.top    += nTop;
		curRect.bottom += nTop;

		pTCurObject = pTCurObject->m_pTParent;
	}

	return curRect;

}

CRect CFormCreatorView::GetObjectRect(CTObject * pTObject, CRect & rect)
{
	CRect curRect = rect;

	CTObject * pTCurObject = pTObject;

	while (pTCurObject != m_pTDlg)
	{
		int nLeft = pTCurObject->m_curRect.left + pTCurObject->m_nBorderLeft;
		int nTop  = pTCurObject->m_curRect.top + pTCurObject->m_nBorderTop;;

		curRect.left   -= nLeft;
		curRect.right  -= nLeft;
		curRect.top    -= nTop;
		curRect.bottom -= nTop;

		pTCurObject = pTCurObject->m_pTParent;
	}

	return curRect;

}

void CFormCreatorView::InsertObject(CPoint & point)
{
	ONDEBUG("Inserting object...");

	EraseDlgDragRect();

	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);
	DrawNumbers();

	m_pTracker->TrackRubberBand(m_pDlg, PointToDlg(point));

	CTObject * pTObject = FindObject(&m_objects, PointToDlg(point), FIND_CHECKALLOBJECT);

	CRect objRect;

	if (pTObject == NULL)
	{
		pTObject = m_pTDlg;
		objRect  = m_pTracker->m_curRect;
	}
	else if (pTObject->m_nType != CTRL_PANEL    && 
		     pTObject->m_nType != CTRL_GROUPBOX &&
			 pTObject->m_nType != CTRL_TABCONTROL)
	{
		pTObject = pTObject->m_pTParent;
		objRect  = m_pTracker->m_curRect;
	}


	objRect = GetObjectRect(pTObject, m_pTracker->m_curRect);

	const int nMinWidth  = 40;
	const int nMinHeight = 18;

	/* jeeli obiekt bdzie zbyt may dobranie minimalnych wymiarw */

	if (m_pTracker->m_curRect.Width() == 0 && m_pTracker->m_curRect.Height() == 0)
	{
		objRect.right  += cCtrlInfo[m_nObjType].nWidth;
		objRect.bottom += cCtrlInfo[m_nObjType].nHeight;
	}
	else
	{
		if (objRect.Width()  < nMinWidth)  objRect.right  += nMinWidth  - objRect.Width();
		if (objRect.Height() < nMinHeight) objRect.bottom += nMinHeight - objRect.Height();
	}

	/* jeli obiekt to combobox zablokowanie moliwoci rozszerzania go w pionie */

	if (m_nObjType == CTRL_COMBOBOX)
		objRect.bottom = objRect.top + 21;

	if (m_nObjType == CTRL_POPUPMENU ||
		m_nObjType == CTRL_MENU)
	{
		objRect.right = objRect.left + cCtrlInfo[m_nObjType].nWidth;
		objRect.bottom = objRect.top + cCtrlInfo[m_nObjType].nHeight;
	}


	AddObject(pTObject, m_nObjType, objRect , true, true, false);


	m_pTObject->m_pObject->ShowWindow(SW_SHOW);
	m_pLstTObject = m_pTObject;

	m_bInsert = false;


	/* dodanie obiektu do trackera */

	m_pTracker->RemoveAllObjects();
	m_pTracker->AddObject(m_pTObject);
	AddToInfObjList(m_pTObject);
	AddToObjList(m_pTObject);

	m_bDlgSelected = false;
	m_pTracker->m_bDlgSelected = false;

	m_nObjSelected = 1;
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::CheckObject
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Sprawdza czy podany punkt nie naley do jakiego obiektu
	Wyjscie    :  bool	-	true - jeli naley
	Parametry  :
			      CPoint & point	-	wskazywany punkt
	Note       :
\*----------------------------------------------------------------------*/

CRect CFormCreatorView::GetObjectRealRect(CTObject * pTObject)
{
	CRect wndRect;
	pTObject->m_pObject->GetWindowRect(&wndRect);
	m_pDlg->ScreenToClient(&wndRect);

	return wndRect;
	
}
CTObject * CFormCreatorView::FindLastObject(CTList<CTObject *> * objects)
{
	objIterator it = objects->last();

	if (it != NULL)
	{
		if (it->m_objects.IsEmpty())
			return *it;
		else
			return FindLastObject(&it->m_objects);
	}
	else
		return NULL;

}

CTObject * CFormCreatorView::FindObject(CTList<CTObject *> * objects, CPoint & point, bool bCheckObjectFrame)
{
	
	CPoint dlgPoint = point;//PointToDlg(point);
	CRect  wndRect;
	CTObject * pTObject;

	bool bIsPointIn = false;

	objIterator it = objects->begin();

	while (it != NULL)
	{
		CRect wndRect = GetObjectRealRect(*it, it->m_curRect);

		bIsPointIn = PointInDlgObject(dlgPoint, wndRect);

		if (bIsPointIn && it->m_pTParent->m_nType == CTRL_TABCONTROL)
		{
			if (it->m_pTParent->m_nCurPage != it->m_nPage)
				bIsPointIn = false;
		}

		if (bCheckObjectFrame && bIsPointIn &&
		   (it->m_nType == CTRL_STATICTEXT || 
		    it->m_nType == CTRL_GROUPBOX))
			
			bIsPointIn = PointInDlgObjectFrame(dlgPoint, wndRect);

		if (bIsPointIn)
			break;

		++it;
	}

	if (bIsPointIn)
	{
		pTObject = FindObject(&it->m_objects, point, false);
		if (pTObject)
			return pTObject;
		else
			return *it;
	}
	else
		return NULL;


}

bool CFormCreatorView::CheckObject(CPoint & point)
{
	ONDEBUG("Checking objects...");

	bool bIsPointIn = false;

	if (m_pTObject = FindObject(&m_objects, PointToDlg(point), false)) 
		bIsPointIn = true;

	m_bObjChange = true; //!(pLstTObject == m_pTObject);

	/* shift moze byc nacisniety i liczba zaznaczonych obiektow wieksza od 0,
	   ale nie znaczy to ze dodajemy obiekt (moze to byc selekcja) */

	if (!m_bShiftPressed || m_pTObject == NULL)
		m_nObjSelected = 0;

	if (bIsPointIn) m_nObjSelected++;

	if (m_nObjSelected > 0 && m_pLstTObject != m_pTObject)
	{
		if (!m_bShiftPressed)
		{
			m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);
			m_pTracker->RemoveAllObjects();
		}

		if (m_pTracker->AddObject(m_pTObject))
		{
			m_pTracker->m_bDlgSelected = false;
			m_bDlgSelected = false;
			m_nHitTest = hitMiddle;

			m_trkRect = m_pTracker->m_curRect;

			ONDEBUG("Adding " << m_nObjSelected << " object to multiselection");
		}
		else
			m_nObjSelected--;

	}

	m_pLstTObject = m_pTObject;

	return bIsPointIn;
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::CheckSelection
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Aby unikn czasochonnego sprawdzania czy dany
	              punkt naley do obiektu, ta funkcja sprawdza czy
				  naley on do ostatnio zaznaczonego. W tym celu
				  wykorzystuje informacj z funkcji SetCursor - zmienn
				  m_nHitTest, ktra okrela w ktrym miejscu na selekcji
				  (lub te nie) klikn uytkownik.
	Wyjscie    :  bool	-	true, jeli punkt jest na selekcji
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::CheckSelection()
{
	ONDEBUG("Checking selection...");

	bool bIsPointIn;

	/* jeli kliknicie byo na rodku formatki i ostanio zaznaczonym
	   obiektem bya caa formatka to ustawiam m_nHitTest na nietrafienie.
	   Spowoduje to sprawdzenie obiektw wewntrz formatki. */

	if (m_bDlgSelected && m_nHitTest == hitMiddle)
		m_nHitTest = hitNothing;
	
	if (m_nHitTest == hitNothing)
		bIsPointIn = false;
	else
		bIsPointIn = true;

	if (!m_bControlPressed && m_nObjSelected == 1 && m_nHitTest == hitMiddle)
		bIsPointIn = false;

	/* jeli zosta nacinity inny obiekt od ostatnio nacinitego
	   to ustaw zmian obiektu */

	return bIsPointIn;
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::CheckRubberband
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Sprawdza czy selekcja zawiera jakie obiekty.
	Wyjscie    :  bool	-	true - jeli selekcja zawiera jakie obiekty
	Parametry  :
			      CPoint & point	-	punkt pocztkowy selekcji
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::CheckRubberband(CPoint & point)
{
	ONDEBUG("Checking rubberband...");

	bool bIsPointIn = false;

	CRect dlgRect = GetDlgScreenRect();

	/* sprawdzenie, czy punkt ley na formatce, ale nie na tyule okna i ramce */

	dlgRect.left   += m_nBorderX;
	dlgRect.right  -= m_nBorderX;
	dlgRect.top    += m_nBorderY;
	dlgRect.bottom -= m_nBorderX;


	if (PointIn(point, dlgRect))
	{

		EraseDlgDragRect();
		m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);
		DrawNumbers();

		int nGridX = m_pTracker->m_nGridX;
		int nGridY = m_pTracker->m_nGridY;
		
		m_pTracker->SetGrid(1, 1);
		m_pTracker->TrackRubberBand(m_pDlg, PointToDlg(point));
		m_pTracker->SetGrid(nGridX, nGridY);

		CRect rbRect = m_pTracker->m_curRect;

		m_nObjSelected = 0;
		m_pTracker->RemoveAllObjects();

		bool bIsFirst = true;

		/* przeszukanie listy obiektw */

		CTList<CTObject *>::iterator it = m_objects.begin();
		CTList<CTObject *>::iterator oneObjIt;


		while (it != NULL)
		{

			m_pTracker->m_curRect.NormalizeRect();

			if (RectInRect(it->m_curRect, rbRect))
			{
				if (bIsFirst)
				{
					bIsFirst = false;
					oneObjIt = it;
				}

				m_pTracker->AddObject(*it);		
				
				m_nObjSelected++;
			}

			++it;
		}


		if (m_nObjSelected > 0)
		{
			bIsPointIn = true;
			m_bDlgSelected = false;
			m_pTracker->m_bDlgSelected = false;

			if (m_nObjSelected == 1)
				m_pTObject  = *oneObjIt;

			DrawTrackerRect();

		}
	}

	ONDEBUG("Found " << m_nObjSelected << " objects in rubberband selection");
	
	return bIsPointIn;

}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::CheckDialog
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Sprawdza czy punk ley na obwdce formatki.
	Wyjscie    :  bool	-	true - jeli punkt ley na obwdce formatki.
	Parametry  :
			      CPoint & point	-	sprawdzany punkt.
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::CheckDialog(CPoint & point)
{
	ONDEBUG("Checking dialog...");

	bool bIsPointIn = false;

	CRect dlgRect = GetDlgScreenRect();

	if (PointIn(point, dlgRect))
	{
	
		m_pTracker->m_curRect = GetDlgScreenRect();

		bIsPointIn = true;

		m_pTracker->m_bDlgSelected = true;
		m_bDlgSelected = true;

		m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);
		DrawTrackerRect();

		ONDEBUG("Found dialog");

	}

	return bIsPointIn;

}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::UpdateObjectCaptionInfo
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Uaktualnia kontrolk zawierajc nazw obiektu
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::UpdateObjectCaptionInfo()
{
	if (m_nObjSelected == 0)
	{
		CString strDlgName;
		m_pDlg->GetWindowText(strDlgName);
		g_pToolBarPrp->m_edtCaption.SetWindowText(strDlgName);
		g_pToolBarPrp->m_edtCaption.EnableWindow(true);
	}
	else if (m_nObjSelected == 1)
	{
		g_pToolBarPrp->m_edtCaption.SetWindowText(m_pTObject->m_strCaption);
		g_pToolBarPrp->m_edtCaption.EnableWindow(true);

	}
	else if (m_nObjSelected > 1)
	{
		g_pToolBarPrp->m_edtCaption.SetWindowText("Multiselekcja");
		g_pToolBarPrp->m_edtCaption.EnableWindow(false);
	}
}
void CFormCreatorView::UpdateObjectNameInfo()
{
	if (m_nObjSelected == 0)
	{
		g_pToolBarPrp->m_edtName.SetWindowText(m_strDlgName);
		g_pToolBarPrp->m_edtName.EnableWindow(true);
	}
	else if (m_nObjSelected == 1)
	{
		g_pToolBarPrp->m_edtName.SetWindowText(m_pTObject->m_strName);
		g_pToolBarPrp->m_edtName.EnableWindow(true);

	}
	else if (m_nObjSelected > 1)
	{
		g_pToolBarPrp->m_edtName.SetWindowText("Multiselekcja");
		g_pToolBarPrp->m_edtName.EnableWindow(false);
	}
}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::GetTotalClipRect
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Zwraca cay obszar (nie tylko widoczny) rysowania
	Wyjscie    :  CRect	-	zawiera wsprzdne obszaru.
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
CRect CFormCreatorView::GetTotalClipRect()
{
	CPoint scrollPos = GetScrollPosition();
	CSize  totalSize = GetTotalSize();
	CRect  clpRect;
	
	GetClientRect(&clpRect);

	clpRect.left   -= scrollPos.x;
	clpRect.top    -= scrollPos.y;

	if (totalSize.cx > clpRect.Width()) 
		clpRect.right  += totalSize.cx - (clpRect.right  + scrollPos.x);
	if (totalSize.cy > clpRect.Height()) 
		clpRect.bottom += totalSize.cy - (clpRect.bottom + scrollPos.y);

	return clpRect;

}
void CFormCreatorView::ResetScrollBars()
{
	static bFirst = true;
	CPoint scrollPos(0,0);
	if (!bFirst)
		scrollPos = GetScrollPosition();

	bFirst = false;

	m_dlgRect = GetDlgScreenRect();
	int nBottom = m_dlgRect.bottom;

	int nGrdHeight = m_objGridRect.Height();
	int nGrdWidth  = m_objGridRect.Width();
	int nDlgHeight = m_dlgRect.Height();
	int nDlgWidth  = m_dlgRect.Width();

	m_objGridRect.top    = 10 + nBottom;
	m_objGridRect.bottom = 10 + nBottom + nGrdHeight;
	m_objGridRect.left   = 10 - scrollPos.x;
	m_objGridRect.right  = 10 - scrollPos.x + nGrdWidth;
	
	m_pGrdInfObjList->MoveWindow(m_objGridRect, false);
	
	SetScrollSizes(MM_TEXT, CSize(MAX(nGrdWidth, nDlgWidth) + 20, nDlgHeight + nGrdHeight + 30));
}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnLButtonDown
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Reakcja na nacinicie lewego przycisku myszy
	Wyjscie    :  void	
	Parametry  :
			      UINT nFlags	-	flagi towarzyszce zdarzeniu
			      CPoint point	-	wskazywany punkt
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CRect rect;
	CRect objRect;
	CRect rectTemp;


	this->SetFocus();

	/* zapobiega przypadkowi zmiany statusu shifta w trakcie wykonywania procedury */

	unsigned char * key = m_key;
	GetKeyboardState(key);


	if (KEY(VK_LCONTROL) || KEY(VK_RCONTROL))
		m_bControlPressed = true;
	else
		m_bControlPressed = false;

	if (KEY(VK_SHIFT))
		m_bShiftPressed = true;
	else
		m_bShiftPressed = false;

	/* zakadamy, e aden obiekt nie zosta wskazany */

	bool bIsPointIn = false;

	/* nie dokonujemy sprawdzenia jeli tracker nie istnieje albo jestemy w trybie
	   testu formatki */

	if (!m_pTracker || m_bTestMode)
		return;

	/*----------------------------------------------------------------------------------*\
                                	Wstawianie obiektu 
	\*----------------------------------------------------------------------------------*/

	if (m_bInsert)
	{
		InsertObject(point);

		DrawTrackerRect();

		g_pToolBarCtrlCon->CheckButton(g_lpButton->idCommand, false);
		UpdateObjectNameInfo();
		UpdateObjectCaptionInfo();
		UpdateObjectClassInfo();

		return;
	}

	/*----------------------------------------------------------------------------------*\
                         Sprawdzenie czy klikniecie bylo na selekcji
	\*----------------------------------------------------------------------------------*/

	if (!bIsPointIn)
	{
		bIsPointIn = CheckSelection();
	}

	/*----------------------------------------------------------------------------------*\
                        Sprawdzenie, czy zostal klikniety jakis obiekt
	\*----------------------------------------------------------------------------------*/

	if (!bIsPointIn)
	{
		bIsPointIn = CheckObject(point);
		if (bIsPointIn)
		{
			UpdateObjectNameInfo();
			UpdateObjectCaptionInfo();
			UpdateObjectClassInfo();

			if (m_nObjSelected == 1)
				UpdateObjectPosInfo(m_pTObject->m_curRect);
			else if (m_nObjSelected > 1)
				UpdateObjectPosInfo(m_pTracker->m_curRect);

			SelectRowOnObjList(m_pTObject);
			SelectRowOnObjInfList(m_pTObject);

		}
		
	}


	/*----------------------------------------------------------------------------------*\
                    Sprawdzenie czy nowa selekcja nie obejmuje obiektow
	\*----------------------------------------------------------------------------------*/

	if (!bIsPointIn)
	{
		bIsPointIn = CheckRubberband(point);
		if (bIsPointIn)
		{
			UpdateObjectClassInfo();
			UpdateObjectNameInfo();
			UpdateObjectCaptionInfo();
			UpdateObjectPosInfo(m_pTracker->m_curRect);
			return;
		}

	}

	/*----------------------------------------------------------------------------------*\
                            Sprawdzenie czy to nie okno dialogowe
	\*----------------------------------------------------------------------------------*/

	if (!bIsPointIn)
	{
		bIsPointIn = CheckDialog(point);
		if (bIsPointIn)
		{
			CString strDlgName;
			m_pDlg->GetWindowText(strDlgName);
			g_pToolBarPrp->m_edtName.SetWindowText(strDlgName);
			g_pToolBarPrp->m_edtName.EnableWindow(true);
			UpdateObjectPosInfo(m_pTracker->m_curRect);
			UpdateObjectClassInfo();
			UpdateObjectNameInfo();
			UpdateObjectCaptionInfo();
			

			return;

		}
	}

	/*----------------------------------------------------------------------------------*\
                                    Przeswanie obiektw
	\*----------------------------------------------------------------------------------*/

	if (m_bDlgSelected)
	{
		CPoint scrollPos = GetScrollPosition();

		//m_pTracker->SetClipRect(GetTotalClipRect());
		m_pTracker->SetClipRect(CRect(0,0, 2000, 2000));
		m_pTracker->m_curRect = GetDlgScreenRect();

		if (m_pTracker->Track(this, point, m_nHitTest))
		{

			m_pDlg->MoveWindow(m_pTracker->m_curRect, false);

			if (m_bControlPressed)
				ScaleObjects(&m_objects);
			else
				UpdateObjectPos();

			m_bChange = true;

			ResetScrollBars();
			Invalidate();
			//DrawTrackerRect();

			ONDEBUG("Moving dialog...");
		}

		
	}
	else if (m_nObjSelected > 0)
	{
		if (m_nObjSelected == 1 && m_pTObject->m_nType == CTRL_TABCONTROL)
			CheckPageControl(point);

		if (m_nObjSelected == 1)
		cout << "p: " << m_pTObject->m_nPage << "," << m_pTObject->m_nCurPage << endl;

		EraseDlgDragRect();

//		if (m_bObjChange)
		DrawTrackerRect();

		if (!m_bShiftPressed)
		{
			CRect clpRect;
			m_pDlg->GetClientRect(&clpRect);

			if (!m_pTObject)
				m_pTracker->SetClipRect(clpRect);
			else
			if (m_pTObject->m_pTParent == m_pTDlg)
				m_pTracker->SetClipRect(clpRect);
			else if (m_nObjSelected > 0)
			{	
				objIterator it = m_pTracker->m_selObjects.begin();
				CRect tmpRect = it->m_curRect;
				++it;

				while (it != NULL)
				{
					if (it->m_curRect.left   < tmpRect.left)   tmpRect.left   = it->m_curRect.left;
					if (it->m_curRect.top    < tmpRect.top)    tmpRect.top    = it->m_curRect.top;
					if (it->m_curRect.right  > tmpRect.right)  tmpRect.right  = it->m_curRect.right;
					if (it->m_curRect.bottom > tmpRect.bottom) tmpRect.bottom = it->m_curRect.bottom;

					++it;
				}
				m_pTracker->SetRect(GetObjectRealRect(m_pTObject, tmpRect));
				clpRect = GetObjectRealRect(m_pTObject->m_pTParent, m_pTObject->m_pTParent->m_curRect);

				clpRect.left   += m_pTObject->m_pTParent->m_nBorderLeft;
				clpRect.top    += m_pTObject->m_pTParent->m_nBorderTop;
				clpRect.right  -= m_pTObject->m_pTParent->m_nBorderLeft;
				clpRect.bottom -= m_pTObject->m_pTParent->m_nBorderTop;

				m_pTracker->SetClipRect(clpRect);
			}
			m_pTracker->m_nHitTest = m_nHitTest;

			if (m_pTracker->Track(m_pDlg, PointToDlg(point), m_nHitTest))
			{
				if (m_bControlPressed && m_nObjSelected == 1 && m_nHitTest != hitMiddle)
					ScaleObjects(&m_pTObject->m_objects);
					
				m_pTracker->MoveSelObjects(m_pDlg);
				m_bChange = true;
	
				DrawTrackerRect();
				ONDEBUG("Moving object...");
			}


			
		}

	}

	CScrollView::OnLButtonDown(nFlags, point);
}

void CFormCreatorView::OnLButtonUp(UINT nFlags, CPoint point) 
{

	CScrollView::OnLButtonUp(nFlags, point);
}

bool CFormCreatorView::CheckPageControl(CPoint point)
{
	
	CRect wndRect = GetObjectRealRect(m_pTObject, m_pTObject->m_curRect);
	
	m_dlgRect = GetDlgScreenRect();

	int cxBorder = ::GetSystemMetrics(SM_CXDLGFRAME);
	int cyBorder = ::GetSystemMetrics(SM_CXHTHUMB) + ::GetSystemMetrics(SM_CYDLGFRAME);

	point.x -= wndRect.left + m_dlgRect.left + cxBorder;
	point.y -= wndRect.top  + m_dlgRect.top  + cyBorder + 5;
	m_pTObject->m_pObject->SendMessage(WM_LBUTTONDOWN, 0, (point.y << 16) | point.x);

	int nCurPage = ((CTabCtrl*) m_pTObject->m_pObject)->GetCurSel();

	m_pTObject->m_nCurPage = nCurPage;

	if (point.y < 25)
	{
	
		ShowObjects(nCurPage, &m_pTObject->m_objects);
		m_pDlg->UpdateWindow();
		return true;
	}
	else
		return false;

}
//Wyswietla obiekty dla pagecontrol
void CFormCreatorView::ShowObjects(int nPage, CTList<CTObject *> * objects)
{
	objIterator it = objects->begin();

	while (it != NULL)
	{
		if (it->m_nPage == nPage)
		{
			it->m_pObject->ShowWindow(SW_SHOW);
			it->m_bVisible = true;
		}
		else
		{
			it->m_pObject->ShowWindow(SW_HIDE);
			m_pDlg->InvalidateRect(it->m_numRect, true);
			it->m_bVisible = false;
		}

		if (it->m_nType == CTRL_TABCONTROL)
			ShowObjects(it->m_nCurPage, &it->m_objects);
		else
			ShowObjects(nPage, &it->m_objects);
		
		++it;
	}
}

void CFormCreatorView::ShowAllObjects( int nPage, CTList<CTObject *> * objects)
{
	objIterator it = objects->begin();

	while (it != NULL)
	{
		if (!it->m_pObject->IsWindowVisible() && it->m_nPage == nPage)
			it->m_pObject->ShowWindow(SW_SHOW);

		if (it->m_nType == CTRL_TABCONTROL)
			ShowAllObjects(it->m_nCurPage, &it->m_objects);
		else
			ShowAllObjects(nPage, &it->m_objects);
		
		++it;
	}
}

BOOL CFormCreatorView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if (m_bPopUpMenu)
		::SetCursor(m_pTracker->m_hcurArrow);
	else

	if (m_pTracker)
	{
		CPoint point;
		GetCursorPos(&point);
		ScreenToClient(&point);
		
		if (m_bDlgSelected)
		{
			m_nHitTest = m_pTracker->HitTest(point, GetDlgScreenRect());

			/* okno dialogowe mona przenosi klikajc tylko na ramk */

			if (m_nHitTest == hitMiddle)
				m_nHitTest = hitNothing;
		}
		else
		{
			m_nHitTest = m_pTracker->MultiHitTest(PointToDlg(point));

			/* jeli jest multiselekcja to nie mona jej rozcign */

			if (m_nObjSelected > 1 && m_nHitTest != hitMiddle && m_nHitTest != hitNothing)
			{
				m_nHitTest = hitMiddle;
				m_pTracker->m_nHitTest = hitMiddle;
			}		

		}
	
		if (pWnd == this)
		{
			m_pTracker->SetCursor(this, m_nHitTest);

			return TRUE;
		}

	}
	
	return CScrollView::OnSetCursor(pWnd, nHitTest, message);
}


void CFormCreatorView::FillObjectsID(CTList<CTObject *> * objects, CString & strName, int nType)
{
	objIterator it = objects->begin();

	while (it != NULL)
	{
		int nStrLen0 = strName.GetLength();
		int nStrLen1 = it->m_strName.GetLength();

		if (nStrLen1 >= nStrLen0)
		{

			CString strBody = it->m_strName.Mid(0, nStrLen0);
			CString strNum  = it->m_strName.Mid(nStrLen0, nStrLen1 - nStrLen0);

			if (strBody == strName) // jesli nazwa kontroli jest defaultowa
			{
				bool bOnlyNumber = true;
				for (int i = 0; i < strNum.GetLength(); i++)
					if (strNum[i] < '0' || strNum[i] > '9')
					{
						bOnlyNumber = false;
						break;
					}

				int nNum = atoi(strNum);

				if (bOnlyNumber && nNum > 0)
					m_objectsID[nNum] = 1;

			}
		}

		if (!it->m_objects.IsEmpty())
			FillObjectsID(&it->m_objects, strName, nType);
		
		++it;
	}
}

CString CFormCreatorView::MakeObjectName(int nType)
{

	CString strClass = cCtrlInfo[nType].pClassType[0].strClass;
	
	strClass = strClass.Mid(1, strClass.GetLength() - 1);
	
	memset(m_objectsID, 0, MAXID);

	FillObjectsID(&m_objects, strClass, nType);

	int nID = 1;

	for (int i = 1; i < MAXID; i++)
		if (m_objectsID[i] == 0)
		{
			nID = i;
			break;
		}

	CString strName;
	strName.Format("%s%d", strClass, nID);
	return strName;
}

void CFormCreatorView::CopyObject(CTObject * pTParent, CTObject * pTObject, CRect rect)
{
	AddObject(pTParent, pTObject->m_nType, rect, true, true, true);
	m_pTObject->m_strCaption = pTObject->m_strCaption;
	m_pTObject->m_bEnabled   = pTObject->m_bEnabled;
	m_pTObject->m_bVisible   = pTObject->m_bVisible;
	m_pTObject->m_nCurPage   = pTObject->m_nCurPage;
	m_pTObject->m_nPage		 = pTObject->m_nPage;

	m_pTObject->m_pObject->SetWindowText(m_pTObject->m_strCaption);
	m_pTObject->m_pObject->EnableWindow(m_pTObject->m_bEnabled);

	if (m_pTObject->m_nType == CTRL_GRID)
	{
		CGridCtrl * pWndSrc = (CGridCtrl *) pTObject->m_pObject;
		CGridCtrl * pWndDst = (CGridCtrl *) m_pTObject->m_pObject;

		
		int nColCount = pWndSrc->GetColumnCount();

		pWndDst->DeleteColumn(1);
		for (int i = 1; i < nColCount; i++)
		{
			int     nWidth  = pWndSrc->GetColumnWidth(i);
			CString strName = pWndSrc->GetItemText(0, i);

			pWndDst->InsertColumn(strName);
			pWndDst->SetColumnWidth(i, nWidth);

		}

	}
	else
	if (m_pTObject->m_nType == CTRL_PANEL)
	{
		CPanelControl * pWndSrc = (CPanelControl *) pTObject->m_pObject;
		CPanelControl * pWndDst = (CPanelControl *) m_pTObject->m_pObject;

		pWndDst->m_nBevelInner  = pWndSrc->m_nBevelInner;
		pWndDst->m_nBevelOuter  = pWndSrc->m_nBevelOuter;
		pWndDst->m_nBevelWidth  = pWndSrc->m_nBevelWidth;
		pWndDst->m_nBevelBorder = pWndSrc->m_nBevelBorder;
	}
	else
	if (m_pTObject->m_nType == CTRL_COMBOBOX)
	{

		CString strItem;
		
		CComboBox * pWndSrc = (CComboBox *) pTObject->m_pObject;
		CComboBox * pWndDst = (CComboBox *) m_pTObject->m_pObject;

		pWndDst->ResetContent();

		for (int i = 0; i < pWndSrc->GetCount(); i++)
		{
			pWndSrc->GetLBText(i, strItem);
			pWndDst->AddString(strItem);
		}
		pWndDst->SetWindowText(m_pTObject->m_strCaption);
	}
	else
	if (m_pTObject->m_nType == CTRL_LISTBOX)
	{

		CString strItem;
		
		CListBox * pWndSrc = (CListBox *) pTObject->m_pObject;
		CListBox * pWndDst = (CListBox *) m_pTObject->m_pObject;

		pWndDst->ResetContent();
			
		for (int i = 0; i < pWndSrc->GetCount(); i++)
		{
			pWndSrc->GetText(i, strItem);
			pWndDst->AddString(strItem);
		}

		pWndDst->SetCurSel(0);
	}
	else
	if (m_pTObject->m_nType == CTRL_LISTCONTROL)
	{
	}
	else
	if (m_pTObject->m_nType == CTRL_TREECONTROL)
	{
	}
	else
	if (m_pTObject->m_nType == CTRL_MENU || m_pTObject->m_nType == CTRL_POPUPMENU)
	{
		CTreeCtrl * pMenu = (CTreeCtrl *) m_pTObject->m_pObject;

	}
	else
	if (m_pTObject->m_nType == CTRL_TABCONTROL)
	{
		CTabCtrl * pWndSrc = (CTabCtrl *) pTObject->m_pObject;
		CTabCtrl * pWndDst = (CTabCtrl *) m_pTObject->m_pObject;
		
		int nPages = pWndSrc->GetItemCount();
		int nCurSel = pWndSrc->GetCurSel();

		pWndDst->DeleteAllItems();
		
		char strItemName[256];
		TCITEM item;
		item.mask = TCIF_TEXT;
		item.cchTextMax = 256;
		item.pszText = strItemName;
		
		for (int i = 0; i < nPages; i++)
		{
			memset(strItemName, 0, 256);
			pWndSrc->GetItem(i, &item);
			pWndDst->InsertItem(i, strItemName);
		}
		pWndDst->SetCurSel(nCurSel);
	}
}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::AddObject
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Dodaje obiekt do formatki (inicjalizuje go)
	Wyjscie    :  CWnd *	-	okno utworzonej kontrolki
	Parametry  :
			      CWnd * pDlgWnd	    -	rodzic do ktego bdzie naleaa kontrolka
			      int nType	            -	typ obiektu (CTRL_BUTTON, itd)
			      CRect & objRect	    -	rozmiar kontrolki
			      bool bCreateObject	-	czy ma tworzy now kontrolk, czy te modyfikowa star
			      bool bUpdateTracker	-	czy nowy obiekt ma zosta objty selekcj
			      DWORD dwFlags	        -	flagi tworzonej kontrolki
			      DWORD dwFlagsEx	    -	dodatkowe flagi
	Note       :
\*----------------------------------------------------------------------*/
CWnd * CFormCreatorView::AddObject(CTObject * pTParent, int nType, CRect & objRect, bool bCreateTObject, bool bCreateObject, bool bUpdateTracker, DWORD dwFlags, DWORD dwFlagsEx)
{
	/* mona doda osobno ale w kolejnoci CTObject, Object */
	CTObject * pTObject = NULL;
	CWnd     * pParent  = NULL;
	CWnd     * pWnd     = NULL;

	CString strCaption = "";
	CString strClass   = "";
	CString strName = MakeObjectName(nType);

	if (bCreateTObject)
	{
		
		cCtrlInfo[nType].nCount++;

		pTObject = new CTObject;

		pTObject->m_nType       = nType;
		pTObject->m_nClass      = 0;
		pTObject->m_pObject     = NULL;
		pTObject->m_curRect     = objRect;
		pTObject->m_oldRect     = objRect;
		pTObject->m_numRect     = objRect;
		pTObject->m_tmpRect     = CRect(0,0,0,0);
		pTObject->m_pTParent    = pTParent;
		pTObject->m_nBorderLeft = 0;
		pTObject->m_nBorderTop  = 0;
		pTObject->m_strGuid     = GUIDgen();
		pTObject->m_bEnabled    = true;
		pTObject->m_strCaption  = strName;
		pTObject->m_strName     = strName;
		pTObject->m_nID         = m_nCtrlID;
		pTObject->m_bEnabled    = true;
		pTObject->m_bVisible	= true;
		pTObject->m_nPage       = -1;
		pTObject->m_nCurPage    = -1;

		if (bUpdateTracker)
			m_pTracker->AddObject(pTObject);
		
		m_pTObject = pTObject;

		m_nCtrlID++;

	}


	if (!bCreateObject)
		return NULL;


	hfont = ::CreateFontIndirect(&lf);
	
	if (nType == CTRL_GRID) 
		pWnd = (CWnd *) new CGridCtrl;
	else if (nType == CTRL_PANEL)
		pWnd = (CWnd *) new CPanelControl;
	else if (nType == CTRL_BUTTONEDIT)
		pWnd = (CWnd *) new CButtonEdit;
	else
		pWnd = (CWnd *) new CWnd;

	if (!m_bTestMode)
	{
		pParent = pTParent->m_pObject;
	
		if (pTParent == m_pTDlg)
			m_objects.InsFront(m_pTObject);
		else
			pTParent->m_objects.InsFront(m_pTObject);

		m_pTObject->m_pObject  = pWnd;
		m_pTObject->m_pTParent = pTParent;
		
		if (pTParent->m_nType == CTRL_TABCONTROL)
			m_pTObject->m_nPage = pTParent->m_nCurPage;
		else
			m_pTObject->m_nPage = pTParent->m_nPage;
	}
	else
		pParent = (CWnd *) pTParent;

	if (nType != CTRL_GRID && nType != CTRL_PANEL)
	{
		DWORD dwCtrlFlags = dwFlags | WS_CHILD | WS_TABSTOP;
		DWORD dwCtrlFlagsEx = dwFlagsEx;

		dwCtrlFlags   |= cCtrlInfo[nType].dwCtrlFalgs;
		dwCtrlFlagsEx |= cCtrlInfo[nType].dwCtrlFalgsEx;
		strClass       = cCtrlInfo[nType].strClass;


		pWnd->CreateEx(dwCtrlFlagsEx, strClass, strName, dwCtrlFlags, objRect, pParent, m_nCtrlID, NULL);
		pWnd->SendMessage(WM_SETFONT, (WPARAM) hfont , MAKELPARAM(FALSE,0));
		if (nType == CTRL_TABCONTROL)
			pWnd->SetWindowPos(&CWnd::wndTop, 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
		else
			pWnd->SetWindowPos(&CWnd::wndBottom, 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
		
		//if (!SubclassDlgItem(m_nCtrlID, this))
		//	cout << "Error subclassing\n";

		CRect clnRect;

		pWnd->GetClientRect(clnRect);

		if (!m_bTestMode)
		{	
			m_pTObject->m_nBorderLeft = (objRect.Width()   - clnRect.Width()) / 2;
			m_pTObject->m_nBorderTop  = (objRect.Height()  - clnRect.Height()) / 2;
		}


	}
	else if (nType == CTRL_GRID)
	{
		CGridCtrl * pGrid = (CGridCtrl *) pWnd;
		pGrid->SetBkColor(RGB(255,255,255));
		pGrid->Create(objRect, pParent, WS_CHILD | WS_BORDER | WS_TABSTOP);
		pGrid->InsertColumn("");
		int nCol = pGrid->InsertColumn("");
		pGrid->SetColumnWidth(nCol, 50);
		pGrid->InsertRow("");
		pGrid->SetFixedRowCount(1);
		pGrid->SetFixedColumnCount(1);
	}
	else if (nType == CTRL_PANEL)
	{
		
		CPanelControl * pPanel = (CPanelControl *) pWnd;
		pPanel->Create(strCaption, 0, objRect, pParent, 0);
		pPanel->m_strName      = strCaption;
		pPanel->m_nBevelInner  = bvNone;
		pPanel->m_nBevelOuter  = bvRaised;
		pPanel->m_nBevelWidth  = 1;
		pPanel->m_nBevelBorder = 0;
	}

	switch (nType)
	{
		case CTRL_GROUPBOX:
				pWnd->ModifyStyle(WS_GROUP, 0);
				break;


		case CTRL_PROGRESSBAR:

				((CProgressCtrl *) pWnd)->SetRange32(0, 10);
				((CProgressCtrl *) pWnd)->SetPos(7);

				break;
		case CTRL_TABCONTROL:

				((CTabCtrl *) pWnd)->InsertItem(0, "Zakadka 1", 0);
				((CTabCtrl *) pWnd)->InsertItem(1, "Zakadka 2", 0);
				((CTabCtrl *) pWnd)->InsertItem(2, "Zakadka 3", 0);
				((CTabCtrl *) pWnd)->SetCurSel(0);

				break;

		case CTRL_TREECONTROL:

				((CTreeCtrl *) pWnd)->SetImageList(&m_imgList, TVSIL_NORMAL);
				((CTreeCtrl *) pWnd)->SetBkColor(RGB(255,255,255));
				HTREEITEM hItem0;
				hItem0 = ((CTreeCtrl *) pWnd)->InsertItem("Item 0", 0, 0, TVI_ROOT, TVI_SORT);
				((CTreeCtrl *) pWnd)->InsertItem("Item 1", 1, 1, TVI_ROOT, TVI_SORT);
				((CTreeCtrl *) pWnd)->InsertItem("Item 2", 2, 2, TVI_ROOT, TVI_SORT);
				((CTreeCtrl *) pWnd)->InsertItem("Item 0.1", 1, 1, hItem0);
				((CTreeCtrl *) pWnd)->Expand(hItem0, 0);

				break;

		case CTRL_COMBOBOX:

				((CComboBox *) pWnd)->AddString("String 0");
				((CComboBox *) pWnd)->AddString("String 1");
				((CComboBox *) pWnd)->AddString("String 2");
				((CComboBox *) pWnd)->SetTopIndex(0);
				//((CComboBox *) pWnd)->SetCurSel(0);
				pWnd->SetWindowText(m_pTObject->m_strCaption);

				break;

		case CTRL_LISTBOX:

				((CListBox *) pWnd)->AddString("String 0");
				((CListBox *) pWnd)->AddString("String 1");
				((CListBox *) pWnd)->AddString("String 2");
				((CListBox *) pWnd)->SetCurSel(0);

				break;

		case CTRL_PICTURE:
				
				((CStatic *) pWnd)->SetBitmap(m_bmpPicture);

				break;

		case CTRL_MENU:
				
				((CStatic *) pWnd)->SetBitmap(m_bmpMenu);


				break;

		case CTRL_POPUPMENU:
				
				((CStatic *) pWnd)->SetBitmap(m_bmpPopupMenu);


				break;

		case CTRL_LISTCONTROL:

				((CListCtrl *) pWnd)->SetImageList(&m_imgList, LVSIL_NORMAL);
				((CListCtrl *) pWnd)->InsertItem(0, "Item 0", 0);
				((CListCtrl *) pWnd)->InsertItem(1, "Item 1", 1);
				((CListCtrl *) pWnd)->InsertItem(2, "Item 2", 2);

				break;

		case CTRL_IPADDRESS:

				((CIPAddressCtrl *) pWnd)->SetFieldRange(0,0,255);
				((CIPAddressCtrl *) pWnd)->SetFieldRange(1,0,255);
				((CIPAddressCtrl *) pWnd)->SetFieldRange(2,0,255);
				((CIPAddressCtrl *) pWnd)->SetFieldRange(3,0,255);
				((CIPAddressCtrl *) pWnd)->SetAddress(0, 0, 0, 0);
				
				break;

	}

	m_bChange = true;
	
	return pWnd;

}


void CFormCreatorView::UpdateObjInfList(CString & strName, CTObject * pTObject)
{
	for (int i = 1; i < m_pGrdInfObjList->GetRowCount(); i++)
	{
		if (strName == m_pGrdInfObjList->GetItemText(i, 1))
			break;
	}
	m_pGrdInfObjList->SetItemText(i, 1, pTObject->m_strName);
	m_pGrdInfObjList->SetItemText(i, 2, pTObject->m_strInfo);
}

void CFormCreatorView::AddToInfObjList(CTObject * pTObject)
{
	int nRow = m_pGrdInfObjList->InsertRow("");
    
	for (int i = 0; i < 2; i++)
		m_pGrdInfObjList->SetItemState(nRow, i, GVIS_READONLY);

	m_nObjectsCount = 0;
	m_nObjectsCount = GetObjectsCount(&m_objects, m_nObjectsCount);

	m_pGrdInfObjList->SetItemText(nRow, 0, MakeLongNum(m_nObjectsCount));
	m_pGrdInfObjList->SetItemText(nRow, 1, pTObject->m_strName);
	m_pGrdInfObjList->SetItemText(nRow, 2, pTObject->m_strInfo);
	m_pGrdInfObjList->SetSelectedRange(nRow, 0, nRow, 2, TRUE, TRUE);
	m_pGrdInfObjList->RedrawRow(nRow);
	m_pGrdInfObjList->UpdateWindow();

	//m_objGridRect.bottom += m_pGrdInfObjList->GetRowHeight(nRow);
	//m_pGrdInfObjList->MoveWindow(m_objGridRect, true);

}

void CFormCreatorView::AddToObjList(CTObject * pTObject)
{
	int nRow = g_pToolBarPrp->m_grdObjList.InsertRow(pTObject->m_strName);
	g_pToolBarPrp->m_grdObjList.ExpandColumnsToFit(TRUE);
	g_pToolBarPrp->m_grdObjList.SetRowHeight(nRow, 16);
	g_pToolBarPrp->m_grdObjList.SortItems(CGridCtrl::pfnCellTextCompare, 0, true);
	g_pToolBarPrp->m_grdObjList.SetSelectedRange(nRow, 0, nRow, 0, TRUE, TRUE);
	//g_pToolBarPrp->m_grdObjList.RedrawRow(nRow);
	g_pToolBarPrp->m_grdObjList.Refresh();
	g_pToolBarPrp->m_grdObjList.UpdateWindow();

}
void CFormCreatorView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	CScrollView::OnPrepareDC(pDC, pInfo);
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::TestDialog
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Tworzy now formatk, inicjalizuje wszystkie obiekty
	              i przecza j w tryb aktywny.
	Wyjscie    :  void
	Parametry  :
			      bool bStatus	-	niewykorzystywane
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::_TestDialog(CTList<CTObject *> * objects, CWnd * pParent)
{
	objIterator it = objects->last();

	while (it != NULL)
	{
		CWnd * pWnd = AddObject((CTObject *) pParent, it->m_nType, it->m_curRect , false, true, false);
		pWnd->SetWindowText(it->m_strCaption);
		pWnd->ShowWindow(SW_SHOW);

		_TestDialog(&it->m_objects, pWnd);

		--it;
	}

}
void CFormCreatorView::TestDialog(bool bStatus)
{
	CDialog * pDlg;
	
	m_bTestMode = true;

	CTObject * pTDlg = new CTObject;
	pDlg = new CDialog;

	pTDlg->m_pObject = pDlg;

	pDlg->Create(IDD_DIALOG_TEST, GetParent());
	pDlg->MoveWindow(GetDlgScreenRect());

	CTObject * pTObject = m_pTObject;

	_TestDialog(&m_objects, pDlg);
	/* przechodzimy list od koca w celu uniknicia przesonicia si
	   obiektw */
	m_pTObject = pTObject;

	m_bTestMode = false;

	pDlg->ShowWindow(SW_SHOW);

}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::UpdateObjectDescInfo
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Uaktualnia kontolki zawierajce opis obiektu
	Wyjscie    :  void	-	
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::UpdateObjectDescInfo()
{

}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::UpdateObjectPosInfo
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Uaktualnie kontrolki zawierajce pooenie obiektu
	Wyjscie    :  void
	Parametry  :
			      CRect &rect	-	pooenie obiektu
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::UpdateObjectPosInfo(CRect &rect)
{
	CString str;

	str.Format("%d", rect.left);
	g_pToolBarPrp->m_edtPosX.SetWindowText(str);
	str.Format("%d", rect.top);
	g_pToolBarPrp->m_edtPosY.SetWindowText(str);
	str.Format("%d", rect.Width());
	g_pToolBarPrp->m_edtWidth.SetWindowText(str);
	str.Format("%d", rect.Height());
	g_pToolBarPrp->m_edtHeight.SetWindowText(str);
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::UpdateObjectClassInfo
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Uaktualnia list z klasami ktre mona przypisa 
	              obiektowi.
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::UpdateObjectClassInfo()
{
	g_pToolBarPrp->m_cmbType.ResetContent();

	if (m_bDlgSelected)
	{
		g_pToolBarPrp->m_cmbType.EnableWindow(false);
		g_pToolBarPrp->m_cmbType.AddString("TForm");
		g_pToolBarPrp->m_cmbType.SetCurSel(0);
		return;

	}
	else if (m_nObjSelected > 1 || m_nObjSelected == 0)
	{
		g_pToolBarPrp->m_cmbType.EnableWindow(false);
		return;
	}

	g_pToolBarPrp->m_cmbType.EnableWindow(true);

	int i = 0;
	int nObj = m_pTObject->m_nType;

	while (cCtrlInfo[nObj].pClassType[i].strClass)
	{
		g_pToolBarPrp->m_cmbType.AddString(cCtrlInfo[nObj].pClassType[i].strClass);
		i++;
	}

	g_pToolBarPrp->m_cmbType.SetCurSel(m_pTObject->m_nClass);
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::DrawTrackerRect
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Rysuje uchwyty obiektw
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
CFormCreatorView::listPos CFormCreatorView::GetObjectIterator(CTList<CTObject *> * objects, CTObject * pTObject)
{

	objIterator it = objects->begin();
	
	listPos lp;

	lp.it      = NULL;
	lp.objects = NULL;

	while (it != NULL)
	{

		if (*it == pTObject)
		{
			lp.it      = it;
			lp.objects = objects;

			return lp;
		}
		else
		{
			lp = GetObjectIterator(&it->m_objects, pTObject);
			if (lp.it != NULL)
				return lp;
		}
		
		++it;
	}
	
	return lp;

}

void CFormCreatorView::CreateFlatObjects(CTList<CTObject *> * objects)
{
	objIterator it = objects->begin();

	while (it != NULL)
	{
		m_flatObjects.InsBack(*it);
		if (!it->m_objects.IsEmpty())
			CreateFlatObjects(&it->m_objects);
		++it;
	}
}

CTObject * CFormCreatorView::FindNextObject(CTObject * pTObject)
{
	m_flatObjects.RemoveAll();
	CreateFlatObjects(&m_objects);

	objIterator it = m_flatObjects.begin();

	while (it != NULL)
	{
		if (*it == pTObject)
		{
		
			objIterator ittmp = it;
			ittmp--;

			if (ittmp != NULL)
				return *ittmp;

		}

		++it;
	}

	return *m_flatObjects.last();
}

CTObject * CFormCreatorView::FindPrevObject(CTObject * pTObject)
{
	m_flatObjects.RemoveAll();
	CreateFlatObjects(&m_objects);

	objIterator it = m_flatObjects.begin();

	while (it != NULL)
	{
		if (*it == pTObject)
		{
		
			objIterator ittmp = it;
			ittmp++;
			if (ittmp != NULL)
				return *ittmp;
		}

		++it;
	}

	return *m_flatObjects.begin();

}
void CFormCreatorView::_RemoveObjectWithChildren(CTList<CTObject *> * objects)
{
	objIterator it = objects->begin();
	objIterator tmpit;

	while (it != NULL)
	{
	
		if (!it->m_objects.IsEmpty())
			_RemoveObjectWithChildren(&it->m_objects);

		int nRow = FindRowInObjInfList(it->m_strName);
		m_pGrdInfObjList->DeleteRow(nRow);
//		m_pGrdInfObjList->UpdateWindow();

		nRow = FindRowInObjList(it->m_strName);
		g_pToolBarPrp->m_grdObjList.DeleteRow(nRow);
//		g_pToolBarPrp->m_grdObjList.UpdateWindow();

		it->m_pObject->DestroyWindow();
		delete it->m_pObject;
		cCtrlInfo[it->m_nType].nCount--;
		delete *it;

		--m_nCtrlID;
		++it;
	}

	objects->RemoveAll();
}

void CFormCreatorView::RemoveObjectsFromSheet(CTList<CTObject *> * objects, int nPage)
{
	ASSERT(objects != NULL);
	objIterator it = objects->begin();

	while (it != NULL)
	{
		objIterator tmpit = it;
		++tmpit;

		if (it->m_nPage == nPage)
			RemoveObjectWithChildren(*it);

		it = tmpit;
	}

}

void CFormCreatorView::ChangeSheetNumbers(CTList<CTObject *> * objects, int nPage)
{
	objIterator it = objects->begin();

	while (it != NULL)
	{
		if (it->m_nPage > nPage)
			it->m_nPage--;

		++it;
	}

}

void CFormCreatorView::RemoveObjectWithChildren(CTObject * pTObject)
{
	listPos lp = GetObjectIterator(&m_objects, pTObject);

	_RemoveObjectWithChildren(&lp.it->m_objects);

	int nRow = FindRowInObjInfList(lp.it->m_strName);
	m_pGrdInfObjList->DeleteRow(nRow);
//	m_pGrdInfObjList->UpdateWindow();

	nRow = FindRowInObjList(lp.it->m_strName);
	g_pToolBarPrp->m_grdObjList.DeleteRow(nRow);
	g_pToolBarPrp->m_grdObjList.Refresh();
//	g_pToolBarPrp->m_grdObjList.UpdateWindow();


	--m_nCtrlID;
	lp.it->m_pObject->DestroyWindow();
	delete lp.it->m_pObject;
	cCtrlInfo[lp.it->m_nType].nCount--;
	delete *lp.it;
	lp.objects->Remove(lp.it);

	m_bChange = true;
}

CTObject * CFormCreatorView::RemoveSelObjects()
{
	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator tmpit;

	while (it != NULL)
	{
		RemoveObjectWithChildren(*it);

		++it;
	}


	return FindLastObject(&m_objects);

}
CString CFormCreatorView::MakeLongNum(int nNum)
{
	CString strNum;
	CString strNum0 = "";
	
	strNum.Format("%d", nNum);
	int nStrLen = strNum.GetLength();

	int nZeros = MAX(nStrLen, m_nZeros);

	for (int i = 0; i < nZeros; i++)
		strNum0 += "0";
	
	for (i = 0; i < nStrLen; i++)
		strNum0.SetAt(nZeros - i - 1, strNum[nStrLen - i - 1]);

	return strNum0;
}
void CFormCreatorView::UpdateObjInfListNum()
{
	for (int i = 1; i < m_pGrdInfObjList->GetRowCount(); i++)
	{
		m_pGrdInfObjList->SetItemText(i, 0, MakeLongNum(i));
		CTObject * pTObject = FindObjectByName(&m_objects, m_pGrdInfObjList->GetItemText(i, 1));
		pTObject->m_nID = i;
	}
	m_pGrdInfObjList->Refresh();
}

void CFormCreatorView::SelectRowOnObjList(CTObject * pTObject)
{
	static int nLstRow = -1;
	int nRow = FindRowInObjList(pTObject->m_strName);

	if (nRow >= 0)
		g_pToolBarPrp->m_grdObjList.SetSelectedRange(nRow, 0, nRow, 0, TRUE, TRUE);

}
void CFormCreatorView::SelectRowOnObjInfList(CTObject * pTObject)
{
	static int nLstRow = -1;
	int nRow = FindRowInObjInfList(pTObject->m_strName);

	if (nRow >= 0)
	{
		m_pGrdInfObjList->SetSelectedRange(nRow, 0, nRow, 2, TRUE, TRUE);
	}
}


void CFormCreatorView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	unsigned char * key = m_key;
	GetKeyboardState(key);

	if (KEY(VK_RCONTROL) || KEY(VK_LCONTROL))
		m_bControlPressed = true;
	else
		m_bControlPressed = false;
	
	if (KEY(VK_SHIFT))
		m_bShiftPressed = true;
	else
		m_bShiftPressed = false;

	if (m_nObjSelected > 0)
	{

		int nLeft   = 0;
		int nRight  = 0;
		int nTop    = 0;
		int nBottom = 0;

		if (KEY(VK_LEFT))
		{
			if (m_bControlPressed) nLeft = nRight = -1; else
			if (m_bShiftPressed)   nRight = -1;
		}
		if (KEY(VK_RIGHT))
		{
			if (m_bControlPressed) nLeft = nRight = 1; else
			if (m_bShiftPressed)   nRight = 1;
		}
		if (KEY(VK_UP))
		{
			if (m_bControlPressed) nTop = nBottom = -1; else
			if (m_bShiftPressed)   nBottom = -1;
		}
		if (KEY(VK_DOWN))
		{
			if (m_bControlPressed) nTop = nBottom = 1; else
			if (m_bShiftPressed)   nBottom = 1;
		}

		if (nLeft != 0 || nRight != 0 || nTop != 0 || nBottom != 0)
		{
			m_pTracker->StoreObjectsPrevPos();
			m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);
			m_pTracker->UpdateSelObjectsPos(nLeft, nTop, nRight, nBottom);
			m_pTracker->MoveSelObjects(m_pDlg);
			m_pTracker->m_curRect.left   += nLeft;
			m_pTracker->m_curRect.right  += nRight;
			m_pTracker->m_curRect.top    += nTop;
			m_pTracker->m_curRect.bottom += nBottom;
			DrawTrackerRect();

			m_bChange = true;
		}
	}

	if (KEY(VK_TAB) && !m_bDlgSelected && m_nObjectsCount > 0)
	{
		m_pTracker->UpdateSelObjectsBkg(m_pDlg, true);
		
		if (GetAsyncKeyState(VK_SHIFT))
			m_pTObject = FindPrevObject(m_pTObject);
		else
			m_pTObject = FindNextObject(m_pTObject);

		m_pLstTObject = m_pTObject;
	
		SelectObject(m_pTObject);

	}

	if (nChar == VK_ESCAPE && !m_bDlgSelected)
	{
		m_pTracker->UpdateSelObjectsBkg(m_pDlg, true);
		m_pTObject = (m_pTracker->m_selObjects.begin())->m_pTParent;
		m_pLstTObject = m_pTObject;
		m_pTracker->RemoveAllObjects();

		if (m_pTObject == m_pTDlg)
		{
			m_nObjSelected = 0;
			m_bDlgSelected = true;
			m_pTracker->m_bDlgSelected = true;
			m_pTracker->m_curRect = GetDlgScreenRect();

		}
		else
		{
			m_pTracker->AddObject(m_pTObject);
			m_nObjSelected = 1;
		}

		DrawTrackerRect();
		UpdateObjectCaptionInfo();
		UpdateObjectClassInfo();
		UpdateObjectNameInfo();
		UpdateObjectPosInfo(m_pTracker->m_curRect);

	
	}

	if (nChar == VK_DELETE)
	{
		if (!m_pTracker->m_selObjects.IsEmpty())
		{
			
			CRect selRect = m_pTracker->CalcDragRect(m_pTracker->m_curRect);
			if (m_bShowNumbers) m_pTracker->InvalidateNumRects(&m_pTracker->m_selObjects, &selRect);

			m_pTObject = RemoveSelObjects();
			m_pTracker->RemoveAllObjects();

			m_pDlg->InvalidateRect(selRect, true);
			m_pDlg->UpdateWindow();

			UpdateObjInfListNum();
			SelectObject(m_pTObject);

		}
	}

	if (nChar == VK_F12)
	{
		OnTbSwitchwindow();
	}

	CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CFormCreatorView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CScrollView::OnKeyUp(nChar, nRepCnt, nFlags);
}

void CFormCreatorView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();

	
	m_pDlg = new CTemplateDialog;
	m_pDlg->Create(IDD_DIALOG_TEMPLATE, this);

	m_pDlg->MoveWindow(10, 10, 690, 400, false);

	m_dlgRect = GetDlgScreenRect();
			
	CRect rect = GetDlgScreenRect();

	m_pTracker = new CMultiRectTracker;

	m_pTracker->SetRect(m_pTracker->CalcDragRect(rect));

	GetDlgBorderSize();

	m_pDlg->GetClientRect(&rect);

	g_pToolBarPrp->m_edtCaption.SetWindowText("Formatka");
	g_pToolBarPrp->m_edtName.SetWindowText("TForm1");
	UpdateObjectPosInfo(m_dlgRect);
	UpdateObjectClassInfo();
	
	m_pTracker->SetGrid(1, 1);
	m_pTracker->m_pParent = (CWnd *) m_pDlg;
	
	GetParent()->GetWindowText(m_strFileName);

	m_bDlgSelected = true;
	m_pTracker->m_bDlgSelected = true;

	m_pTDlg = new CTObject;

	m_pTDlg->m_pTParent    = m_pTDlg;
	m_pTDlg->m_pObject     = (CWnd *) m_pDlg;
	m_pTDlg->m_nBorderLeft = 0;
	m_pTDlg->m_nBorderTop  = 0;
	m_pTDlg->m_nPage       = -1;
	m_pTDlg->m_nCurPage    = -1;
	m_pTDlg->m_strCaption  = "Formatka";
	m_pTDlg->m_strName     = "TForm1";

	m_pGrdInfObjList = new CGridCtrl;

	m_objGridRect.SetRect(10, m_dlgRect.bottom + 10, 700, m_dlgRect.bottom + 10);
	m_pGrdInfObjList->Create(m_objGridRect, this, IDC_OBJINFLISTGRID, WS_CHILD | WS_VSCROLL);
	m_pGrdInfObjList->SetBkColor(RGB(255,255,255));

	m_pGrdInfObjList->SetDoubleBuffering(true);
	m_pGrdInfObjList->SetTrackFocusCell(false);
	m_pGrdInfObjList->SetFrameFocusCell(false);
	m_pGrdInfObjList->SetDefCellHeight(16);
	m_pGrdInfObjList->InsertColumn("Numer");
	m_pGrdInfObjList->InsertColumn("Nazwa obiektu");
	m_pGrdInfObjList->InsertColumn("Opis");
	m_pGrdInfObjList->SetColumnWidth(0, 50);
	m_pGrdInfObjList->SetColumnWidth(1, 100);
	int nScrollWidth = GetSystemMetrics(SM_CXVSCROLL);
	m_pGrdInfObjList->SetColumnWidth(2, 536 - nScrollWidth);
	m_pGrdInfObjList->SetFixedRowCount(1);
	m_pGrdInfObjList->SetListMode(true);
	m_pGrdInfObjList->SetSingleRowSelection(true);
	m_pGrdInfObjList->EnableSelection(TRUE);
	m_pGrdInfObjList->SetHeaderSort();
	m_pGrdInfObjList->SetSortColumn(0);
	
	
	CGridCellBase * pCell =  m_pGrdInfObjList->GetCell(0,0);
	pCell->SetBackClr(RGB(245,214,33));
	pCell =  m_pGrdInfObjList->GetCell(0,1);
	pCell->SetBackClr(RGB(220,220,0));
	pCell =  m_pGrdInfObjList->GetCell(0,2);
	pCell->SetBackClr(RGB(220,220,0));

	m_objGridRect.bottom += 403;//m_pGrdInfObjList->GetRowHeight(0) + 4;

	ResetScrollBars();

	m_pGrdInfObjList->MoveWindow(m_objGridRect);

    m_pDlg->ShowWindow(SW_SHOWNORMAL);
	//m_pDlg->SetRedraw(FALSE);
    m_pGrdInfObjList->ShowWindow(SW_SHOWNORMAL);


}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::FileFindString
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Szuka cigu str w pliku file
	Wyjscie    :  bool	-	true - jeli cig zosta znaleziony
	Parametry  :
			      CFile & file	-	uchwyt pliku
			      char * str	-	szukany cig znakw
	Note       :
\*----------------------------------------------------------------------*/
bool CFormCreatorView::FileFindString(CFile & file, char * str)
{
	CString strTmp("");

	int nLength = strlen(str);
	int i = 0;
	char chChar;

	while (file.Read(&chChar, 1))
	{
		if (i < nLength)
		{
			if (chChar == str[i])
				i++;
			else
				i = 0;
		}
		else
			return true;
	}

	return false;
}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::FileReadString
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Czyta pierwszy napotkany cig znakw, omijajc
	              najpierw wszystkie znaki zawarte w tablicy chSMarks
	Wyjscie    :  CString	-	odczytany cig znakw
	Parametry  :
			      CFile & file	-	uchwyt pliku
	Note       :
\*----------------------------------------------------------------------*/

CString CFormCreatorView::FileReadString(CFile & file)
{
	char  chSMarks[] = {' ', '\'', ':', '=', '<', '>',13,10};
	const ciMaxSMark = 8;
	int   nRead;
	char  chChar;

	CString strTmp("");

	bool bSMark;

	bool bStart = false;
	bool bEnd   = false;

	char chStart = '\0';
	char chEnd   = '\0';

	while ((nRead = file.Read(&chChar, 1)))
	{
		bSMark = false;

		for (int i = 0; i < ciMaxSMark; i++)
			if (chChar == chSMarks[i])
			{
				if (bStart)
				{
					chEnd = chChar;
					bEnd = true;
				}
				else
					chStart = chChar;

				bSMark = true;

				break;
			}

		if (!bSMark || chChar == '\'')
			bStart = true;

		if (bStart)
		{
			if (chStart == '\'' && chEnd != '\'')
				bEnd = false;
			if (bEnd)
				break;
			else if (chChar != '\'')
				strTmp += chChar;
		}

	}

	if (nRead == 0)
		strTmp = "EndOfFile";

	return strTmp;
}

void CFormCreatorView::ShowObjectProperties(CTObject * pTObject)
{
	if (!m_pTObject)
		return;

	if (m_pTObject->m_nType == CTRL_GRID)
	{
		CGridCtrl * pWnd = (CGridCtrl *) m_pTObject->m_pObject;
		
		int nColCount = pWnd->GetColumnCount();

		CColumnInfo * pCols = new CColumnInfo[nColCount];

		for (int i = 0; i < nColCount; i++)
		{
			pCols[i].nWidth = pWnd->GetColumnWidth(i);
			pCols[i].strName = pWnd->GetItemText(0, i);
			pCols[i].nCol = i;
		}

		CColumnsDialog dlg;
		dlg.m_pGrid = (CGridCtrl *) m_pTObject->m_pObject;
		dlg.m_wndRect = GetObjectRealRect(m_pTObject);
		dlg.m_pParent = m_pDlg;
		int nRes = dlg.DoModal();

		if (nRes == IDCANCEL)
		{
			pWnd->DeleteAllItems();

			for (i = 0; i < nColCount; i++)
			{
				pWnd->InsertColumn(pCols[i].strName);
				pWnd->SetColumnWidth(pCols[i].nCol, pCols[i].nWidth);
			}
			pWnd->InsertRow("");
			pWnd->SetFixedRowCount(1);
			pWnd->SetFixedColumnCount(1);

		}
		delete [] pCols;
	}
	else
	if (m_pTObject->m_nType == CTRL_PANEL)
	{
		CPanelControl * pPanel = (CPanelControl *) m_pTObject->m_pObject;
		CPanelControlDialog dlg;
		dlg.m_nCmbBvInnerPos = pPanel->m_nBevelInner;
		dlg.m_nCmbBvOuterPos = pPanel->m_nBevelOuter;	
		CString str;
		str.Format("%d", pPanel->m_nBevelBorder);
		dlg.m_strBvBorder = str;
		str.Format("%d", pPanel->m_nBevelWidth);
		dlg.m_strBvWidth  = str;
		int nRes = dlg.DoModal();

		if (nRes == IDOK)
		{
			pPanel->m_nBevelBorder = atoi(dlg.m_strBvBorder);
			pPanel->m_nBevelWidth  = atoi(dlg.m_strBvWidth);
			pPanel->m_nBevelInner  = dlg.m_nBvInner;
			pPanel->m_nBevelOuter  = dlg.m_nBvOuter;

			pPanel->Invalidate(true);
		}
	}
	else
	if (m_pTObject->m_nType == CTRL_COMBOBOX)
	{
		CListItemsDialog dlg;

		CString strItem;
		
		CComboBox * pWnd = (CComboBox *) m_pTObject->m_pObject;

		for (int i = 0; i < pWnd->GetCount(); i++)
		{
			pWnd->GetLBText(i, strItem);
			dlg.m_strings.InsBack(strItem);
		}

		dlg.DoModal();

		pWnd->ResetContent();

		CTList<CString>::iterator it = dlg.m_strings.begin();
		while (it != NULL)
		{
			pWnd->AddString(*it);
			++it;
		}

		pWnd->SetWindowText(m_pTObject->m_strCaption);
	}
	else
	if (m_pTObject->m_nType == CTRL_LISTBOX)
	{
		CListItemsDialog dlg;

		CString strItem;
		
		CListBox * pWnd = (CListBox *) m_pTObject->m_pObject;

		for (int i = 0; i < pWnd->GetCount(); i++)
		{
			pWnd->GetText(i, strItem);
			dlg.m_strings.InsBack(strItem);
		}

		dlg.DoModal();

		pWnd->ResetContent();

		CTList<CString>::iterator it = dlg.m_strings.begin();
		while (it != NULL)
		{
			pWnd->AddString(*it);
			++it;
		}

		pWnd->SetCurSel(0);

	}
	else
	if (m_pTObject->m_nType == CTRL_LISTCONTROL)
	{
	}
	else
	if (m_pTObject->m_nType == CTRL_TREECONTROL)
	{
	}
	else
	if (m_pTObject->m_nType == CTRL_MENU || m_pTObject->m_nType == CTRL_POPUPMENU)
	{
		CTreeCtrl * pMenu = (CTreeCtrl *) m_pTObject->m_pObject;

		CMenuDialog dlg;

		dlg.DoModal();

	}
	else
	if (m_pTObject->m_nType == CTRL_TABCONTROL)
	{
		CTabCtrl * pTabCtrl = (CTabCtrl *) m_pTObject->m_pObject;
		int nPages = pTabCtrl->GetItemCount();
		int nCurSel = pTabCtrl->GetCurSel();
		
		CString * pStrSheetsName = NULL;
		if (nPages > 0)
			pStrSheetsName = new CString[nPages];

		char strItemName[256];
		TCITEM item;
		item.mask = TCIF_TEXT;
		item.cchTextMax = 256;
		item.pszText = strItemName;
		
		for (int i = 0; i < nPages; i++)
		{
			memset(strItemName, 0, 256);
			pTabCtrl->GetItem(i, &item);
			pStrSheetsName[i] = strItemName;
		}


		CTabDialog dlg;
		dlg.m_pTabCtrl = pTabCtrl;
		dlg.pView = this;
		int nRes = dlg.DoModal();

		if (nRes == IDCANCEL)
		{
			pTabCtrl->DeleteAllItems();

			for (int i = 0; i < nPages; i++)
				pTabCtrl->InsertItem(i, pStrSheetsName[i],0);

			pTabCtrl->SetCurSel(nCurSel);
			m_pDlg->UpdateWindow();
			DrawNumbers();

		}

		delete [] pStrSheetsName;

	}

}

void CFormCreatorView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{

	ShowObjectProperties(m_pTObject);

	CScrollView::OnLButtonDblClk(nFlags, point);
}

void CFormCreatorView::RemoveAllObjects()
{

	m_pTracker->RemoveAllObjects();
	objIterator it = m_objects.begin();
	
	while (it != NULL)
	{
		objIterator it0 = it;
		++it0;
		RemoveObjectWithChildren(*it);
		it = it0;
	}
	m_objects.RemoveAll();
		
}
int CFormCreatorView::GetObjectsCount(CTList<CTObject *> * objects, int & nCount)
{

	objIterator it = objects->begin();

	while (it != NULL)
	{
		GetObjectsCount(&it->m_objects, nCount);
		++nCount;
		++it;
	}

	return nCount;
}
void CFormCreatorView::OnTbSwitchwindow() 
{
	CWnd * pWnd = FindWindow(_T("TF_UMLAppMainForm"), NULL);
	if (!pWnd)
	{
		AfxMessageBox("Aplikacja 'Edytor Formatek' nie jest uruchomiona");
		return;
	}

	CFile file;

	BOOL bOpened = file.Open(m_strAppPath + "Temp\\FCFile.tmp" , CFile::modeWrite | CFile::modeCreate | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd zapisu do pliku");
		return;
	}

	TFCHeaderBuffer hdrBuffer;
	memset(&hdrBuffer, 0, sizeof(TFCHeaderBuffer));
	strcpy(hdrBuffer.sStateID, (LPCSTR) m_strGuid);
	hdrBuffer.nObjCount = 0;
	hdrBuffer.nObjCount = GetObjectsCount(&m_objects, hdrBuffer.nObjCount);
	hdrBuffer.nLeft = -1;
	hdrBuffer.nTop  = -1;
	hdrBuffer.nWidth = m_dlgRect.Width();
	hdrBuffer.nHeight = m_dlgRect.Height();

	file.Write(&hdrBuffer, sizeof(TFCHeaderBuffer));

	TMP_SaveObjects(file, &m_objects);

	file.Close();

	pWnd->SendMessage(WM_APP + 10001, 0, 0);
}

void CFormCreatorView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_bPopUpMenu = true;

	bool bIsPointIn = CheckSelection();
	
	if (!bIsPointIn)
		bIsPointIn = CheckObject(point);

	if (bIsPointIn)
	{
		CMenu menu;
		menu.LoadMenu(IDR_MENU_RIGHT);
		CPoint pnt(point);
		ClientToScreen(&pnt);

		CMenu * pPopUpMenu = menu.GetSubMenu(0);

		DrawTrackerRect();
		UpdateObjectNameInfo();
		UpdateObjectCaptionInfo();
		UpdateObjectClassInfo();

		pPopUpMenu->EnableMenuItem(ID_MENU1_PROPERTIES, true);

		if (m_nObjSelected == 1)
		{
	
			if (m_pTObject->m_nType == CTRL_GRID ||
				m_pTObject->m_nType == CTRL_TABCONTROL ||
				m_pTObject->m_nType == CTRL_COMBOBOX ||
				m_pTObject->m_nType == CTRL_LISTBOX ||
				m_pTObject->m_nType == CTRL_PANEL ||
				m_pTObject->m_nType == CTRL_MENU ||
				m_pTObject->m_nType == CTRL_POPUPMENU)

				pPopUpMenu->EnableMenuItem(ID_MENU1_PROPERTIES, false);

			UpdateObjectPosInfo(m_pTObject->m_curRect);
		}
		else if (m_nObjSelected > 1)
			UpdateObjectPosInfo(m_pTracker->m_curRect);

		
		pPopUpMenu->TrackPopupMenu(TPM_RIGHTBUTTON | TPM_LEFTALIGN, pnt.x, pnt.y, this);
	}


	m_bPopUpMenu = false;
	
	CScrollView::OnRButtonDown(nFlags, point);
}


void CFormCreatorView::OnHelpContent() 
{

	UINT ret = WinExec("hh.exe " + m_strAppPath + "\\FormCreator.chm", SW_SHOWNORMAL);
	if (ret <= 31)
		AfxMessageBox("Nie mog otworzy pliku pomocy");
}



void CFormCreatorView::OnPaint() 
{
	
CPaintDC dc(this); // device context for painting
/*CRect rcPaint = dc.m_ps.rcPaint;
CBitmap bmp;
bmp.CreateCompatibleBitmap( &dc, rcPaint.Width(), rcPaint.Height() );
CDC newDC;
newDC.CreateCompatibleDC( &dc );
CBitmap *pOld = newDC.SelectObject( &bmp );
newDC.SetViewportOrg( -rcPaint.left, -rcPaint.top );
OnPrepareDC( &newDC );
OnDraw( &newDC );
VERIFY( dc.BitBlt( rcPaint.left, rcPaint.top, rcPaint.Width(), rcPaint.Height(), &newDC, rcPaint.left, rcPaint.top, SRCCOPY ) );*/
//SelectObject( newDC, pOld );	
}

void CFormCreatorView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
//	Invalidate(TRUE);
	//DrawTrackerRect();
	
	CScrollView::OnHScroll(nSBCode, nPos, pScrollBar);
	//DrawTrackerRect();
	//Invalidate(TRUE);
}

void CFormCreatorView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	//Invalidate(TRUE);
	//DrawTrackerRect();
	
	CScrollView::OnVScroll(nSBCode, nPos, pScrollBar);
	//DrawTrackerRect();
	//Invalidate(TRUE);
}

