// GuzikView.h : interface of the CFormCreatorView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GUZIKVIEW_H__6C129010_E1EB_4343_9332_EB2D786EDC7B__INCLUDED_)
#define AFX_GUZIKVIEW_H__6C129010_E1EB_4343_9332_EB2D786EDC7B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DialogTemplate.h"
#include "TObject.h"
#include "MultiRectTracker.h"
#include "ToolBarControls.h"
#include "GridCtrl/GridCtrl.h"
#include "CTList.h"

const bool UPD_ALLOBJECTS = false;
const bool UPD_SELOBJECTS = true;
const bool UPD_CURPOS = true;
const bool UPD_OLDPOS = false;

const int  FIND_LAST = 1;
const int  FIND_SELECTED = 0;
const bool FIND_CHECKOBJECTFRAME = true;
const bool FIND_CHECKALLOBJECT = false;

#ifdef _DEBUG
#define ONDEBUG(str) cout << str << endl;
#else
#define ONDEBUG(str)
#endif
#define ABS(x) (x) < 0 ? -(x) : (x)
#define MIN(x,y) ((x) < (y) ? (x) : (y))
#define MAX(x,y) ((x) < (y) ? (y) : (x))
#define KEY(key) m_key[key] & 0x80

#define MAXID 1000
#define MAXSTR 500

#define WM_UPDATEDIALOG (WM_USER + 10001)
class CFormCreatorView : public CScrollView
{
protected: // create from serialization only
	CFormCreatorView();
	DECLARE_DYNCREATE(CFormCreatorView)

// Attributes
public:

	CFormCreatorDoc* GetDocument();

	typedef CTList<CTObject *>::iterator objIterator;
	
	struct listPos
	{
		objIterator it;
		CTList<CTObject *> * objects;
	};

	struct CColumnInfo 
	{
		int nCol;
		int nWidth;
		CString strName;

	};

	struct CSubStr
	{
		CString m_str;
		int nPosX;

	} m_subStr[MAXSTR];

	struct TFCObjBuffer 
	{
		 char sObjID[41];
		 char sObjPrnID[41];
		 char sObjType[16];
		 char sObjName[16];
		 char sObjCaption[2049];
		 char sObjState[32];
		 char sObjDescr[256];

		 int nObjPosX;
		 int nObjPosY;
		 int nObjWidth;
		 int nObjHeight;

//		 char cActive;    // 1,0 
	};
	struct TFCHeaderBuffer 
	{
 	     char sStateID[41];
		 int nLeft;
		 int nTop;
		 int nWidth;
		 int nHeight;
 		 int nObjCount;    
		 // -1 - nowe okno
	};



	listPos GetObjectIterator(CTList<CTObject *> * objects, CTObject * pTObject);

	CRect   GetDlgScreenRect();
	CRect   GetTotalClipRect();
	void    GetDlgBorderSize();
	
	CRect   GetObjectRect(CTObject * pTObject, CRect & rect);
	CRect   GetObjectRealRect(CTObject * pTObject, CRect & rect);
	CRect   GetObjectRealRect(CTObject * pTObject);

	void	AddChildObjects(CTObject * pTPParent, CTObject * pTParent, CTList<CTObject *> * objects, int nDepth);
	void	CopyObject(CTObject * pTParent, CTObject * pTObject, CRect rect);


	CWnd  * AddObject(CTObject * pTParent, int nType, CRect & objRect, bool bCreateTObject, bool bCreateObject, bool bUpdateTracker, DWORD dwFlags = 0, DWORD dwFlagsEx = 0);
	void    _RemoveObjectWithChildren(CTList<CTObject *> * objects);
	void    RemoveObjectWithChildren(CTObject * pTObject);
	void	RemoveObjectsFromSheet(CTList<CTObject *> * objects, int nPage);
	void    RemoveAllObjects();

	void	ChangeSheetNumbers(CTList<CTObject *> * objects, int nPage);

	void    AddToInfObjList(CTObject * pTObject);
	void	AddToObjList(CTObject * pTObject);

	CPoint  PointToDlg(CPoint & point);
	bool    PointIn(CPoint &p, CRect &r);
	bool    PointInDlgObject(CPoint & point,  CRect & rect);
	bool    PointInDlgObjectFrame(CPoint &point, CRect & rect);
	bool    RectInRect(CRect & rect0, CRect & rect1);
	bool    IntersectRect(CRect & rect0, CRect & rect1);

	void    InsertObject(CPoint & point);
	bool    CheckObject(CPoint & point);
	bool    CheckSelection();
	bool    CheckRubberband(CPoint & point);
	bool    CheckDialog(CPoint & point);
	bool    CheckPageControl(CPoint point);

	void    TestDialog(bool bStaus);
	void	_TestDialog(CTList<CTObject *> * objects, CWnd * pParent);
	
	void    MoveSelObjects();

	void    ScaleObjects(CTList<CTObject *> * objects);
	void	_ScaleObjects(CTList<CTObject *> * objects, float fdx, float fdy);

	void    UpdateObjectPos();
	void    UpdateObjectDescInfo();
	void    UpdateObjectNameInfo();
	void    UpdateObjectCaptionInfo();
	void    UpdateObjectPosInfo(CRect &rect);
	void    UpdateObjectClassInfo();
	void    UpdateObjInfList(CString & strName, CTObject * pTObject);
	void    UpdateObjInfListNum();

	void	SelectRowOnObjInfList(CTObject * pTObject);
	void	SelectRowOnObjList(CTObject * pTObject);

	void	SelectObject(CTObject * pTObject);

	int	    JustifyString(CDC * pDC, int nMaxStr, int nColWidth);
	int     SubstractString(CString  & str);
	void    DrawTrackerRect();
	void    DrawGrid(CRect rect, DWORD color = RGB(100, 100, 100));
	void    DrawA4Page(CDC * pDC);
	void    EraseDlgDragRect();
	void    DrawNumbers();
	//! \brief Rysuje numerki na kontrolkach
	void    _DrawNumbers(CDC * pDC,						//!<Wskanik na kontekst urzdzenia
						 CDC * pMemDC,					//!<Wskanik na tymczasowy bufor graficzny (DIB)
						 CTList<CTObject *> * objects,  //!<Lista obiektw, dla ktrych maj by narysowane numerki
						 int & nNum						//!<Ostatni narysowany numerek
						 );
	
	void    DrawInfo(CDC * pDC);
	void    _DrawInfo(CDC * pDC, float & fPosY, int & cNum, int nCountColLeft, int nNameColLeft, int nInfoColLeft, int nInfoColWidth, CTList<CTObject *> * objects);

	void    ChangeGridSize(int nGridX, int nGridY);

	void    OnFilePrintPreview();
	void    ComputePrintSizes(CDC *pDC,  CPrintInfo* pInfo);

	bool    FileFindString(CFile & file, char * str);
	CString FileReadString(CFile & file);

	bool    DFM_LoadObjects(CFile & file, CTObject * pTObject);
	bool    DFM_LoadObject(CFile & file, CTObject * pTObject, bool bObject);
	bool    DFM_AddObject(CTObject * pTObject, CString & strClass, CString & strCaption, int nLeft, int nTop, int nWidth, int nHeight, bool bCreateObject);
	bool	DFM_SaveObjects(CFile &file, CTList<CTObject *> * objects, CString strSpaces0, CString strSpaces1, int nPage);
	bool    DFM_SaveHeader(CFile & file, CTList<CTObject *> * objects);
	bool    LoadDFM(CFile &file);
	
	void	SetFileExt(CString & strFilename, CString strExt);

	void    FORM_LoadObjects(CFile & file, CTObject * pTParent);
	void	FORM_SaveObjects(CFile & file, CTList<CTObject *> * objects);

	void    TMP_SaveObjects(CFile & file, CTList<CTObject *> * objects);
	void    TMP_LoadObjects(CFile & file);
	bool    TMP_AddObject(TFCObjBuffer * pObjBuffer);

	void	HTML_Save(CFile & file);

	int     GetObjectType(CString & strClass);
	int     GetObjectClass(CString & strClass);

	void    UpdateDialog();

	CString MakeObjectName(int nType);
	void    FillObjectsID(CTList<CTObject *> * objects, CString & strName, int nType);

	void	OnObjListClick(NMHDR *pNotifyStruct, LRESULT* /*pResult*/);

	int     GetObjectsCount(CTList<CTObject *> * objects, int & nCount);
	

	void    OnObjInfListClick(NMHDR *pNotifyStruct, LRESULT* /*pResult*/);

	int     FindRowInObjInfList(CString & strName);
	int		FindRowInObjList(CString & strName);
	
	void    ResetScrollBars();

	
	CTObject * FindPrevObject(CTObject * pTObject);
	CTObject * FindNextObject(CTObject * pTObject);
	CTObject * FindObjectByName(CTList<CTObject *> * objects, CString & strName);
	CTObject * FindObjectByGuid(CTList<CTObject *> * objects, CString & strGuid);
	CTObject * FindLastObject(CTList<CTObject *> * objects);
	CTObject * FindObject(CTList<CTObject *> * objects, CPoint & point, bool bCheckObjectFrame = true);
	CTObject * RemoveSelObjects();
	
	void	CreateFlatObjects(CTList<CTObject *> * objects);

	CString MakeLongNum(int nNum);
	
	void ShowObjects(int nPage, CTList<CTObject *> * objects);
	void ShowAllObjects(int nPage, CTList<CTObject *> * objects);
	void ShowObjectProperties(CTObject * pTObject);

	CTList<CTObject *>     m_objects;
	CTList<CTObject *>     m_selObjects;
	CTList<CTObject *>     m_flatObjects;
	CTList<TFCObjBuffer *> m_objBuffer;

	CMultiRectTracker * m_pTracker;
	CTObject          * m_pTDlg;
	CTemplateDialog   * m_pDlg;
	CTObject          * m_pTObject;
	CTObject          * m_pLstTObject;

	CGridCtrl * m_pGrdInfObjList;
	CRect       m_objGridRect;

	int * m_pObjectsID;
	bool m_bInsert;
	bool m_bDrawDragRect;
	bool m_bObjChange;
	bool m_bShiftPressed;
	bool m_bControlPressed;
	bool m_bDlgSelected;
	bool m_bSaved;
	bool m_bChange;
	bool m_bGetFileName;
	bool m_bTestMode;
	bool m_bShowGrid;
	bool m_bSnapToGrid;
	bool m_bShowNumbers;
	bool m_bPopUpMenu;

	int  m_nObjSelected;
	int  m_nCtrlID;
	int  m_nObjType;

	int  m_nHitTest;

	int  m_nGridX;
	int  m_nGridY;
	int  m_nBorderX;
	int  m_nBorderY;

	int  m_nTotalViewX;
	int  m_nTotalViewY;

    int  m_PrintHeader;
	int  m_PrintFooter;
    int  m_nColPages;      
    int  m_nRowPages;

	int  m_nZeros;

	int  m_nObjectsCount;

	int  m_objectsID[MAXID];

	unsigned char m_key[256];

	CImageList   m_imgList;
	CBitmap    * m_pBitmap;
	CDC        * m_pMemDC;
	CDC        * m_pDC;

	LOGFONT lf;

	CRect  m_clpRect;
	CRect  m_dlgRect;
	CRect  m_trkRect;

	HFONT hfont;

	CFont fontBold;
	CFont fontItalic;
	CFont fontNormal;

	CString m_strDlgInfo;
	CString m_strFileName;
	CString m_strAppPath;
	CString m_strGuid;
	CString m_strDlgName;

	CBitmap m_bmpMenu;
	CBitmap m_bmpPopupMenu;
	CBitmap m_bmpPicture;
	CBitmap * m_pBmpNumber;

	int m_nTabLeft;
	int m_nTabRight;
	int m_nTabTop;

		
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFormCreatorView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFormCreatorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:

// Generated message map functions
public:
	//{{AFX_MSG(CFormCreatorView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnTbButton();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTbTextbox();
	afx_msg void OnTbCheckbutton();
	afx_msg void OnTbRadiobutton();
	afx_msg void OnTbStatictext();
	afx_msg void OnTbGroupbox();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnTbVscrollbar();
	afx_msg void OnTbHscrollbar();
	afx_msg void OnTbListbox();
	afx_msg void OnTbPicture();
	afx_msg void OnTbProgressbar();
	afx_msg void OnTbSlider();
	afx_msg void OnTbTabcontrol();
	afx_msg void OnTbTreecontrol();
	afx_msg void OnTbCombobox();
	afx_msg void OnTbTestmode();
	afx_msg void OnTbListcontrol();
	afx_msg void OnTbSpin();
	afx_msg void OnTbIpaddress();
	afx_msg void OnTbHotkey();
	afx_msg void OnTbDatetimepicker();
	afx_msg void OnTbAlgnobjleft();
	afx_msg void OnTbAlgnobjright();
	afx_msg void OnTbAlgnobjtop();
	afx_msg void OnTbAlgnobjbottom();
	afx_msg void OnTbCenterv();
	afx_msg void OnTbCenterh();
	afx_msg void OnTbGrid();
	afx_msg void OnTbSamesizev();
	afx_msg void OnTbSamesizeh();
	afx_msg void OnTbSamesizevh();
	afx_msg void OnTbSpacev();
	afx_msg void OnTbSpaceh();
	afx_msg void OnTbCalendar();
	afx_msg void OnTbRichedit();
	afx_msg void OnTbSgrid();
	afx_msg void OnFileOpen();
	afx_msg void OnGridUser();
	afx_msg void OnGrid0();
	afx_msg void OnGrid1();
	afx_msg void OnGrid2();
	afx_msg void OnGrid3();
	afx_msg void OnGrid4();
	afx_msg void OnUpdateGrid0(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGrid1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGrid2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGrid3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGrid4(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGridUser(CCmdUI* pCmdUI);
	afx_msg void OnFileSaveAs();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditCut();
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnFileImportDfm();
	afx_msg void OnFileExportDfm();
	afx_msg void OnTbPanel();
	afx_msg void OnFileSavehtml();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnTbSwitchwindow();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMenu1Activ();
	afx_msg void OnMenu1Aligntoleft();
	afx_msg void OnMenu1Aligntoright();
	afx_msg void OnMenu1Aligntotop();
	afx_msg void OnMenu1Aligntobottom();
	afx_msg void OnMenu1Centerh();
	afx_msg void OnMenu1Centerv();
	afx_msg void OnMenu1Samesizeh();
	afx_msg void OnMenu1Samesizev();
	afx_msg void OnMenu1Samesizevh();
	afx_msg void OnMenu1Spaceh();
	afx_msg void OnMenu1Spacev();
	afx_msg void OnMenu1Switchapp();
	afx_msg void OnHelpContent();
	afx_msg void OnTbButtonedit();
	afx_msg void OnMenu1Properties();
	afx_msg void OnFileSave();
	afx_msg void OnTbMenu();
	afx_msg void OnTbPopupmenu();
	afx_msg void OnPaint();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnUserMessage(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTbSnap();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GuzikView.cpp
inline CFormCreatorDoc* CFormCreatorView::GetDocument()
   { return (CFormCreatorDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GUZIKVIEW_H__6C129010_E1EB_4343_9332_EB2D786EDC7B__INCLUDED_)
