#include "stdafx.h"
#include "FormCreator.h"
#include "Globals.h"

#include "GridCtrl/GridCtrl.h"
#include "Console.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include "MultiRectTracker.h"
#include "ToolbarControls.h"

#include "DialogGrid.h"
#include "DialogTemplate.h"
#include "ColumnsDialog.h"

#include "TObject.h"
#include "PanelControl.h"

#include "TransparentWindow.h"
#include "math.h"
#include <afxrich.h>

#include <iostream>
using namespace std;

/*--------------------------------------------------------------------------------------*/
int  CFormCreatorView::GetObjectType(CString & strClass)
{
	int i = 0;
	while (i < CTRL_MAX)
	{
		CClassInfo * pClassType = cCtrlInfo[i].pClassType;
		
		int j = 0;
		while (pClassType[j].strClass)
		{
			if (strClass == pClassType[j].strClass)
				return i;

			j++;
		}
		i++;
	}

	return -1;

}
/*--------------------------------------------------------------------------------------*/
int CFormCreatorView::GetObjectClass(CString & strClass)
{
	int i = 0;
	while (i < CTRL_MAX)
	{
		CClassInfo * pClassType = cCtrlInfo[i].pClassType;
		
		int j = 0;
		while (pClassType[j].strClass)
		{
			if (strClass == pClassType[j].strClass)
				return j;

			j++;
		}
		i++;
	}

	return -1;

}
/*--------------------------------------------------------------------------------------*/

bool g_bFirstObject = true;

bool CFormCreatorView::DFM_AddObject(CTObject * pTObject, CString & strClass, CString & strCaption, int nLeft, int nTop, int nWidth, int nHeight, bool bCreateObject)
{

        if (g_bFirstObject)
        {
                m_pDlg->SetWindowPos(NULL, 20, 20, nWidth, nHeight, 0);
                m_pDlg->SetWindowText(strCaption);

                g_bFirstObject = false;

                m_pTObject = m_pTDlg;

                return true;
        }
        

        int nCtrlType = GetObjectType(strClass);

        if (nCtrlType >= 0)
        {       

				CRect wndRect = CRect(nLeft, nTop, nLeft + nWidth, nTop + nHeight);
                CWnd * pWnd = AddObject(pTObject, nCtrlType, wndRect, true, bCreateObject, false);

                m_pTObject->m_strCaption = strCaption;
                m_pTObject->m_strInfo = "";
                m_pTObject->m_nClass  = GetObjectClass(strClass);

				m_pTObject->m_curRect = wndRect;
				m_pTObject->m_oldRect = wndRect;

				if (bCreateObject)
				{			
					pWnd->SetWindowText(strCaption);
					pWnd->ShowWindow(SW_SHOW);
				}

                return true;
        }

        return false;

}

bool CFormCreatorView::DFM_LoadObject(CFile & file, CTObject * pTObject, bool bObject)
{
        int nLeft, nTop;
        int nWidth, nHeight;


        CString strToken = "";
        CString strCaption = "";
        CString strBevelOuter;
        CString strBevelInner;

        CString strName;
        CString strClass;


		bool bEnd    = false;
		bool bFirst  = true;

		bool bCreated = false;

		strName  = FileReadString(file);
		strClass = FileReadString(file);

        while ((strToken = FileReadString(file)) != "")
        {             

                if (strToken == "Left")       nLeft         = atoi(FileReadString(file));
                if (strToken == "Top")        nTop          = atoi(FileReadString(file));
                if (strToken == "Width")      nWidth        = atoi(FileReadString(file));
                if (strToken == "Height")     nHeight       = atoi(FileReadString(file));
                if (strToken == "Caption")    strCaption    = FileReadString(file);
                if (strToken == "BevelOuter") strBevelOuter = FileReadString(file);
                if (strToken == "BevelInner") strBevelInner = FileReadString(file);

                if (strToken == "object") 
                {
						DFM_AddObject(pTObject, strClass, strCaption, nLeft, nTop, nWidth, nHeight, true);
						bObject = true;

						DFM_LoadObject(file, m_pTObject, bObject);

						
                }

                if (strToken == "end" && !bObject)
				{
					DFM_AddObject(pTObject, strClass, strCaption, nLeft, nTop, nWidth, nHeight, true);

					bObject = false;
				}

        };

/*

	object
	   object
	   end
	   object
	     object
		 end
	   end
	end

 */
        return true;

}
/*--------------------------------------------------------------------------------------*/

bool CFormCreatorView::LoadDFM(CFile &file)
{
	CString strToken;

	int nTop, nLeft;
	int nWidth, nHeight;
	int nBorderLeft;
	int nBorderTop;

	struct CObjInfo
	{
		int nLeft;
		int nTop;
		int nWidth;
		int nHeight;
		int nTabOrder;
		int nPage;
		int nParent;

		CString strName;
		CString strCaption;
		CString strClass;
		CString strBevelOuter;
		CString strBevelInner;
		CString strVisible;

		CTObject * pTObject;
		
	};

	#define MAXOBJ 5000

	CObjInfo objInfo[MAXOBJ];
	int      objParent[MAXOBJ];

	memset(&objParent, -1, sizeof(int) * MAXOBJ);

	int nObj    = -1;
	int nParent = -1;
	int nParentTmp = -1;
	int nPage = -1;

	CString strName;
	CString strClass;

	
	while ((strToken = FileReadString(file)) != "EndOfFile")
	{
//		cout << (LPCSTR) strToken << endl;

		if (strToken == "Left")       objInfo[nObj].nLeft         = atoi(FileReadString(file));	
		if (strToken == "Top")	      objInfo[nObj].nTop          = atoi(FileReadString(file));
		if (strToken == "Width")      objInfo[nObj].nWidth        = atoi(FileReadString(file));
		if (strToken == "Height")     objInfo[nObj].nHeight       = atoi(FileReadString(file));
		if (strToken == "Caption")    objInfo[nObj].strCaption    = FileReadString(file);
		if (strToken == "BevelOuter") objInfo[nObj].strBevelOuter = FileReadString(file);
		if (strToken == "BevelInner") objInfo[nObj].strBevelInner = FileReadString(file);
		if (strToken == "Visible")    objInfo[nObj].strVisible    = FileReadString(file);
		if (strToken == "item")       nParent++;
		if (strToken == "end")        nParent--;
	
		if (strToken == "object" || strToken == "inherited")
		{
			nObj++;
			nParent++;

			if (nParent  == MAXOBJ)
			{
				AfxMessageBox("Nie mona zaadowa tylu obiektw");
				break;
			}


			strName  = FileReadString(file);
			strClass = FileReadString(file);

			objInfo[nObj].strName       = strName;
			objInfo[nObj].strClass      = strClass;
			objInfo[nObj].strCaption    = "";
			objInfo[nObj].strBevelOuter = "";
			objInfo[nObj].nLeft         = 0;
			objInfo[nObj].nTop          = 0;
			objInfo[nObj].nWidth        = 0;
			objInfo[nObj].nHeight       = 0;

			if (strClass == "TPanel"       || 
				strClass == "TGroupBox"    || 
				strClass == "TPageControl" ||
				strClass == "TTabSheet")
				objParent[nParent] = nObj;

			if (strClass == "TPageControl")
				nPage = -1;
			if (strClass == "TTabSheet")
				nPage++;
			
			if (nParent - 1 < 0)
				objInfo[nObj].nParent = -1;
			else
				objInfo[nObj].nParent = objParent[nParent - 1];

			objInfo[nObj].nPage = nPage;
		}

	}

	int nDlgWidth  = 0;
	int nDlgHeight = 0;

	if (nObj >= 0)
	{

		RemoveAllObjects();
		m_pTracker->m_selObjects.RemoveAll();
	
		m_pDlg->SetWindowText(objInfo[0].strCaption);

		m_strDlgName = objInfo[0].strName;
	
		UpdateObjectPosInfo(CRect(10, 10, objInfo[0].nWidth, objInfo[0].nHeight));

		for (int i = 1; i <= nObj; i++)
		{
			DWORD dwFlags = 0;
			DWORD dwFlagsEx = 0;

			int nCtrlType = GetObjectType(objInfo[i].strClass);

			if (objInfo[i].strClass == "TTabSheet")
			{
				((CTabCtrl *) (objInfo[objInfo[i].nParent].pTObject->m_pObject))->InsertItem(objInfo[i].nPage, objInfo[i].strCaption);
			}
	
			if (nCtrlType >= 0)
			{

				CWnd * pWnd;
				CTObject * pTObject;

				int nParent = objInfo[i].nParent;

				if (nParent < 0)
				{
					nBorderLeft = 0;
					nBorderTop  = 0;
					pTObject    = m_pTDlg;

					if (objInfo[i].nLeft + objInfo[i].nWidth > nDlgWidth)
						nDlgWidth = objInfo[i].nWidth + objInfo[i].nLeft;

					if (objInfo[i].nTop + objInfo[i].nHeight> nDlgHeight)
						nDlgHeight = objInfo[i].nHeight + objInfo[i].nTop;
					
				}
				else
				{
					if (objInfo[nParent].strClass == "TTabSheet")
						pTObject = objInfo[objInfo[nParent].nParent].pTObject;
					else
						pTObject = objInfo[nParent].pTObject;

					nBorderLeft = pTObject->m_nBorderLeft;
					nBorderTop  = pTObject->m_nBorderTop;
				}

				nLeft   = objInfo[i].nLeft - nBorderLeft;
				nTop    = objInfo[i].nTop  - nBorderTop;
				nWidth  = objInfo[i].nWidth;
				nHeight = objInfo[i].nHeight;

				if (nParent >= 0 && objInfo[nParent].strClass == "TTabSheet")
				{
					nTop += 25;
				}

				int nCtrlClass = GetObjectClass(objInfo[i].strClass);

				if (cCtrlInfo[nCtrlType].pClassType[nCtrlClass].nHeight != 0)
					nHeight = DEF_HEIGHT;

				pWnd = AddObject(pTObject, nCtrlType, CRect(nLeft, nTop, nLeft + nWidth, nTop + nHeight), true, true, false, dwFlags, dwFlagsEx);

				objInfo[i].pTObject = m_pTObject;


				if (nParent >= 0 && objInfo[nParent].strClass == "TTabSheet")
				{
					m_pTObject->m_nPage = objInfo[i].nPage;
					m_pTObject->m_bVisible = (objInfo[i].nPage == 0);
				}

				if (nCtrlType == CTRL_TABCONTROL)
				{
					((CTabCtrl *) pWnd)->DeleteAllItems();
				}
				else
				if (nCtrlType == CTRL_PANEL)
				{
					((CPanelControl *) pWnd)->m_nBevelOuter = bvRaised;
					((CPanelControl *) pWnd)->m_nBevelInner = bvNone;
					
					((CPanelControl *) pWnd)->m_strName = objInfo[i].strCaption;

					if (objInfo[i].strBevelOuter == "bvRaised")
						((CPanelControl *) pWnd)->m_nBevelOuter = bvRaised;
					else
					if (objInfo[i].strBevelOuter == "bvLowered")
						((CPanelControl *) pWnd)->m_nBevelOuter = bvLowered;

					if (objInfo[i].strBevelInner == "bvRaised")
						((CPanelControl *) pWnd)->m_nBevelInner = bvRaised;
					else
					if (objInfo[i].strBevelInner == "bvLowered")
						((CPanelControl *) pWnd)->m_nBevelInner = bvLowered;
				}

				m_pTObject->m_strCaption = objInfo[i].strCaption;
				m_pTObject->m_strName    = objInfo[i].strName;
				m_pTObject->m_strInfo    = "";
				m_pTObject->m_nClass     = GetObjectClass(objInfo[i].strClass);

				AddToObjList(m_pTObject);
				AddToInfObjList(m_pTObject);

			
				pWnd->SetWindowText(objInfo[i].strCaption);
				if (m_pTObject->m_bVisible)
					pWnd->ShowWindow(SW_SHOW);
				else
					pWnd->ShowWindow(SW_HIDE);
/*				if (objInfo[i].strVisible == "True")
					pWnd->ShowWindow(SW_SHOW);
				else
				if (objInfo[i].strVisible == "False");
					//pWnd->ShowWindow(SW_HIDE);
				else
					pWnd->ShowWindow(SW_SHOW);*/

			}

		}

		if (objInfo[0].nWidth == 0)
			objInfo[0].nWidth = nDlgWidth + 5 + m_nBorderX;
		if (objInfo[0].nHeight == 0)
			objInfo[0].nHeight = nDlgHeight + 5 + m_nBorderY;
		m_pDlg->SetWindowPos(NULL, 10, 10, objInfo[0].nWidth, objInfo[0].nHeight, 0);

		return true;

	}
	

	return false;
		
}
/*--------------------------------------------------------------------------------------*/
// nPage - zakladka na ktorej lezy obiekt , jesli -1 to parametr nie gra roli
bool CFormCreatorView::DFM_SaveObjects(CFile &file, CTList<CTObject *> * objects, CString strSpaces0, CString strSpaces1, int nPage)
{
	
	CString strTmp;

	objIterator it = objects->begin();

	while (it != NULL)
	{
		if (it->m_nPage != nPage)
		{
			++it;
			continue;
		}

		CString strClass;
		CString strName;

		strClass = cCtrlInfo[it->m_nType].pClassType[it->m_nClass].strClass;
	
		strTmp.Format("%sobject %s : %s\r\n", strSpaces0, it->m_strName, strClass);
		file.Write((LPCSTR) strTmp, strTmp.GetLength());
		strTmp.Format("%sLeft = %d\r\n", strSpaces1, it->m_curRect.left);
		file.Write((LPCSTR) strTmp, strTmp.GetLength());
		strTmp.Format("%sTop = %d\r\n", strSpaces1, it->m_curRect.top);
		file.Write((LPCSTR) strTmp, strTmp.GetLength());
		strTmp.Format("%sWidth = %d\r\n", strSpaces1, it->m_curRect.Width());
		file.Write((LPCSTR) strTmp, strTmp.GetLength());
		strTmp.Format("%sHeight = %d\r\n", strSpaces1, it->m_curRect.Height());
		file.Write((LPCSTR) strTmp, strTmp.GetLength());

		if (it->m_nType == CTRL_PANEL       || it->m_nType == CTRL_BUTTON      ||
			it->m_nType == CTRL_TEXTBOX     || it->m_nType == CTRL_STATICTEXT  ||
			it->m_nType == CTRL_GROUPBOX    || it->m_nType == CTRL_RADIOBUTTON ||
			it->m_nType == CTRL_CHECKBUTTON || it->m_nType == CTRL_RICHEDIT)
		{	
			strTmp.Format("%sCaption = '%s'\r\n", strSpaces1, it->m_strCaption);
			file.Write((LPCSTR) strTmp, strTmp.GetLength());
		}

		if (it->m_nType == CTRL_GRID)
		{
			strTmp.Format("%sColumns = <\r\n", strSpaces1);;
			file.Write((LPCSTR) strTmp, strTmp.GetLength());

			int nColCount = ((CGridCtrl *)it->m_pObject)->GetColumnCount();

			for (int nCol = 1; nCol < nColCount; nCol++)
			{
				CString strColName = ((CGridCtrl *) it->m_pObject)->GetItemText(0, nCol);
				strTmp.Format("%s   item\r\n", strSpaces1);
				file.Write((LPCSTR) strTmp, strTmp.GetLength());
				strTmp.Format("%s      Expanded = False\r\n", strSpaces1);
				file.Write((LPCSTR) strTmp, strTmp.GetLength());
				strTmp.Format("%s      FieldName = '%s'\r\n", strSpaces1, strColName);
				file.Write((LPCSTR) strTmp, strTmp.GetLength());
				strTmp.Format("%s      Visible = True\r\n", strSpaces1);
				file.Write((LPCSTR) strTmp, strTmp.GetLength());
				if (nCol == nColCount - 1)
					strTmp.Format("%s   end>\r\n", strSpaces1);
				else
					strTmp.Format("%s   end\r\n", strSpaces1);
				file.Write((LPCSTR) strTmp, strTmp.GetLength());

			}
		}

		if (it->m_nType == CTRL_LISTBOX)
		{

				strTmp.Format("%sItems.Strings = (\r\n", strSpaces1);
				file.Write((LPCSTR) strTmp, strTmp.GetLength());

				int nCount = ((CListBox *) it->m_pObject)->GetCount();
				int i = 0;
				CString strItem;

				while (i < nCount)
				{
					((CListBox *) it->m_pObject)->GetText(i, strItem);

					strTmp.Format("%s   '%s'", strSpaces1, strItem);
					if (i == nCount - 1)
						strTmp += ")\r\n";
					else
						strTmp += "\r\n";

					file.Write((LPCSTR) strTmp, strTmp.GetLength());
					++i;
				}
		}

		if (it->m_nType == CTRL_COMBOBOX)
		{
				strTmp.Format("%sItems.Strings = (\r\n", strSpaces1);
				file.Write((LPCSTR) strTmp, strTmp.GetLength());

				int nCount = ((CComboBox *) it->m_pObject)->GetCount();
				int i = 0;
				CString strItem;

				while (i < nCount)
				{
					((CComboBox *) it->m_pObject)->GetLBText(i, strItem);

					strTmp.Format("%s   '%s'", strSpaces1, strItem);
					if (i == nCount - 1)
						strTmp += ")\r\n";
					else
						strTmp += "\r\n";

					file.Write((LPCSTR) strTmp, strTmp.GetLength());
					++i;
				}
		}

		if (it->m_nType == CTRL_TABCONTROL)
		{
				CTabCtrl * pTabCtrl = (CTabCtrl *) it->m_pObject;
				int nSheets = pTabCtrl->GetItemCount();

				CString strTabName;

				for (int i = 0; i < nSheets; i++)
				{
					strTabName.Format("%s%d", "TabSheet", i + 1);
					strTmp.Format("%sobject %s : %s\r\n", strSpaces0 + "   ", strTabName, "TabSheet");
					file.Write((LPCSTR) strTmp, strTmp.GetLength());
					DFM_SaveObjects(file, &it->m_objects, strSpaces0 + "      ", strSpaces0 + "         ", i);
					strTmp.Format("%send\r\n", strSpaces0 + "   ");
					file.Write((LPCSTR) strTmp, strTmp.GetLength());

				}
		}

		DFM_SaveObjects(file, &it->m_objects, strSpaces0 + "   ", strSpaces0 + "      ", nPage);

		strTmp.Format("%send\r\n", strSpaces0);
		file.Write((LPCSTR) strTmp, strTmp.GetLength());
		++it;

	}


	return true;
}
/*--------------------------------------------------------------------------------------*/
bool CFormCreatorView::DFM_SaveHeader(CFile & file, CTList<CTObject *> * objects)
{
	objIterator it = objects->begin();

	CString strSpaces = "        ";
	while (it != NULL)
	{

		CString strClass;

		strClass = cCtrlInfo[it->m_nType].pClassType[it->m_nClass].strClass;
	
		CString strTmp;
		strTmp.Format("%s%s *%s;\r\n", strSpaces, strClass, it->m_strName);

		file.Write((LPCSTR) strTmp, strTmp.GetLength());

		DFM_SaveHeader(file, &it->m_objects);

		++it;
	}


	return true;

}
/*--------------------------------------------------------------------------------------*/
void CFormCreatorView::OnFileImportDfm() 
{

	CString strDocName;
	this->GetParentFrame()->GetWindowText(strDocName);
	CFileDialog dlgFile(true, "dfm", strDocName, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Formatki C++ Builder (*.dfm)|*.dfm|");
	
	int iRes = dlgFile.DoModal();

	if (iRes == IDCANCEL)
		return;

	CFile file;

	ONDEBUG("Imprting file " << (LPCSTR) dlgFile.GetFileName());
	
	BOOL bOpened = file.Open(dlgFile.GetFileName(), CFile::modeRead | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd odczytu pliku");
		return;
	}

	CString strExt = dlgFile.GetFileExt();
	strExt.MakeUpper();

	if (strExt != "DFM")
	{
		AfxMessageBox("Niewaciwy typ pliku");
		file.Close();
	}
	g_bFirstObject = true;
//	RemoveAllObjects(); //robi to LoadDFM gdy nie znajdzie w pliku zadnych obiektow

//	FileFindString(file, "object");
	SetScrollPos(0, 0, FALSE);
	SetScrollPos(1, 0, FALSE);

	if (!LoadDFM(file))
//	if (!DFM_LoadObject(file, m_pTDlg, false))
	{
		AfxMessageBox("Niepoprawny format pliku");
		file.Close();
		return;
	}
	
	file.Close();

	ResetScrollBars();
	Invalidate();

	GetDocument()->SetTitle(dlgFile.GetFileName());
	
	m_strFileName = dlgFile.GetFileName();

	m_pTracker->m_nObjSelected = 0;
	m_nObjSelected = 0;
	m_pTracker->m_bDlgSelected = true;
	m_pTracker->m_curRect = GetDlgScreenRect();
	m_bDlgSelected = true;
	m_pTracker->SetClipRect(GetTotalClipRect());

	GetDlgBorderSize();

	UpdateObjectNameInfo();
	UpdateObjectCaptionInfo();
	UpdateObjectClassInfo();
	
	
}
/*--------------------------------------------------------------------------------------*/
void CFormCreatorView::SetFileExt(CString & strFilename, CString strExt)
{
	CString strDot("");
	int nLen = strFilename.GetLength() - 1;
	int i = nLen;
	while (i > 0 && strFilename[i] != '.') i--;
	if (i == 0)
	{
		i = nLen;
		strDot = ".";
	}

	strFilename = strFilename.Left(i + 1) + strDot + strExt;
}
/*--------------------------------------------------------------------------------------*/
void CFormCreatorView::OnFileExportDfm() 
{
	CString strDocName;
	this->GetParentFrame()->GetWindowText(strDocName);
	SetFileExt(strDocName, "dfm");
	CFileDialog dlgFile(false, "dfm", strDocName, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Formatki C++ Builder (*.dfm)|*.dfm|");
	
	int iRes = dlgFile.DoModal();

	if (iRes == IDCANCEL)
		return;

	CFile file;

	m_nCtrlID = 1;

	ONDEBUG("Exporting file " << (LPCSTR) dlgFile.GetFileName());
	
	BOOL bOpened = file.Open(dlgFile.GetFileName(), CFile::modeWrite | CFile::modeCreate | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd tworzenia pliku");
		return;
	}


	CString strTmp;
	CRect dlgRect;
	m_pDlg->GetWindowRect(&dlgRect);
	CString strDlgName;
	m_pDlg->GetWindowText(strDlgName);

	CString strFrmClass = "T" + m_strDlgName;

	strTmp.Format("object %s : %s\r\n", m_strDlgName, strFrmClass);  file.Write((LPCSTR) strTmp, strTmp.GetLength());
	strTmp.Format("   Left = %d\r\n", dlgRect.left);   	   file.Write((LPCSTR) strTmp, strTmp.GetLength());
	strTmp.Format("   Top = %d\r\n", dlgRect.top);         file.Write((LPCSTR) strTmp, strTmp.GetLength());
	strTmp.Format("   Width = %d\r\n", dlgRect.Width());   file.Write((LPCSTR) strTmp, strTmp.GetLength());
	strTmp.Format("   Height = %d\r\n", dlgRect.Height()); file.Write((LPCSTR) strTmp, strTmp.GetLength());
	strTmp.Format("   Caption = '%s'\r\n", strDlgName);    file.Write((LPCSTR) strTmp, strTmp.GetLength());
	strTmp = "   Color = clBtnFace\r\n";                   file.Write((LPCSTR) strTmp, strTmp.GetLength());
    strTmp = "   Font.Charset = DEFAULT_CHARSET\r\n";      file.Write((LPCSTR) strTmp, strTmp.GetLength());
	strTmp = "   Font.Color = clWindowText\r\n";           file.Write((LPCSTR) strTmp, strTmp.GetLength());
    strTmp = "   Font.Height = -11\r\n";                   file.Write((LPCSTR) strTmp, strTmp.GetLength());
    strTmp = "   Font.Name = 'MS Sans Serif'\r\n";         file.Write((LPCSTR) strTmp, strTmp.GetLength());  
    strTmp = "   Font.Style = []\r\n";                     file.Write((LPCSTR) strTmp, strTmp.GetLength());
    strTmp = "   OldCreateOrder = False\r\n";              file.Write((LPCSTR) strTmp, strTmp.GetLength());
    strTmp = "   PixelsPerInch = 96\r\n";                  file.Write((LPCSTR) strTmp, strTmp.GetLength());
    strTmp = "   TextHeight = 13\r\n";                     file.Write((LPCSTR) strTmp, strTmp.GetLength());

	if (!DFM_SaveObjects(file, &m_objects, "   ", "      ", -1))
	{
		AfxMessageBox("Bd zapisu pliku");
		file.Close();
		return;
	}
	
	strTmp.Format("end\r\n");
	file.Write((LPCSTR) strTmp, strTmp.GetLength());
	file.Close();

	CString strFileNameCpp = dlgFile.GetFileTitle() + ".cpp";
	CString strFileNameH   = dlgFile.GetFileTitle() + ".h";


	ONDEBUG("Exporting file " << (LPCSTR) strFileNameCpp);
	
	bOpened = file.Open(strFileNameCpp, CFile::modeWrite | CFile::modeCreate | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd tworzenia pliku");
		file.Close();
		return;
	}

	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <vcl.h>\r\n"; file.Write(strTmp, strTmp.GetLength());
	strTmp = "#pragma hdrstop\r\n";  file.Write(strTmp, strTmp.GetLength());
	strTmp.Format("#include \"%s\"\r\n", strFileNameH); 
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "#pragma package(smart_init)\r\n"; file.Write(strTmp, strTmp.GetLength());
	strTmp = "#pragma resource \"*.dfm\"\r\n";  file.Write(strTmp, strTmp.GetLength());
	strTmp.Format("%s *%s;\r\n", strFrmClass, m_strDlgName); file.Write(strTmp, strTmp.GetLength());
	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp.Format("__fastcall %s::%s(TComponent* Owner)\r\n", strFrmClass, strFrmClass); file.Write(strTmp, strTmp.GetLength());
	strTmp = "        : TForm(Owner)\r\n"; file.Write(strTmp, strTmp.GetLength());       
	strTmp = "{\r\n}\r\n"; file.Write(strTmp, strTmp.GetLength());
	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());

	file.Close();

	ONDEBUG("Exporting file " << (LPCSTR) strFileNameH);
	
	bOpened = file.Open(strFileNameH, CFile::modeWrite | CFile::modeCreate | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd tworzenia pliku");
		return;
	}
	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp.Format("#ifndef %sH\r\n", dlgFile.GetFileTitle());
	file.Write(strTmp, strTmp.GetLength());
	strTmp.Format("#define %sH\r\n", dlgFile.GetFileTitle());
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <Classes.hpp>\r\n";  file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <Controls.hpp>\r\n"; file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <StdCtrls.hpp>\r\n"; file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <Forms.hpp>\r\n";    file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <ComCtrls.hpp>\r\n"; file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <ExtCtrls.hpp>\r\n"; file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <DBGrids.hpp>\r\n";  file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <Grids.hpp>\r\n";    file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <Mask.hpp>\r\n";     file.Write(strTmp, strTmp.GetLength());
	strTmp = "#include <Menus.hpp>\r\n";    file.Write(strTmp, strTmp.GetLength());
	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp.Format("class %s : public TForm\r\n", strFrmClass); file.Write(strTmp, strTmp.GetLength());
	strTmp = "{\r\n";                                       file.Write(strTmp, strTmp.GetLength());
	strTmp = "__published:	// IDE-managed Components\r\n"; file.Write(strTmp, strTmp.GetLength());

	if (!DFM_SaveHeader(file, &m_objects))
	{
		AfxMessageBox("Bd zapisu pliku");
		file.Close();
		return;
	}

	strTmp = "private:	// User declarations\r\n";                file.Write(strTmp, strTmp.GetLength());
	strTmp = "public:		// User declarations\r\n";            file.Write(strTmp, strTmp.GetLength());
	strTmp.Format("        __fastcall %s(TComponent* Owner);\r\n", strFrmClass); file.Write(strTmp, strTmp.GetLength());
	strTmp = "};\r\n";                                            file.Write(strTmp, strTmp.GetLength());
	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp.Format("extern PACKAGE %s *%s;\r\n", strFrmClass, m_strDlgName);
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "//---------------------------------------------------------------------------\r\n";
	file.Write(strTmp, strTmp.GetLength());
	strTmp = "#endif\r\n";
	file.Write(strTmp, strTmp.GetLength());
	file.Close();

	GetDocument()->SetTitle(dlgFile.GetFileName());
	m_strFileName = dlgFile.GetFileName();

}
