#include "stdafx.h"
#include "FormCreator.h"
#include "Globals.h"

#include "GridCtrl/GridCtrl.h"
#include "Console.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include "MultiRectTracker.h"
#include "ToolbarControls.h"

#include "DialogGrid.h"
#include "DialogTemplate.h"
#include "ColumnsDialog.h"

#include "TObject.h"
#include "PanelControl.h"

#include "TransparentWindow.h"
#include "math.h"
#include <afxrich.h>

#include <iostream>
using namespace std;

/*-------------------------------------------------------------------------------------------*\
                                    ZAPIS/ODCZYT *.form
\*-------------------------------------------------------------------------------------------*/
void CFormCreatorView::FORM_LoadObjects(CFile & file, CTObject * pTParent)
{
	int  nCount;
	int  nType;
	int  nClass;
	int  nLeft, nRight;
	int  nTop, nBottom;
	int  strLen;
	int  nID;
	int  nItemsCount;
	char strCaption[256];
	char strInfo[65535];
	char strName[256];
	char strItem[256];
	bool bEnabled;
	bool bVisible;
	int  nCurPage;
	int  nPage;

	bool bFirst;

	file.Read(&nCount, sizeof(int));

//	cout << nCount << endl;
	while (nCount--)
	{
		file.Read(&strLen,   sizeof(int));
		file.Read(&strCaption, strLen);
		strCaption[strLen] = 0;
		file.Read(&strLen,   sizeof(int));
		file.Read(&strInfo, strLen);
		strInfo[strLen] = 0;
		file.Read(&strLen,   sizeof(int));
		file.Read(&strName, strLen);
		strName[strLen] = 0;
		file.Read(&nType,    sizeof(int));
		file.Read(&nClass,   sizeof(int));
		file.Read(&nID,      sizeof(int));
		file.Read(&nLeft,    sizeof(int));
		file.Read(&nTop,     sizeof(int));
		file.Read(&nRight,   sizeof(int));
		file.Read(&nBottom,  sizeof(int));
		file.Read(&bEnabled, sizeof(bool));
		file.Read(&bVisible, sizeof(bool));
		file.Read(&nCurPage, sizeof(int));
		file.Read(&nPage,    sizeof(int));

		//cout << nType << endl;
		//cout << strName << endl;
		
		if (nType >= 0)
		{
		
			CWnd * pWnd = AddObject(pTParent, nType, CRect(nLeft, nTop, nRight, nBottom), true, true, false);

			bFirst = true;

			switch (nType)
			{
				case CTRL_GRID:

							file.Read(&nItemsCount, sizeof(int));
						
							
							if (nItemsCount == 2 && 
								((CGridCtrl *) pWnd)->GetItemText(0, 1) == "")
							{						
								((CGridCtrl *) pWnd)->SetColumnWidth(1, 50);
								break;
							}

							((CGridCtrl *) pWnd)->DeleteColumn(1);

							nItemsCount--;

							while (nItemsCount--)
							{
								file.Read(&strLen, sizeof(int));
								file.Read(strItem, strLen);
								strItem[strLen] = 0;
								((CGridCtrl *) pWnd)->InsertColumn(strItem);
							}

							

							break;

				case CTRL_LISTBOX:

							file.Read(&nItemsCount, sizeof(int));

							((CListBox *) pWnd)->ResetContent();

							while (nItemsCount--)
							{
								file.Read(&strLen, sizeof(int));
								file.Read(strItem, strLen);
								strItem[strLen] = 0;
								((CListBox *) pWnd)->AddString(strItem);
							}

							break;

				case CTRL_COMBOBOX:

							file.Read(&nItemsCount, sizeof(int));
							((CComboBox *) pWnd)->ResetContent();

							while (nItemsCount--)
							{
								file.Read(&strLen, sizeof(int));
								file.Read(strItem, strLen);
								strItem[strLen] = 0;
								((CComboBox *) pWnd)->AddString(strItem);
							}
							break;
			}
		

			pWnd->SetWindowText(strCaption);
			m_pTObject->m_strCaption = strCaption;
			m_pTObject->m_strInfo    = strInfo;
			m_pTObject->m_strName    = strName;
			m_pTObject->m_nClass     = nClass;
			m_pTObject->m_nID        = nID;
			m_pTObject->m_bEnabled   = bEnabled;
			m_pTObject->m_bVisible   = bVisible;
			m_pTObject->m_nPage      = nPage;
			m_pTObject->m_nCurPage   = nCurPage;

			AddToObjList(m_pTObject);
			AddToInfObjList(m_pTObject);

			pWnd->EnableWindow(bEnabled);
			
			if (m_pTObject->m_nType == CTRL_TABCONTROL)
				((CTabCtrl *) m_pTObject->m_pObject)->SetCurSel(m_pTObject->m_nCurPage);

			if (m_pTObject->m_pTParent->m_nType == CTRL_TABCONTROL)
			{
				if (m_pTObject->m_pTParent->m_nCurPage == m_pTObject->m_nPage)
					pWnd->ShowWindow(SW_SHOW);
				else
					pWnd->ShowWindow(SW_HIDE);
			}
			else
				pWnd->ShowWindow(SW_SHOW);

			FORM_LoadObjects(file, m_pTObject);

		}

	}

}
void CFormCreatorView::FORM_SaveObjects(CFile & file, CTList<CTObject *> * objects)
{
	objIterator it = objects->last();
	
	int nCount = objects->Count();
	int nItemsCount;
	CString strItem;

	file.Write(&nCount, sizeof(int));

	while (it != NULL)
	{
		int strLen = it->m_strCaption.GetLength();
		file.Write(&strLen, sizeof(int));
		file.Write(it->m_strCaption, strLen);
		it->m_strInfo = m_pGrdInfObjList->GetItemText(FindRowInObjInfList(it->m_strName), 2);
		strLen = it->m_strInfo.GetLength();
		file.Write(&strLen, sizeof(int));
		file.Write(it->m_strInfo, strLen);
		strLen = it->m_strName.GetLength();
		file.Write(&strLen, sizeof(int));
		file.Write(it->m_strName, strLen);

		file.Write(&it->m_nType,          sizeof(int));
		file.Write(&it->m_nClass,         sizeof(int));
		file.Write(&it->m_nID,            sizeof(int));
		file.Write(&it->m_curRect.left,   sizeof(int));
		file.Write(&it->m_curRect.top,    sizeof(int));
		file.Write(&it->m_curRect.right,  sizeof(int));
		file.Write(&it->m_curRect.bottom, sizeof(int));
		file.Write(&it->m_bEnabled,       sizeof(bool));
		file.Write(&it->m_bVisible,		  sizeof(bool));
		file.Write(&it->m_nCurPage,       sizeof(int));
		file.Write(&it->m_nPage,          sizeof(int));

		bool bFirst = true;
		int i;

		switch (it->m_nType)
		{
			case CTRL_GRID:

						nItemsCount = ((CGridCtrl *) it->m_pObject)->GetColumnCount();

						file.Write(&nItemsCount, sizeof(int));

						i = 1;
						while (i < nItemsCount)
						{
							strItem = ((CGridCtrl *) it->m_pObject)->GetItemText(0, i);
							strLen = strItem.GetLength();
							file.Write(&strLen, sizeof(int));
							file.Write(strItem, strLen);
							++i;
						}

						break;

			case CTRL_LISTBOX:

						nItemsCount = ((CListBox *) it->m_pObject)->GetCount();

						file.Write(&nItemsCount, sizeof(int));

						i = 0;
						while (i < nItemsCount)
						{
							((CListBox *) it->m_pObject)->GetText(i, strItem);
							strLen = strItem.GetLength();
							file.Write(&strLen, sizeof(int));
							file.Write(strItem, strLen);
							++i;
						}

						break;

			case CTRL_COMBOBOX:

						nItemsCount = ((CComboBox *) it->m_pObject)->GetCount();

						file.Write(&nItemsCount, sizeof(int));

						i = 0;
						while (i < nItemsCount)
						{
							((CComboBox *) it->m_pObject)->GetLBText(i, strItem);
							strLen = strItem.GetLength();
							file.Write(&strLen, sizeof(int));
							file.Write(strItem, strLen);
							++i;
						}

						break;
		}

		FORM_SaveObjects(file, &it->m_objects);

		--it;	
	}

}

void CFormCreatorView::OnFileSave() 
{

	CString strDocName;
	this->GetParentFrame()->GetWindowText(strDocName);

	SetFileExt(strDocName, "form");

	CFileDialog dlgFile(false, "form", strDocName, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Formatki (*.form)|*.form|");
	CString strFileName;

	if (!m_bSaved)
		m_bGetFileName = true;

	if (m_bGetFileName)
	{
		int iRes = dlgFile.DoModal();

		if (iRes == IDCANCEL)
			return;

		strFileName = dlgFile.GetFileName();
	}
	else
		strFileName = strDocName;

	m_strFileName = strFileName;

	ONDEBUG("Saving file " << (LPCSTR) strFileName);

	CFile file;
	BOOL bOpened = file.Open(strFileName, CFile::modeWrite | CFile::modeCreate | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd zapisywania do pliku");
		return;
	}

	CString strHeader = "FCv1.5";
	file.Write(strHeader, strHeader.GetLength());


	CRect dlgRect;
	CString strDlgName;

	int nStrLen = m_strDlgName.GetLength();

	file.Write(&nStrLen, sizeof(int));
	file.Write((LPCSTR) m_strDlgName, nStrLen);

	m_pDlg->GetWindowRect(&dlgRect);
	ScreenToClient(&dlgRect);
	m_pDlg->GetWindowText(strDlgName);

	nStrLen = strDlgName.GetLength();

	file.Write(&nStrLen, sizeof(int));
	file.Write(strDlgName, nStrLen);

	int nWidth  = dlgRect.Width();
	int nHeight = dlgRect.Height();
	
	file.Write(&nWidth,  sizeof(int));
	file.Write(&nHeight, sizeof(int));

	FORM_SaveObjects(file, &m_objects);

	file.Close();

	GetDocument()->SetTitle(strFileName);

	m_bSaved = true;
	m_bChange = false;
	
}

void CFormCreatorView::OnFileOpen() 
{
	char strHeader[6 + 1] = "FCv1.5";
	CString strOrgHeader = "FCv1.5";
	int nHeaderLen = strOrgHeader.GetLength();

	CString strDocName;
	this->GetParentFrame()->GetWindowText(strDocName);
	CFileDialog dlgFile(true, "form", strDocName, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Formatki (*.form)|*.form|");
	
	int iRes = dlgFile.DoModal();

	if (iRes == IDCANCEL)
		return;

	CFile   file;
	char    strName[256];
	int     strLen;
	int     nWidth, nHeight;

	ONDEBUG("Loading file " << (LPCSTR) dlgFile.GetFileName());
	
	BOOL bOpened = file.Open(dlgFile.GetFileName(), CFile::modeRead | CFile::typeBinary);

	if (!bOpened)
	{
		AfxMessageBox("Bd odczytu pliku");
		return;
	}

	m_nCtrlID = 1;

	GetDocument()->SetTitle(dlgFile.GetFileName());
	m_strFileName = dlgFile.GetFileName();
	
	if (file.Read(strHeader, nHeaderLen) < nHeaderLen)
	{
		AfxMessageBox("Niewaciwy typ pliku (Plik jest za krtki)");
		file.Close();
		return;
	}

	strHeader[nHeaderLen] = 0;

	if (strOrgHeader != strHeader)
	{
		AfxMessageBox("Niewaciwy typ pliku (Nieprawidowy identyfikator)");
		file.Close();
		return;
	}


	RemoveAllObjects();
	SetScrollPos(0, 0, FALSE);
	SetScrollPos(1, 0, FALSE);

	file.Read(&strLen,   sizeof(int));
	file.Read(strName,   strLen);
	strName[strLen] = 0;
	m_strDlgName = strName;
	file.Read(&strLen,   sizeof(int));
	file.Read(strName,   strLen);
	strName[strLen] = 0;
	file.Read(&nWidth,   sizeof(int));
	file.Read(&nHeight,  sizeof(int));

	const int nLeftGap = 10;
	const int nTopGap  = 10;

	m_pDlg->SetWindowPos(NULL, nLeftGap, nTopGap, nWidth, nHeight, 0);
	m_pDlg->SetWindowText(strName);
	
	m_nObjSelected = 0;
	m_pTracker->m_bDlgSelected = true;
	m_pTracker->m_curRect = GetDlgScreenRect();
	m_bDlgSelected = true;

	GetDlgBorderSize();

	FORM_LoadObjects(file, m_pTDlg);

	ResetScrollBars();
	Invalidate();

	UpdateObjectNameInfo();
	UpdateObjectCaptionInfo();
	UpdateObjectPosInfo(CRect(nLeftGap, nTopGap, nWidth, nHeight));
	UpdateObjectClassInfo();

	file.Close();

	m_bSaved = true;
}

void CFormCreatorView::OnFileSaveAs() 
{
	m_bGetFileName = true;
	OnFileSave();
	m_bGetFileName = false;
}
