// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "FormCreator.h"
#include "FormCreatorView.h"

#include "MainFrm.h"
#include "Globals.h"
#include <iostream>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_APP + 10001, OnUserMessage)
END_MESSAGE_MAP()

static UINT indicators[1];/* =
{
/*	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};*/

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}
LRESULT CMainFrame::OnUserMessage(WPARAM wParam, LPARAM lParam)
{
	g_pActiveWnd->SendMessage(WM_APP+10001,0,0);
	return 1;
}
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}


	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	int cxFS = GetSystemMetrics(SM_CXFULLSCREEN);
	int cyFS = GetSystemMetrics(SM_CYFULLSCREEN);

	cs.cx = cxFS;
	cs.cy = cyFS;

	cs.x = 0;
	cs.y = 0;

	cs.style = WS_OVERLAPPED  | WS_CAPTION     | 
		       WS_SYSMENU     | FWS_ADDTOTITLE |
	           WS_MINIMIZEBOX | WS_MAXIMIZEBOX |
			   WS_MAXIMIZE |
	           WS_THICKFRAME;

	cs.lpszClass = _T("FormCreatorClass");

	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;


	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


LRESULT CMainFrame::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	return CMDIFrameWnd::WindowProc(message, wParam, lParam);
}

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg) 
{

	return CMDIFrameWnd::PreTranslateMessage(pMsg);
}

void CMainFrame::OnClose() 
{
	CWnd * pWnd = FindWindow(_T("TF_UMLAppMainForm"), NULL);

	if (pWnd)
		pWnd->SendMessage(WM_APP + 10001, 1, 0);

	CMDIFrameWnd::OnClose();
}
