// PanelControl.cpp : implementation file
//

#include "stdafx.h"
#include "formcreator.h"
#include "PanelControl.h"
#include "FormCreatorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPanelControl

CPanelControl::CPanelControl()
{
	m_nBevelWidth  = 0;
	m_nBevelInner  = 0;
	m_nBevelOuter  = 0;
	m_nBevelBorder = 0;
	fontNormal.CreateFont(10, 0, 0, 0, FW_NORMAL, 0, 0, 0,
						  ANSI_CHARSET, OUT_DEFAULT_PRECIS,
						  CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
						  DEFAULT_PITCH | FF_SWISS, "MS Sans Serif");
}

CPanelControl::~CPanelControl()
{
}


BEGIN_MESSAGE_MAP(CPanelControl, CStatic)
	//{{AFX_MSG_MAP(CPanelControl)
	ON_WM_PAINT()
	ON_WM_NCCALCSIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPanelControl message handlers

void CPanelControl::DrawBorder(CDC & dc, CRect & rect, CPen & pen0, CPen & pen1, int nWidth)
{
	if (rect.Width() < nWidth * 2)
		nWidth = rect.Width() / 2;

	if (rect.Height() < nWidth * 2)
		nWidth = rect.Height() / 2;

	for (int i = 0; i < nWidth; i++)
	{
		dc.SelectObject(pen0);

		dc.MoveTo(rect.left + i, rect.top + i);
		dc.LineTo(rect.right - i, rect.top + i);

		dc.MoveTo(rect.left + i, rect.top + i);
		dc.LineTo(rect.left + i, rect.bottom - i);

		dc.SelectObject(pen1);

		dc.MoveTo(rect.left + i, rect.bottom - i);
		dc.LineTo(rect.right - i + 1, rect.bottom - i);

		dc.MoveTo(rect.right - i, rect.top + i);
		dc.LineTo(rect.right - i, rect.bottom - i);
	}

}

void CPanelControl::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CRect clnRect;
	GetClientRect(&clnRect);

	CBrush grayBrush;
	grayBrush.CreateSolidBrush(::GetSysColor(COLOR_3DFACE));
	dc.FillRect(clnRect, &grayBrush);

	clnRect.right -= 1;
	clnRect.bottom -= 1;


	CPen whitePen;
	CPen grayPen;

	int nWidth = m_nBevelWidth;

	whitePen.CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	grayPen.CreatePen(PS_SOLID, 1, RGB(100, 100, 100));


	if (m_nBevelOuter != bvNone)
	{

		if (m_nBevelOuter == bvRaised)
			DrawBorder(dc, clnRect, whitePen, grayPen, m_nBevelWidth);
		else
			DrawBorder(dc, clnRect, grayPen, whitePen, m_nBevelWidth);
	} 
	else
		nWidth = 0;
	

	if (m_nBevelInner != bvNone)
	{	
		int nSpace = nWidth + m_nBevelBorder;

		clnRect.left   += nSpace;
		clnRect.top    += nSpace;
		clnRect.right  -= nSpace;
		clnRect.bottom -= nSpace;


		if (m_nBevelInner == bvRaised)
			DrawBorder(dc, clnRect, whitePen, grayPen, m_nBevelWidth);
		else
			DrawBorder(dc, clnRect, grayPen, whitePen, m_nBevelWidth);

	}
	
	dc.SelectObject(&fontNormal);
	CSize textSize = dc.GetTextExtent(m_strName);
	textSize.cx += 5;
	GetClientRect(&clnRect);

	int nMidX = (clnRect.left + clnRect.right) / 2;
	int nMidY = (clnRect.top + clnRect.bottom) / 2;

	dc.SetBkColor(::GetSysColor(COLOR_3DFACE));
	dc.TextOut(nMidX - textSize.cx / 2, nMidY - textSize.cy / 2, m_strName);

}

BOOL CPanelControl::PreCreateWindow(CREATESTRUCT& cs) 
{
	return CStatic::PreCreateWindow(cs);
}

void CPanelControl::OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS FAR* lpncsp) 
{

	//lpncsp->
	CStatic::OnNcCalcSize(bCalcValidRects, lpncsp);
}
