#include "stdafx.h"
#include "FormCreator.h"
#include "Globals.h"

#include "GridCtrl/GridCtrl.h"
#include "Console.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include "MultiRectTracker.h"
#include "ToolbarControls.h"

#include "DialogGrid.h"
#include "DialogTemplate.h"
#include "DialogPanelControl.h"
#include "ColumnsDialog.h"

#include "TObject.h"

#include "PanelControl.h"

#include "TransparentWindow.h"
#include "math.h"
#include "Guid.h"
#include <afxrich.h>

#include <iostream>
using namespace std;

/*
void CFormCreatorView::OnFilePrintPreview()
{
	CPrintPreviewState * pState = new CPrintPreviewState;
	if (!DoPrintPreview(AFX_IDD_PREVIEW_TOOLBAR, this, RUNTIME_CLASS(CPreviewView), pState))
	{
		TRACE0("Error: DoPrintPreview failed.\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		delete pState;
	}
}*/

BOOL CFormCreatorView::OnPreparePrinting(CPrintInfo* pInfo)
{
	PRINTDLG dlg;
    AfxGetApp()->GetPrinterDeviceDefaults(&dlg);
  
    CDC pdc;
    if (0 != AfxGetApp()->CreatePrinterDC(pdc))
    {
        ComputePrintSizes(&pdc, pInfo);
    }

	return DoPreparePrinting(pInfo);
}

void CFormCreatorView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	ComputePrintSizes(pDC, pInfo);
}

void CFormCreatorView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}
void CFormCreatorView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CRect rect = pInfo->m_rectDraw; 
	CPoint prPrint = rect.BottomRight();
	CPoint pt;

	pt.y  = prPrint.y * ((pInfo->m_nCurPage - 1) / m_nColPages);
	pt.x  = prPrint.x * ((pInfo->m_nCurPage - 1) % m_nColPages);
	pDC->SetWindowOrg(pt);
		
	CScrollView::OnPrint(pDC, pInfo);
}

void CFormCreatorView::ComputePrintSizes(CDC *pDC,  CPrintInfo* pInfo)
{
    
    int nPixPerInchX, nPixPerInchY;
    int nPhysPixWidth, nPhysPixHeight;
    int nPhysOffsetX,  nPhysOffsetY;
    CSize pageSize;
    
    CSize mySize = GetTotalSize();         


    nPixPerInchX   = pDC->GetDeviceCaps(LOGPIXELSX); 
    nPhysPixWidth  = pDC->GetDeviceCaps(PHYSICALWIDTH);
    nPixPerInchY   = pDC->GetDeviceCaps(LOGPIXELSY); 
    nPhysPixHeight = pDC->GetDeviceCaps(PHYSICALHEIGHT);
    nPhysOffsetX   = pDC->GetDeviceCaps(PHYSICALOFFSETX);
    nPhysOffsetY   = pDC->GetDeviceCaps(PHYSICALOFFSETY);
    
	if (nPixPerInchX > 0 && nPixPerInchY > 0)
    {
        pageSize.cx = 100 * (nPhysPixWidth  - 2 * nPhysOffsetX) / nPixPerInchX;
        pageSize.cy = 100 * (nPhysPixHeight - 2 * nPhysOffsetY) / nPixPerInchY;

        TRACE(" PrinterDC yields x(%d) y(%d)\n", pageSize.cx, pageSize.cy);
    }
 
    pageSize.cx -= (m_PrintHeader + m_PrintFooter);
    m_nColPages = 1 + mySize.cx / pageSize.cx;      
    m_nRowPages = 1+  mySize.cy / pageSize.cy;
    pInfo->SetMaxPage(m_nColPages * m_nRowPages);

}
