#include "stdafx.h"
#include "TObject.h"

CClassInfo cButtonClass[CLASS_MAX] = 
{
	"TButton", 0, 0,
	"TBitBtn", 0, 0,
	"TSpeedButton", 0, 0,
	"TdxEditButton", 0, 0,
	"TdxfColorButton", 0, 0
};

CClassInfo cEditClass[CLASS_MAX] = 
{
	"TEdit", 0, 0,
	"TDBEdit", 0, 0,
	"TMaskEdit", 0, 0,
	"TMemo", 0, 0,
	"TDBMemo", 0, 0,
	"TdxDBExtLookupEdit", 0, DEF_HEIGHT,
	"TdxDBEdit", 0, DEF_HEIGHT,
	"TdxDBMaskEdit", 0, DEF_HEIGHT,
	"TdxDBMemo", 0, DEF_HEIGHT,
	"TdxSpinEdit", 0, DEF_HEIGHT,
	"TdxBlobEdit", 0, DEF_HEIGHT,
};

CClassInfo cStaticClass[CLASS_MAX] = 
{
	"TLabel", 0, 0,
	"TDBText", 0, 0,
	"TdxfLabel", 0, 0
};

CClassInfo cCheckBoxClass[CLASS_MAX] = 
{
	"TCheckBox", 0, 0,
	"TDBCheckBox", 0, 0,
	"TdxfCheckBox", 0, 0,
	"TdxCheckEdit", 0, 0
};

CClassInfo cRadioButtonClass[CLASS_MAX] = 
{
	"TRadioButton", 0, 0
};

CClassInfo cGroupBoxClass[CLASS_MAX] = 
{
	"TGroupBox", 0, 0,
	"TdxfGroupBox", 0, 0,
	"TRadioGroup", 0, 0,
	"TDBRadioGroup", 0, 0

};

CClassInfo cHScrollBarClass[CLASS_MAX] = 
{
	"THScrollBar", 0, 0
};

CClassInfo cVScrollBarClass[CLASS_MAX] = 
{
	"TVScrollBar", 0, 0
};
CClassInfo cSliderClass[CLASS_MAX] = 
{
	"TTrackBar", 0, 0
};

CClassInfo cComboBoxClass[CLASS_MAX] = 
{
	"TComboBox", 0, 0,
	"TDBComboBox", 0, 0,
	"TdxImageComboBox", 0, 0
};

CClassInfo cListBoxClass[CLASS_MAX] = 
{
	"TListBox", 0, 0,
	"TDBListBox", 0, 0,
	"TdxImageListBox", 0, 0,
	"TdxfComboBox", 0, 0,
	"TdxfFontNameComboBox", 0, 0
};	

CClassInfo cPictureClass[CLASS_MAX] = 
{
	"TImage", 0, 0,
	"TdxSpinImage", 0, 0
};
CClassInfo cTreeControlClass[CLASS_MAX] = 
{
	"TTreeView", 0, 0,
	"TdxTreeList", 0, 0,
	"TdxDBTreeList", 0, 0
};

CClassInfo cTabControlClass[CLASS_MAX] = 
{
	"TPageControl", 0, 0,
	"TTabControl", 0, 0
};
CClassInfo cProgressBarClass[CLASS_MAX] = 
{
	"TProgressBar", 0, 0
};
CClassInfo cSpinClass[CLASS_MAX] = 
{
	"TUpDown", 0, 0
};
CClassInfo cHotKeyClass[CLASS_MAX] = 
{
	"THotKey", 0, 0
};
CClassInfo cIPAddressClass[CLASS_MAX] = 
{
	"TMaskEdit", 0, 0
};

CClassInfo cListControlClass[CLASS_MAX] = 
{
	"TListView", 0, 0
};

CClassInfo cDateTimePickerClass[CLASS_MAX] = 
{
	"TDateTimePicker", 0, 0,
	"TDateTime", 0, 0,
	"TdxDBTimeEdit", 0, DEF_HEIGHT,
	"TdxDateEdit", 0, DEF_HEIGHT

};
CClassInfo cGridClass[CLASS_MAX] = 
{
	"TDBGrid", 0, 0,
	"TDBCtrlGrid", 0, 0,
	"TdxDBGrid", 0, 0,
	"TDrawGrid", 0, 0,
	"TStringGrid", 0, 0
};

CClassInfo cRichEditClass[CLASS_MAX] = 
{
	"TRichEdit", 0, 0,
	"TDBRichEdit", 0, 0
};
CClassInfo cCalendarClass[CLASS_MAX] = 
{
	"TMonthCaledar", 0, 0
};

CClassInfo cPanelClass[CLASS_MAX] = 
{
	"TPanel", 0, 0
};

CClassInfo cButtonEditClass[CLASS_MAX] = 
{
	"TdxButtonEdit", 0, DEF_HEIGHT
};

CClassInfo cMenuClass[CLASS_MAX] = 
{
	"TMenu", 0, 0
};
CClassInfo cPopupMenuClass[CLASS_MAX] = 
{
	"TPopupMenu", 0, 0
};

const float fScale = 1.5;
#define SCALE(x) (int) (fScale * x)

CCtrlInfo cCtrlInfo[] = {

	CTRL_BUTTON,         SCALE(50),  SCALE(14),  0, "BUTTON",            "Button",         cButtonClass,         BS_PUSHBUTTON | WS_GROUP,                                    0,
	CTRL_TEXTBOX,        SCALE(40),  SCALE(14),  0, "EDIT",              "Edit",           cEditClass,           ES_AUTOHSCROLL | ES_LEFT,                                    WS_EX_CLIENTEDGE,
	CTRL_STATICTEXT,     SCALE(19),  SCALE(8),   0, "STATIC",            "Label",          cStaticClass,         SS_SIMPLE,                                                   0,
	CTRL_CHECKBUTTON,    SCALE(50),  SCALE(10),  0, "BUTTON",            "CheckBox",       cCheckBoxClass,       BS_CHECKBOX | BS_AUTOCHECKBOX,                               0,
	CTRL_RADIOBUTTON,    SCALE(60),  SCALE(10),  0, "BUTTON",            "RadioButton",    cRadioButtonClass,    BS_RADIOBUTTON,                                              0,
	CTRL_GROUPBOX,       SCALE(48),  SCALE(40),  0, "BUTTON",            "GroupBox",       cGroupBoxClass,       BS_GROUPBOX | WS_GROUP,                                      0,
	CTRL_HSCROLLBAR,     SCALE(40),  SCALE(11),  0, "SCROLLBAR",         "ScrollBar",      cHScrollBarClass,     SBS_HORZ,                                                    0,
	CTRL_VSCROLLBAR,     SCALE(10),  SCALE(40),  0, "SCROLLBAR",         "ScrollBar",      cVScrollBarClass,     SBS_VERT,                                                    0,
	CTRL_SLIDER,         SCALE(100), SCALE(15),  0, "msctls_trackbar32", "Slider",         cSliderClass,         0,                                                           0,
	CTRL_COMBOBOX,       SCALE(48),  SCALE(14),  0, "COMBOBOX",          "ComboBox",       cComboBoxClass,       CBS_DROPDOWN | WS_VSCROLL,                                   0,
	CTRL_LISTBOX,        SCALE(48),  SCALE(40),  0, "LISTBOX",           "ListBox",        cListBoxClass,        LBS_NOINTEGRALHEIGHT | WS_VSCROLL,                           0,
	CTRL_PICTURE,        77,  74,                0, "STATIC",            "Picture",        cPictureClass,        SS_BITMAP | SS_CENTERIMAGE,                                  0,
	CTRL_TREECONTROL,    SCALE(60),  SCALE(50),  0, "SysTreeView32",     "Tree",           cTreeControlClass,    WS_BORDER | TVS_HASBUTTONS | TVS_HASLINES | TVS_LINESATROOT, 0,
	CTRL_TABCONTROL,     SCALE(100), SCALE(50),  0, "SysTabControl32",   "Tab",            cTabControlClass,     TCS_TABS | WS_CLIPSIBLINGS,                                  0,
	CTRL_PROGRESSBAR ,   SCALE(80),  SCALE(14),  0, "msctls_progress32", "ProgressBar",    cProgressBarClass,    WS_BORDER,                                                   0,
	CTRL_SPIN,           SCALE(10),  SCALE(14),  0, "msctls_updown32",   "Spin",           cSpinClass,           UDS_ARROWKEYS,                                               0,
	CTRL_HOTKEY,         SCALE(80),  SCALE(14),  0, "msctls_hotkey32",   "HotKey",         cHotKeyClass,         WS_BORDER,                                                   0,
	CTRL_IPADDRESS,      SCALE(100), SCALE(15),  0, "SysIPAddress32",    "IPAddress",      cIPAddressClass,      0,                                                           0,
	CTRL_LISTCONTROL,    SCALE(60),  SCALE(50),  0, "SysListView32",     "ListControl",    cListControlClass,    WS_BORDER,                                                   0,
	CTRL_DATETIMEPICKER, SCALE(100), SCALE(15),  0, "SysDateTimePick32", "DateTimePicker", cDateTimePickerClass, DTS_RIGHTALIGN,                                              0,
	CTRL_GRID,           SCALE(154), SCALE(70),  0, "MFCGridCtrl",       "Grid",           cGridClass,           0,                                                           0,
	CTRL_RICHEDIT,       SCALE(40),  SCALE(14),  0, "RICHEDIT",          "RichEdit",       cRichEditClass,       ES_AUTOHSCROLL | WS_BORDER,                                  0,
	CTRL_CALENDAR,       SCALE(130), SCALE(85),  0, "SysMonthCal32",     "Calendar",       cCalendarClass,       MCS_NOTODAY,                                                 0,
	CTRL_PANEL,          SCALE(130), SCALE(85),  0, "STATIC",            "Panel",          cPanelClass,          SS_GRAYFRAME,                                                0,
	CTRL_BUTTONEDIT,     SCALE(100), SCALE(14),  0, "EDIT",              "ButtonEdit",     cButtonEditClass,     ES_AUTOHSCROLL | ES_LEFT,                                    WS_EX_CLIENTEDGE,
	CTRL_MENU,			 SCALE(20),  SCALE(20),	 0, "STATIC",            "Menu",           cMenuClass,           SS_BITMAP,                                                   0,
	CTRL_POPUPMENU,		 SCALE(20),  SCALE(20),	 0, "STATIC",            "PopupMenu",      cPopupMenuClass,      SS_BITMAP,                                                   0

};


void CTObject::StoreCurrent()
{
	CTObject pTObject = new CTObject;

	pTObject->m_bEnabled	= m_bEnabled;
	pTObject->m_bVisible	= m_bVisible;
	pTObject->m_curRect		= m_curRect;
	pTObject->m_tmpRect		= m_tmpRect;
	pTObject->m_nBorderLeft = m_nBorderLeft;
	pTObject->m_nBorderTop	= m_nBorderTop;
	pTObject->m_nClass		= m_nClass;
	pTObject->m_nCurPage	= m_nCurPage;
	pTObject->m_nID			= m_nID;
	pTObject->m_nType		= m_nType;
	pTObject->m_numRect		= m_numRect;
	pTObject->m


	m_object.InsBack(pTObject);
}

void CTObject::RestoreLast()
{

}

void CTObject::RestoreNext()
{
}