#pragma once
#include "stdafx.h"
#include "CTList.h"

#define CTRL_DIALOG         666
#define CTRL_BUTTON         0
#define CTRL_TEXTBOX        1
#define CTRL_STATICTEXT     2
#define CTRL_CHECKBUTTON    3
#define CTRL_RADIOBUTTON    4
#define CTRL_GROUPBOX       5
#define CTRL_HSCROLLBAR     6
#define CTRL_VSCROLLBAR     7
#define CTRL_SLIDER         8
#define CTRL_COMBOBOX       9
#define CTRL_LISTBOX        10
#define CTRL_PICTURE        11
#define CTRL_TREECONTROL    12
#define CTRL_TABCONTROL     13
#define CTRL_PROGRESSBAR    14
#define CTRL_SPIN           15
#define CTRL_HOTKEY         16
#define CTRL_IPADDRESS      17
#define CTRL_LISTCONTROL    18
#define CTRL_DATETIMEPICKER 19
#define CTRL_GRID           20
#define CTRL_RICHEDIT       21
#define CTRL_CALENDAR       22
#define CTRL_PANEL          23
#define CTRL_BUTTONEDIT     24
#define CTRL_MENU           25
#define CTRL_POPUPMENU      26

#define CTRL_MAX            27
#define DEF_HEIGHT          21
#define CLASS_MAX           20

struct CClassInfo
{
	char * strClass;
	int    nWidth;
	int    nHeight;
};

struct CCtrlInfo
{
	int		     nCtrlID;
	int		     nWidth;
	int		     nHeight;
	int		     nCount;
	char       * strClass;
	char	   * strCaption;
	CClassInfo * pClassType;
	DWORD        dwCtrlFalgs;
	DWORD        dwCtrlFalgsEx;

};

struct CObjectProperties
{
	int nNum;
	CString strName;

};

extern CCtrlInfo cCtrlInfo[];


class CTObject
{

public:

	CTObject()
	{
	}
	
	~CTObject()
	{

	}

	int         m_nType;
	int         m_nClass;   // index w tablicy klas

	CRect       m_curRect;  /* ramka kontrolki (wzgldna)  */
	CRect       m_oldRect;  /* poprzednia ramka kontrolki  */
	CRect       m_tmpRect;  /* tymczasowa ramka kontrolki  */
	CRect       m_numRect;  /* ramka numerka (rzeczywista) */

	CString     m_strName;
	CString     m_strCaption;
	CString     m_strInfo;
	CString     m_strGuid;

	int         m_nBorderLeft;
	int         m_nBorderTop;
	int         m_nID;

	int         m_nPage;    /* numer zakadki na ktrej ley kontrolka */ 
	int         m_nCurPage; /* wana tylko gdy kontrolka to TPageControl */
	                        /* numer aktualnie widocznej zakadki */

	CWnd      * m_pObject;
	CTObject  * m_pTParent;

	bool        m_bEnabled;
	bool		m_bVisible;

	CToolTipCtrl * m_pToolTip;
	CTList<CTObject *> m_objects;
	CTList<CObjectProperties *> m_properties; /* waciwoci obiektu np. nazwa kolumny,
											     albo pozycji w menu itp */

	CTList<CTObject *> m_object; /* wskanik na ten sam obiekt ale w poprzednim stanie.
								    Taki obiekt nie zawiera podobiektw, a jedynie kopi
									swoich waciwoci. Pole wymagane przez opcj Undo */

	void StoreCurrent();
	void RestoreLast();
	void RestoreNext();


};