// MToolBar.cpp : implementation file
//

#include "stdafx.h"
#include "FormCreator.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include "ToolBarControls.h"
#include "Globals.h"
#include "TObject.h"
#include <iostream>

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CControlsToolBar::CControlsToolBar()
{
	m_lpButton = NULL;
	m_iLastPressedButton = -1;
	m_bLButton = false;
}

CControlsToolBar::~CControlsToolBar()
{
	delete m_lpButton;
}


BEGIN_MESSAGE_MAP(CControlsToolBar, CToolBar)
	//{{AFX_MSG_MAP(CControlsToolBar)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlsToolBar message handlers

void CControlsToolBar::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CToolBarCtrl & pToolBarCtrl = GetToolBarCtrl();

	m_iLastPressedButton = pToolBarCtrl.HitTest(&point);

	if (m_lpButton)
		pToolBarCtrl.CheckButton(m_lpButton->idCommand, false);
	else
		m_lpButton = new _TBBUTTON;

	pToolBarCtrl.GetButton(m_iLastPressedButton, m_lpButton);
	pToolBarCtrl.CheckButton(m_lpButton->idCommand, true);


	g_lpButton = m_lpButton;

	CFormCreatorView * pView = (CFormCreatorView *) GetParentFrame()->GetActiveView();
	if (m_lpButton->iBitmap > 0 && m_lpButton->iBitmap < CTRL_MAX)
	{
		pView->m_nObjType = cCtrlInfo[m_lpButton->iBitmap].nCtrlID;
		pView->m_bInsert = true;
	}

	CToolBar::OnLButtonDown(nFlags, point);
}


void CControlsToolBar::OnLButtonUp(UINT nFlags, CPoint point) 
{

	CRect rect;
	g_pToolBarCtrlCon->GetWindowRect(&rect);
	ScreenToClient(&rect);
	
	if (rect.PtInRect(point) == FALSE)
	{
		g_pToolBarCtrlCon->CheckButton(m_lpButton->idCommand, false);
		CFormCreatorView * pView = (CFormCreatorView *) GetParentFrame()->GetActiveView();
		pView->m_bInsert = false;
	}

	CToolBar::OnLButtonUp(nFlags, point);
}

void CControlsToolBar::OnMouseMove(UINT nFlags, CPoint point) 
{
	CFormCreatorView * pView = (CFormCreatorView *) GetParentFrame()->GetActiveView();
	
	if (nFlags & MK_LBUTTON)
	{

		CRect rect;
		CToolBarCtrl & pToolBarCtrl = GetToolBarCtrl();
		pToolBarCtrl.GetWindowRect(&rect);
		ScreenToClient(&rect);

		if (rect.PtInRect(point) == FALSE)
		{
		
			pView->EraseDlgDragRect();
			pView->m_pTracker->UpdateSelObjectsBkg(pView->m_pDlg, true);
			pView->DrawNumbers();

			int nButton = m_iLastPressedButton;

			int nHeight = cCtrlInfo[nButton].nHeight;
			int nWidth  = cCtrlInfo[nButton].nWidth;
			int nType   = cCtrlInfo[nButton].nCtrlID;

			CRect ctlRect(0, 0, nWidth, nHeight);

			pView->m_pTracker->RemoveAllObjects();
			pView->AddObject(pView->m_pTDlg, nType, ctlRect, true, false, true);

			pView->m_pTracker->m_bDlgSelected = false;
			CRect clpRect;
			pView->m_pDlg->GetClientRect(&clpRect);
			pView->m_pTracker->SetClipRect(clpRect);
			pView->m_pTracker->Track(pView->m_pDlg, CPoint(nWidth / 2, nHeight / 2), hitMiddle);
			pView->m_nObjType = nType;

			CTObject * pTObject = pView->FindObject(&pView->m_objects, 
				                                     CPoint(pView->m_pTracker->m_nMousePosX,
											                pView->m_pTracker->m_nMousePosY),
											         false);

			CRect objRect;

			if (pTObject == NULL)
			{
				pTObject = pView->m_pTDlg;
				objRect  = pView->m_pTracker->m_curRect;
			}
			else
			{
				if (pTObject->m_nType != CTRL_PANEL    && 
					pTObject->m_nType != CTRL_GROUPBOX &&
					pTObject->m_nType != CTRL_TABCONTROL)
				{
					pTObject = pTObject->m_pTParent;
					objRect  = pView->m_pTracker->m_curRect;
				}
	
				if (pTObject->m_nType == CTRL_TABCONTROL && 
					cCtrlInfo[pTObject->m_nType].pClassType[pTObject->m_nClass].strClass == "TTabControl")
				{			
					pTObject = pTObject->m_pTParent;
					objRect  = pView->m_pTracker->m_curRect;
				}

			}

			objRect = pView->GetObjectRect(pTObject, pView->m_pTracker->m_curRect);

			CWnd * curObject = pView->AddObject(pTObject, nType, objRect, false, true, false);

			curObject->ShowWindow(SW_SHOW);

			pView->m_nObjSelected = 1;
			pView->m_pTracker->m_bDlgSelected = false;
			pView->m_bDlgSelected = false;

			pView->m_pTObject->m_curRect = objRect;

			if (m_lpButton)
				pToolBarCtrl.CheckButton(m_lpButton->idCommand, false);
			
			pView->UpdateObjectNameInfo();
			pView->UpdateObjectClassInfo();
			pView->UpdateObjectCaptionInfo();

			pView->DrawTrackerRect();

			pView->AddToInfObjList(pView->m_pTObject);
			pView->AddToObjList(pView->m_pTObject);

			pView->m_pLstTObject = pView->m_pTObject;
			pView->m_bInsert = false;
	
		}
	
	} 
			
	
	CToolBar::OnMouseMove(nFlags, point);
}
