#include "stdafx.h"
#include "FormCreator.h"
#include "Globals.h"

#include "GridCtrl/GridCtrl.h"
#include "Console.h"
#include "FormCreatorDoc.h"
#include "FormCreatorView.h"
#include "MultiRectTracker.h"
#include "ToolbarControls.h"

#include "DialogGrid.h"
#include "DialogTemplate.h"
#include "DialogPanelControl.h"
#include "ColumnsDialog.h"

#include "TObject.h"

#include "PanelControl.h"

#include "TransparentWindow.h"
#include "math.h"
#include "Guid.h"
#include <afxrich.h>

#include <iostream>
using namespace std;

/*-------------------------------------------------------------------------------------------*\
                                       TOOLBAR LAYOUT
\*-------------------------------------------------------------------------------------------*/

void CFormCreatorView::OnTbTestmode() 
{
	TestDialog(true);
}

void CFormCreatorView::OnTbSgrid() 
{
	m_bShowGrid = !m_bShowGrid;

	bool bShowGrid = m_bShowGrid;

	g_pToolBarCtrlLay->GetButton(1, g_pToolBarLay->m_lpButton);
	g_pToolBarCtrlLay->CheckButton(g_pToolBarLay->m_lpButton->idCommand, m_bShowGrid);


	m_pDlg->Invalidate(TRUE);
	m_pDlg->UpdateWindow();
/*	CRect clnRect;
	m_pDlg->GetClientRect(&clnRect);

	if (!m_bShowGrid)
		DrawGrid(clnRect, ::GetSysColor(COLOR_3DFACE));
	else
		DrawGrid(clnRect);*/
	
	DrawTrackerRect();
}

void CFormCreatorView::OnTbSnap() 
{
	m_bSnapToGrid = !m_bSnapToGrid;

//	bool bShowGrid = m_bShowGrid;
	if (m_bSnapToGrid)
		m_pTracker->SetGrid(m_nGridX, m_nGridY);
	else	
		m_pTracker->SetGrid(1, 1);

	g_pToolBarCtrlLay->GetButton(2, g_pToolBarLay->m_lpButton);
	g_pToolBarCtrlLay->CheckButton(g_pToolBarLay->m_lpButton->idCommand, m_bSnapToGrid);
	
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::MoveSelObjects
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Przeswa zaznaczone obiekty
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::MoveSelObjects()
{
	CTList<CTObject *>::iterator it = m_pTracker->m_selObjects.begin();
	
	CRect oldRect;

	CWnd * pParent = m_pTracker->m_selObjects.begin()->m_pTParent->m_pObject;

	while (it != m_pTracker->m_selObjects.last())
	{
		it->m_pObject->MoveWindow(it->m_curRect, false);

		pParent->InvalidateRect(it->m_oldRect, true);
		pParent->InvalidateRect(it->m_curRect, false);
		m_pDlg->InvalidateRect(it->m_numRect, true);

		m_pTracker->InvalidateNumRects(&it->m_objects);


		++it;
	}

	m_pDlg->UpdateWindow();
	pParent->UpdateWindow();

/*	it = m_pTracker->m_selObjects.begin();
	while (it != m_pTracker->m_selObjects.last())
	{
		CRect rect(GetObjectRealRect(*it, it->m_oldRect));
		DrawGrid(m_pTracker->CalcDragRect(rect));
		++it;
	}*/

	DrawTrackerRect();
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbAlgnobjleft
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrwnanie zaznaczonych obiektw do lewej
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbAlgnobjleft() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();

	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);

	while (it != lit)
	{
		int dx = lit->m_curRect.left - it->m_curRect.left;
		
		if (it->m_curRect.right + dx > clpRect.right) 
			dx = clpRect.right - it->m_curRect.right;

		it->m_curRect.left  += dx;
		it->m_curRect.right += dx;
		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbAlgnobjright
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrwnanie zaznaczonych obiektw do prawej
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbAlgnobjright() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();

	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);

	while (it != lit)
	{
		int dx = lit->m_curRect.right - it->m_curRect.right;
		
		if (it->m_curRect.left + dx < clpRect.left) 
			dx = clpRect.left - it->m_curRect.left;

		it->m_curRect.left  += dx;
		it->m_curRect.right += dx;
		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbAlgnobjtop
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrwnanie zaznaczonych obiektw do gry
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbAlgnobjtop() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();

	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);

	while (it != lit)
	{
		int dy = lit->m_curRect.top - it->m_curRect.top;
		
		if (it->m_curRect.bottom + dy > clpRect.bottom) 
			dy = clpRect.bottom - it->m_curRect.bottom;

		it->m_curRect.top    += dy;
		it->m_curRect.bottom += dy;
		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbAlgnobjbottom
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrwnanie zaznaczonych obiektw do dou
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbAlgnobjbottom() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();

	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);

	while (it != lit)
	{
		int dy = lit->m_curRect.bottom - it->m_curRect.bottom;
		
		if (it->m_curRect.top + dy < clpRect.top) 
			dy = clpRect.top - it->m_curRect.top;

		it->m_curRect.top    += dy;
		it->m_curRect.bottom += dy;
		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbCenterv
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrnanie obiektw w pionie
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbCenterv() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();

	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);

	int cdx = (lit->m_curRect.left + lit->m_curRect.right) / 2;

	while (it != lit)
	{
		int dx = cdx - (it->m_curRect.left + it->m_curRect.right) / 2;
		
		if (it->m_curRect.left + dx < clpRect.left) 
			dx = clpRect.left - it->m_curRect.left;
		if (it->m_curRect.right + dx > clpRect.right)
			dx = clpRect.right - it->m_curRect.right;

		it->m_curRect.left  += dx;
		it->m_curRect.right += dx;
		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbCenterh
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrwnanie obiektw w poziomie
	Wyjscie    :  void	-	
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbCenterh() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();

	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);

	int cdy = (lit->m_curRect.top + lit->m_curRect.bottom) / 2;

	while (it != lit)
	{
		int dy = cdy - (it->m_curRect.top + it->m_curRect.bottom) / 2;
		
		if (it->m_curRect.top + dy < clpRect.top) 
			dy = clpRect.top - it->m_curRect.top;
		if (it->m_curRect.bottom + dy > clpRect.bottom)
			dy = clpRect.bottom - it->m_curRect.bottom;

		it->m_curRect.top    += dy;
		it->m_curRect.bottom += dy;
		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbSamesizev
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrwnanie rozmiarw obiektw w pionie
	Wyjscie    :  void	-	
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbSamesizev() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();


	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);


	while (it != lit)
	{
		int nHeight = (lit->m_curRect.Height() - it->m_curRect.Height()) / 2;

		int dy0 = nHeight;
		int dy1 = nHeight;

		int minTop    = ABS(clpRect.top    - it->m_curRect.top);
		int minBottom = ABS(clpRect.bottom - it->m_curRect.bottom);

		if (it->m_curRect.bottom + dy1 > clpRect.bottom)
		{
			dy1 = minBottom;
			dy0 += nHeight - minBottom;
		}
		
		if (it->m_curRect.top - dy0 < clpRect.top)
		{
			dy0 = minTop;
			dy1 += nHeight - minTop;
		}

		if (it->m_curRect.bottom + dy1 > clpRect.bottom)
			dy1 = minBottom;

		if (it->m_nType != CTRL_COMBOBOX)
		{
			it->m_curRect.top    -= dy0;
			it->m_curRect.bottom += dy1;
		}

		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}
/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbSamesizeh
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrwnanie rozmiarw obiektw w poziomie
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbSamesizeh() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();


	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);


	while (it != lit)
	{
		int nWidth = (lit->m_curRect.Width() - it->m_curRect.Width()) / 2;

		int dx0 = nWidth;
		int dx1 = nWidth;

		int minLeft  = ABS(clpRect.left  - it->m_curRect.left);
		int minRight = ABS(clpRect.right - it->m_curRect.right);

		if (it->m_curRect.right + dx1 > clpRect.right)
		{
			dx1 = minRight;
			dx0 += nWidth - minRight;

		}
		
		if (it->m_curRect.left - dx0 < clpRect.left)
		{
			dx0 = minLeft;
			dx1 += nWidth - minLeft;
		}

		if (it->m_curRect.right + dx1 > clpRect.right)
			dx1 = minRight;

		it->m_curRect.left  -= dx0;
		it->m_curRect.right += dx1;

		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbSamesizevh
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Wyrwnanie rozmiarw obiektw w pionie i w poziomie
	Wyjscie    :  void	-	
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbSamesizevh() 
{
	if (m_pTracker->m_selObjects.Count() < 2)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej dwa obiekty.");
		return;
	}

	objIterator it = m_pTracker->m_selObjects.begin();
	objIterator lit = m_pTracker->m_selObjects.last();


	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	CRect clpRect;
	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);


	while (it != lit)
	{
		int nWidth = (lit->m_curRect.Width() - it->m_curRect.Width()) / 2;
		int nHeight = (lit->m_curRect.Height() - it->m_curRect.Height()) / 2;

		int dx0 = nWidth;
		int dx1 = nWidth;
		int dy0 = nHeight;
		int dy1 = nHeight;

		int minLeft   = ABS(clpRect.left   - it->m_curRect.left);
		int minRight  = ABS(clpRect.right  - it->m_curRect.right);
		int minTop    = ABS(clpRect.top    - it->m_curRect.top);
		int minBottom = ABS(clpRect.bottom - it->m_curRect.bottom);

		if (it->m_curRect.right + dx1 > clpRect.right)
		{
			dx1 = minRight;
			dx0 += nWidth - minRight;

		}
		
		if (it->m_curRect.left - dx0 < clpRect.left)
		{
			dx0 = minLeft;
			dx1 += nWidth - minLeft;
		}

		if (it->m_curRect.right + dx1 > clpRect.right)
			dx1 = minRight;

		if (it->m_curRect.bottom + dy1 > clpRect.bottom)
		{
			dy1 = minBottom;
			dy0 += nHeight - minBottom;

		}
		
		if (it->m_curRect.top - dy0 < clpRect.top)
		{
			dy0 = minTop;
			dy1 += nHeight - minTop;
		}

		if (it->m_curRect.bottom + dy1 > clpRect.bottom)
			dy1 = minBottom;


		it->m_curRect.left   -= dx0;
		it->m_curRect.right  += dx1;

		if (it->m_nType != CTRL_COMBOBOX)
		{
			it->m_curRect.top    -= dy0;
			it->m_curRect.bottom += dy1;
		}

		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}


/*----------------------------------------------------------------------*\
	Funkcja    :  CmpFnHeight
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Sprawdza czy rodek obiektu obj0 w pionie ley
	              poniej lub powyej rodka obiektu obj1
	Wyjscie    :  bool	-	true - jeli powyej
	Parametry  :
			      CTObject * obj0	-	pierwszy obiekt
			      CTObject * obj1	-	drugi obiekt
	Note       :
\*----------------------------------------------------------------------*/
bool CmpFnHeight(CTObject * obj0, CTObject * obj1)
{
	int dy0 = (obj0->m_curRect.top + obj0->m_curRect.bottom) / 2;
	int dy1 = (obj1->m_curRect.top + obj1->m_curRect.bottom) / 2;

	if (dy0 < dy1)
		return true;
	else
		return false;
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbSpacev
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Rozkada obiekty rwnomiernie w pionie
	Wyjscie    :  void	-	
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbSpacev() 
{
	CTList<CTObject *> * objList = &m_pTracker->m_selObjects;

	if (objList->Count() < 3)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej trzy obiekty.");
		return;
	}

	CRect clpRect;

	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	objList->CmpFn = &CmpFnHeight;
	objList->Sort();

	int minY = (objList->begin()->m_curRect.top + 
		        objList->begin()->m_curRect.bottom) / 2; 
	int maxY = (objList->last()->m_curRect.top + 
		        objList->last()->m_curRect.bottom) / 2; 

	int nHeight = ABS(maxY - minY);
	int nObj    = objList->Count() - 1;


	float cdy = (float) nHeight / (float) nObj;
	float sdy = (float) minY;


	objIterator it  = objList->begin()++;
	objIterator lit = objList->last();

	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);

	while (it != lit)
	{
		sdy += cdy;

		int dy = (int) sdy - (it->m_curRect.top + it->m_curRect.bottom) / 2 ;
		
		if (it->m_curRect.top    + dy < clpRect.top) 	dy = clpRect.top    - it->m_curRect.top;
		if (it->m_curRect.bottom + dy > clpRect.bottom) dy = clpRect.bottom - it->m_curRect.bottom;

		it->m_curRect.top    += dy;
		it->m_curRect.bottom += dy;

		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CmpFnWidth
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Sprawdza czy rodek obiektu obj0 w poziomie ley
	              przed lub za rodkiem obiektu obj1
	Wyjscie    :  bool	-	true - jeli przed
	Parametry  :
			      CTObject * obj0	-	pierwszy obiekt
			      CTObject * obj1	-	drugi obiekt
	Note       :
\*----------------------------------------------------------------------*/
bool CmpFnWidth(CTObject * obj0, CTObject * obj1)
{
	int dx0 = (obj0->m_curRect.left + obj0->m_curRect.right) / 2;
	int dx1 = (obj1->m_curRect.left + obj1->m_curRect.right) / 2;

	if (dx0 < dx1)
		return true;
	else
		return false;
}

/*----------------------------------------------------------------------*\
	Funkcja    :  CFormCreatorView::OnTbSpaceh
	Wersja     :  1.0
  ----------------------------------------------------------------------
	Opis       :  Rozkada obiekty rwnomiernie w poziomie
	Wyjscie    :  void
	Parametry  :
	Note       :
\*----------------------------------------------------------------------*/
void CFormCreatorView::OnTbSpaceh() 
{

	CTList<CTObject *> * objList = &m_pTracker->m_selObjects;
	
	if (objList->Count() < 3)
	{
		AfxMessageBox("Musisz zaznaczy conajmniej trzy obiekty.");
		return;
	}

	CRect clpRect;

	m_pTracker->StoreObjectsPrevPos();
	m_pTracker->UpdateSelObjectsBkg(m_pDlg, UPD_CURPOS);

	objList->CmpFn = &CmpFnWidth;
	objList->Sort();

	int minX = (objList->begin()->m_curRect.left + 
		        objList->begin()->m_curRect.right) / 2; 
	int maxX = (objList->last()->m_curRect.left + 
		        objList->last()->m_curRect.right) / 2; 

	int nWidth = ABS(maxX - minX);
	int nObj   = objList->Count() - 1;


	float cdx = (float) nWidth / (float) nObj;
	float sdx = (float) minX;


	objIterator it  = objList->begin()++;
	objIterator lit = objList->last();

	(*it)->m_pTParent->m_pObject->GetClientRect(&clpRect);

	while (it != lit)
	{
		sdx += cdx;

		int dx = (int) sdx - (it->m_curRect.left + it->m_curRect.right) / 2 ;
		
		if (it->m_curRect.left  + dx < clpRect.left) 	dx = clpRect.left  - it->m_curRect.left;
		if (it->m_curRect.right + dx > clpRect.right)   dx = clpRect.right - it->m_curRect.right;

		it->m_curRect.left  += dx;
		it->m_curRect.right += dx;

		++it;
	}

	MoveSelObjects();
	m_pTracker->RecalculateSelctionRect();
	
}

